# (C) http://spcms.ru
use strict;

use vars qw / $state_date $gteacher_show_all $stat_inbox_new %ACL /;

sub generate_menu() {

    return '' if ( param('popup') );

    my $sp  = $gconf{'sp'};
    my $cms = $gconf{'cms'};
    my $msg = $gconf{'msg'};

    my $owner = $ACL{'6'} ? 6 : $guid;

    my $site = $gconf{'chpu'} ? "/ow/$owner" : "$cms?ow=$owner";

    my $msg_text =
        "<span id='menu_count_n' title=' '>"
      . ( $stat_inbox_new > 0 ? "<b> ($stat_inbox_new)</b>" : "" )
      . "</span>";

    my $add_administration = ( $ACL{'6'} and not $gconf{'light'} )
      ? qq[
{ text: " ", url: "$cms?mod=administration&edt=lst", id:"spm_adm" },
{ text: "", url: "$sp?act=medallist_editor" },
]
      : '';

    my $menu =
'<noscript>       JavaScript,        .      JavaScript    ,       .<br></noscript>
<div class=menu>';

    my $menu_item_users = "$sp?act=registered";
    if ( $ggid == 2 ) { $menu_item_users = "$sp?act=gen_list_form"; }
    if ( $ggid == 4 ) { $menu_item_users = "$sp?act=name_rating"; }

    my ( $pupil_comment_out_start, $pupil_comment_out_end ) = ( '', '' );
    if ( $ggid == 4 ) {
        ( $pupil_comment_out_start, $pupil_comment_out_end ) = ( '/*', '*/' );
    }

    my $menu_item_journal = "$sp?act=score_form_select_class";
    if ( $ggid == 4 ) { $menu_item_journal = "$sp?act=score_all_subjects"; }

    my ( $teacher_binding_text, $teacher_binding_id, $add_teacher_settings );

    if ( $ggid == 2 ) {
        if ($gteacher_show_all) {
            $teacher_binding_text = '  ';
            $teacher_binding_id   = 0;
        }
        else {
            $teacher_binding_text = '  ';
            $teacher_binding_id   = 1;
        }

        $add_teacher_settings = qq~
	{ text: "$teacher_binding_text", url: "$sp?act=teacher_switch_binding&id=$teacher_binding_id" },
	{ text: " ", url: "$sp?act=teacher_list_bindings" }
],
[
~;
    }
    else {
        $add_teacher_settings = '';
    }

    my $test_url = ( $ggid == 4 ) ? "$sp?act=test" : "$sp?act=maketest";

    $menu .= qq~
<div class="yui-skin-sam">
<div id="sp_main_menu" class="yuimenubar yuimenubarnav">
<div class="bd">
<ul class="first-of-type">
		<li class="yuimenubaritem first-of-type"><a class="yuimenubaritemlabel" href="$menu_item_users"><span class="i spmi_usr"></span></a></li>
		<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$menu_item_journal"><span class="i spmi_jrl"></span></a></li>
~;

    if ( $ggid != 4 ) {
        $menu .=
qq~<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$sp?act=report_form"><span class="i spmi_rep"></span></a></li>~;
    }

    $menu .= qq~
		<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$test_url"><span class="i spmi_tst"></span></a></li>
		<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$site" target=_blank><span class="i spmi_sit"></span></a></li>
		<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$msg"><span class="i spmi_msg">$msg_text</span></a></li>
~;

    if ( $ggid != 4 ) {
        $menu .=
qq~<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$sp?act=state_date_form"><span class="i spmi_opt"></span></a></li>~;
        $menu .=
qq~<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$sp?act=state_date_form"><span class="i spmi_srv"></span></a></li>~;
    }

    $menu .= qq~
		<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$sp?act=logout"><span class="i spmi_exi"></span></a></li>
	</ul>
</div></div></div>
~;

    my $lazyload =
      ( $ENV{'HTTP_USER_AGENT'} and $ENV{'HTTP_USER_AGENT'} =~ /MSIE/i )
      ? 'true'
      : 'false';

    if ( $gconf{'light'} ) {
        $menu = qq~
<div class="yui-skin-sam">
<div id="sp_main_menu" class="yuimenubar yuimenubarnav">
<div class="bd">
<ul class="first-of-type">
	<li class="yuimenubaritem first-of-type"><a class="yuimenubaritemlabel" href="$menu_item_users"><span class="i spmi_usr"></span></a></li>
	<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$site" target=_blank><span class="i spmi_sit"></span></a></li>
	<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$msg"><span class="i spmi_msg">$msg_text</span></a></li>
	<li class="yuimenubaritem"><a class="yuimenubaritemlabel" href="$sp?act=logout"><span class="i spmi_exi"></span></a></li>
</ul>
</div></div></div>

<script type="text/javascript">
<!--
	var oMenuBar = new YAHOO.widget.MenuBar("sp_main_menu", { autosubmenudisplay: true, showdelay: 150, hidedelay: 700, lazyload: $lazyload } );

  var aSubmenuData = [

  {
    /*  */
    id: "sp_main_menu_1", itemdata:
    [
      [  { text: " ", url: "$sp?act=logged", id:"spm_usr_act" },
         { text: "", url: "$sp?act=registered", id:"spm_reg" },
      ],
      [ { text: " ", url: "$sp?act=logs", id:"spm_logs",
                 submenu: { id: "sp_main_menu_13", itemdata: [
              [ { text: " ", url: "$sp?act=logs", id:"spm_empty" }, ],
              [  { text: "", url: "$sp?act=logs&g=1", id:"spm_empty1" }
                ,{ text: "", url: "$sp?act=logs&g=2", id:"spm_empty2" } ]
            ]}
        },
      ],
      [ { text: "  &hellip;", url: "$sp?act=change_password", id: "spm_key" } ]
    ]
  },
  /*  */
  {
    id: "sp_main_menu_5", itemdata: [
      [
        [ { text: "", url: "$cms?mod=news&edt=lst", id: "spm_news",
                   submenu: { id: "sp_main_menu_51", itemdata: [
              { text: "&hellip;", url: "$cms?mod=news&edt=an", id: "spm_news_add" },
              { text: " ", url: "$cms?mod=news&edt=lst", id:"spm_pages1" },
            ]}
          },
          { text: "", url: "$cms?mod=content&edt=lst", id: "spm_articles",
                   submenu: { id: "sp_main_menu_52", itemdata: [
              { text: " &hellip;", url: "$cms?mod=content&edt=ac", id:"spm_page_add" },
              { text: " &hellip;", url: "$cms?mod=content&edt=as", id:"spm_folder_new" },
              { text: " ", url: "$cms?mod=content&edt=lst", id:"spm_pages2" },
            ]}
          },
          { text: "", url: "$cms?mod=mainmenu&edt=lst", id: "spm_menu" },
          $add_administration
          { text: " ", url: "$cms?mod=customblock&edt=edit", id: "spm_custom" },
          { text: " ", url: "$cms?mod=analytics&edt=code" },
        ],
        [
          { text: "", url: "$cms?mod=modules&edt=lst", id: "spm_components" },
          { text: " ", url: "$cms?mod=themes&edt=lst", id: "spm_themes",
                   submenu: { id: "sp_main_menu_53", itemdata: [
              { text: "&hellip;", url: "$cms?mod=themes&edt=upl", id:"spm_add1" },
              { text: " ", url: "$cms?mod=themes&edt=lst", id:"spm_pages3" },
            ]}
          },
        ],
        [ { text: "    &hellip;", url: "$site", target: "_blank", id: "spm_site_new" }, ]
      ],
    ]
  },
  /*    */
  {
    id: "sp_main_menu_6", itemdata: [
      [
        [ { text: "", url: "$msg?act=inbox", id:"spm_mail",
                   submenu: { id: "sp_main_menu_61", itemdata: [
              [ { text: "&hellip;", url: "$msg?act=new_msg", id:"spm_add3" },
              ],
              [ { text: "", url: "$msg?act=inbox", id:"spm_mail_in" },
                { text: "", url: "$msg?act=sent", id:"spm_mail_out" },
              ],
              [ { text: "", url: "$msg?act=recycler", id:"spm_trash" },
              ],
            ]}
          },
          { text: "", url: "$msg?act=announcement&sact=active", id:"spm_ann",
                   submenu: { id: "sp_main_menu_62", itemdata: [
              [ { text: "", url: "$msg?act=announcement&sact=active" },
                { text: "", url: "$msg?act=announcement", id:"spm_ann_arc" },
              ],
              [ { text: "&hellip;", url: "$msg?act=new_pub", id:"spm_add4" },
              ],
            ]}
          },
        ],
~;

        if ( isadmin() ) {
            $menu .=
qq~[ { text: "", url: "$msg?act=msg_stat", id: "spm_msg_stat" } ],~;
            $menu .=
qq~[ { text: "",  url: "$msg?act=set", id: "spm_msg_set" } ]~;
        }
        $menu .= qq~
      ],
    ]
  },

  ];

  oMenuBar.subscribe ( "beforeRender",
    function ()
    {
      if (this.getRoot() == this)
      {
        this.getItem(0).cfg.setProperty("submenu", aSubmenuData[0]);
        this.getItem(1).cfg.setProperty("submenu", aSubmenuData[1]);
 				this.getItem(2).cfg.setProperty("submenu", aSubmenuData[2]);
      }
    }
  );

	oMenuBar.render();

-->
</script>
~;
        return $menu;
    }

    $menu .= qq~<script type="text/javascript">
<!--
	var oMenuBar = new YAHOO.widget.MenuBar("sp_main_menu",
		{
			autosubmenudisplay: true,
			showdelay: 150, hidedelay: 700,
			lazyload: $lazyload
		}
	);

  /*    */
  var aSubmenuData = [
  {
    /*  */
    id: "sp_main_menu_1", itemdata:
    [
~;

    if ( isadmin() ) {
        $menu .= qq~
      [
         { text: " ", url: "$sp?act=logged", id:"spm_usr_act" },
         { text: "", url: "$sp?act=registered", id:"spm_reg" },
      ],
      [
        { text: "", url: "$sp?act=all_pupils", id: "spm_pupil",
                 submenu: { id: "sp_main_menu_11", itemdata: [
            [ { text: "  ", url: "$sp?act=all_pupils", id:"spm_pages5" },
              { text: " ", url: "$sp?act=name_rating", id: "spm_rating" },
            ],
			[	{ text: "  &hellip;", url: "$sp?act=reg1", id:"spm_add5" },
				{ text: "  CSV-&hellip;", url: "$sp?act=pupil_import_csv" },
            ],
			[ { text: "    &hellip;", url: "$sp?act=change_and_print_class_passwords", id: "spm_key1" },
			]
          ]}
        },
        { text: "", url: "$sp?act=users_teachers",
                 submenu: { id: "sp_main_menu_12", itemdata: [
            [ { text: " ", url: "$sp?act=users_teachers", id:"spm_pages6" },
            ],
            [ { text: " ", url: "$sp?act=teacher_placement" },
              { text: " ", url: "$sp?act=teacher_form_master" },
            ],
            [ { text: "  &hellip;", url: "$sp?act=register_teacher_form", id:"spm_add6" },
			  { text: "  CSV-&hellip;", url: "$sp?act=teacher_import_csv" },
              { text: "   ", url: "$sp?act=register_sp_teachers", id: "spm_wand2" },
              { text: " &hellip;", url: "$sp?act=change_teachers_passwords", id: "spm_key2" },
            ]
          ]}
        },
      ],
      [
        { text: " ", url: "$sp?act=logs", id:"spm_logs",
                 submenu: { id: "sp_main_menu_13", itemdata: [
              [ { text: " ", url: "$sp?act=logs", id:"spm_empty" },
              ],
              [  { text: "", url: "$sp?act=logs&g=1", id:"spm_empty1" }
                ,{ text: "", url: "$sp?act=logs&g=2", id:"spm_empty2" }
                ,{ text: "", url: "$sp?act=logs&g=4", id:"spm_empty3" }
              ]
            ]}
        },
      ],
	~;
    }

    if ( ( $ggid == 2 or $ggid == 4 ) and !$ACL{'1'} ) {
        $menu .= qq~[ { text: " ", url: "$sp?act=name_rating" } ],~;
    }

    if ( $ggid == 4 ) {
        $menu .=
qq~[ { text: "SMS &hellip;", url: "$sp?act=sms_setup_recipient", id: "spm_sms" } ],~;
    }

    $menu .= qq~
      [ { text: "  &hellip;", url: "$sp?act=change_password", id: "spm_key" } ]
    ]
  },

  /*  */
  {
    id: "sp_main_menu_2", itemdata: [
	~;

    if ( $ggid == 4 ) {
        $menu .= qq~
      { text: " ", url: "$sp?act=score_all_subjects", id:"spm_score" },
      { text: "  ", url: "$sp?act=score_list_pupil_totals", id:"spm_score2" },
      { text: " ", url: "$sp?act=main_pupil", id:"spm_total" },
      { text: "  ", url: "$sp?act=score_top", id:"spm_star" },~;
    }
    else {
        $menu .= qq~
      { text: " &hellip;", url: "$sp?act=score_form_select_class", id:"spm_score" },
      { text: " &hellip;", url: "$sp?act=score_form_select_class&goto=totals", id:"spm_total" },
      { text: "  ", url: "$sp?act=score_form_select_class&goto=score_top", id:"spm_star" },~;
    }

    $menu .= qq~
    ]
  },

  /*  */
	$pupil_comment_out_start
  {
    id: "sp_main_menu_3", itemdata: [
      [
        { text: "", url: "$sp?act=report_form",
				submenu: { id: "sp_main_menu_31", itemdata: [
              [ { text: "&hellip;", url: "$sp?act=report_form", id:"spm_pupil3" },
                { text: "&hellip;", url: "$sp?act=report_form_parallel", id:"spm_parallel" },
                { text: "&hellip;", url: "$sp?act=report_form_links", id:"spm_steps2" },
              ],
              [ { text: "&hellip;", url: "$sp?act=report_form_school" },
              ]
            ]}
        },
      ],
      [
        { text: " ( )&hellip;", url: "$sp?act=score_all_subjects_class_form", id: "spm_score2" },
        { text: " ( )&hellip;", url: "$sp?act=report_form_totals", id: "spm_total2" },
      ],
      [ { text: " &hellip;", url: "$sp?act=gen_list_form", id: "spm_pupil1" },
      ],
      [ { text: " -&hellip;", url: "$sp?act=report_form_teacher" },
        { text: "   &hellip;", url: "$sp?act=report_form_progress_movement" },
      	{ text: "  &hellip;", url: "$sp?act=report_knowledge_area_form" },
      ],
    ]
  },
	$pupil_comment_out_end
~;

    if ( $ggid != 4 ) {
        $menu .= qq~
  /*  */
	$pupil_comment_out_start
  {
	  id: "sp_main_menu_4", itemdata: [
	    [ { text: "", url: "$sp?act=test", id:"spm_test_run" }, ],
			[ { text: "", url: "$sp?act=test_report&sact=report_list", id: "spm_test_report" }, ],
			[ { text: "", url: "$sp?act=maketest", id: "spm_constructor" },
				{ text: "&hellip;", url: "$sp?act=maketest&sact=maketest_dsmk", id: "spm_wand" },
	  	]
    ]
  },
	$pupil_comment_out_end
~;
    }

    $menu .= qq~

  /*  */
  {
    id: "sp_main_menu_5", itemdata: [
      [
        [ { text: "", url: "$cms?mod=news&edt=lst", id: "spm_news",
                   submenu: { id: "sp_main_menu_51", itemdata: [
              { text: "&hellip;", url: "$cms?mod=news&edt=an", id: "spm_news_add" },
              { text: " ", url: "$cms?mod=news&edt=lst", id:"spm_pages1" },
            ]}
          },
          { text: "", url: "$cms?mod=content&edt=lst", id: "spm_articles",
                   submenu: { id: "sp_main_menu_52", itemdata: [
              { text: " &hellip;", url: "$cms?mod=content&edt=ac", id:"spm_page_add" },
              { text: " &hellip;", url: "$cms?mod=content&edt=as", id:"spm_folder_new" },
              { text: " ", url: "$cms?mod=content&edt=lst", id:"spm_pages2" },
            ]}
          },
          { text: "", url: "$cms?mod=mainmenu&edt=lst", id: "spm_menu" },
          $add_administration
          { text: " ", url: "$cms?mod=customblock&edt=edit", id: "spm_custom" },
          { text: " ", url: "$cms?mod=analytics&edt=code" },
        ],
        [
          { text: "", url: "$cms?mod=modules&edt=lst", id: "spm_components" },
          { text: " ", url: "$cms?mod=themes&edt=lst", id: "spm_themes",
                   submenu: { id: "sp_main_menu_53", itemdata: [
              { text: "&hellip;", url: "$cms?mod=themes&edt=upl", id:"spm_add1" },
              { text: " ", url: "$cms?mod=themes&edt=lst", id:"spm_pages3" },
            ]}
          },
        ],
        [ { text: "    &hellip;", url: "$site", target: "_blank", id: "spm_site_new" }, ]
      ],
    ]
  },

  /*    */
  {
    id: "sp_main_menu_6", itemdata: [
      [
        [ { text: "", url: "$msg?act=inbox", id:"spm_mail",
                   submenu: { id: "sp_main_menu_61", itemdata: [
              [ { text: "&hellip;", url: "$msg?act=new_msg", id:"spm_add3" },
              ],
              [ { text: "", url: "$msg?act=inbox", id:"spm_mail_in" },
                { text: "", url: "$msg?act=sent", id:"spm_mail_out" },
              ],
              [ { text: "", url: "$msg?act=recycler", id:"spm_trash" },
              ],
            ]}
          },
          { text: "", url: "$msg?act=announcement&sact=active", id:"spm_ann",
                   submenu: { id: "sp_main_menu_62", itemdata: [
              [ { text: "", url: "$msg?act=announcement&sact=active" },
                { text: "", url: "$msg?act=announcement", id:"spm_ann_arc" },
              ],
              [ { text: "&hellip;", url: "$msg?act=new_pub", id:"spm_add4" },
              ],
            ]}
          },
        ],
~;

    if ( isadmin() ) {
        $menu .=
qq~[ { text: "", url: "$msg?act=msg_stat", id: "spm_msg_stat" } ],~;
        $menu .=
          qq~[ { text: "", url: "$msg?act=set", id: "spm_msg_set" } ]~;
    }

    $menu .= qq~
      ],
    ]
  },

  /*  */
	$pupil_comment_out_start
  {
    id: "sp_main_menu_7", itemdata: [
      [
        [
          $add_teacher_settings
~;

    if ( isadmin() ) {
        $menu .=
qq~{ text: "&hellip;", url: "$sp?act=setup_periods", id:"spm_periods" },~;
    }

    $menu .= qq~
          { text: " &hellip;", url: "$sp?act=state_date_form", id:"spm_tm" },
~;

    if ( isadmin() ) {
        $menu .=
qq~{ text: "&hellip;", url: "$sp?act=class_links_list", id: "spm_steps" },~;
    }

    $menu .= qq~
          { text: "", url: "$sp?act=subgrp_list", id: "spm_pupil2",
                   submenu: { id: "sp_main_menu_71", itemdata: [
              { text: "&hellip;", url: "$sp?act=score_form_select_class&goto=subgroups", id:"spm_add2" },
              { text: "", url: "$sp?act=subgrp_list", id:"spm_pages4" },
            ]}
          },
          { text: "   &hellip;", url: "$sp?act=req_view" },
        ],
      ],
    ]
  },
	$pupil_comment_out_end

	/*  */
	$pupil_comment_out_start
	{
		id: "sp_main_menu_8", itemdata:
		[
			[
				{ text: " SMS&hellip;", url: "$sp?act=sms_send", id: "spm_sms_send" },
				{ text: "   SMS&hellip;", url: "$sp?act=sms_edit_numbers", id:"spm_sms1" },
				{ text: " SMS &hellip;", url: "$sp?act=sms_setup", id: "spm_sms" },
				{ text: " &hellip;", url: "$sp?act=sms_group" },
            ],
			[
				{ text: "  &hellip;", url: "$sp?act=internet_access_control", id:"spm_inet" },
			],
			[
				{ text: " ", url: "$sp?act=wizard_new_year", id:"spm_ok" }
			],
			[
				{ text: "<span title='    '> &mdash;  &hellip;</span>", url: "$sp?act=payfood_error_pay", }
			]
		]
	},
	$pupil_comment_out_end

];

  /*  beforeRender -      */
  oMenuBar.subscribe ( "beforeRender",
    function ()
    {
      if (this.getRoot() == this)
      {
        this.getItem(0).cfg.setProperty("submenu", aSubmenuData[0]);
        this.getItem(1).cfg.setProperty("submenu", aSubmenuData[1]);
~;

    if ( $ggid != 4 ) {
        $menu .= qq~
this.getItem(2).cfg.setProperty("submenu", aSubmenuData[2]);
this.getItem(3).cfg.setProperty("submenu", aSubmenuData[3]);
this.getItem(4).cfg.setProperty("submenu", aSubmenuData[4]);
this.getItem(5).cfg.setProperty("submenu", aSubmenuData[5]);
this.getItem(6).cfg.setProperty("submenu", aSubmenuData[6]);
this.getItem(7).cfg.setProperty("submenu", aSubmenuData[7]);
~;
    }
    else {
        $menu .= qq~
this.getItem(3).cfg.setProperty("submenu", aSubmenuData[2]);
this.getItem(4).cfg.setProperty("submenu", aSubmenuData[3]);
~;
    }

    $menu .= qq~
      }
    }
  );

	oMenuBar.render();

-->
</script>~;

    $menu .= "</div>";

    unless ( $ggid == 4 ) {
        $menu .=
qq[<div class=state_date>:        <b>$gdate</b>.  <a href='$gconf{"sp"}?act=state_date_reset'></a>,    .</div>]
          if $state_date;
    }
    else {
        if ($state_date) {
            my $d1       = $state_date + 30 * 86400;
            my $days     = sprintf "%.0f", ( $d1 - time ) / 86400;
            my $days_str = declension( $days, [ '', '', '' ] );
            my $ost_str =
              declension( $days, [ '', '', '' ] );
            $menu .=
qq[<div class=state_date>: $ost_str <b>$days</b> $days_str     .</div>];
        }
    }

    our $auto_check_msg = int( auto_check_msg() );
    $menu .= qq[<div id='msg_popup'></div>
<script type="text/javascript" language="JavaScript">
<!--
  var gConfSP = "$gconf{sp}";
  var session_idle = $gconf{'session_idle_max'}-90; // 1:30    
  var session_idle_conf = session_idle;
];

    if ( $auto_check_msg > 0 ) {
        my $auto_check_msg_df = $auto_check_msg;
        $menu .= qq[
  var AutoCheckMsg = $auto_check_msg_df;
  var gConfMsg = "$gconf{msg}";
  load_msg_count();
];
    }

    $menu .= q[
  setTimeout ("timeout_session_idle()", 1000);
//-->
</script>];

    {
        $menu =~ s/^\s+//gm;

        $menu =~ s|/\*.*?[^(\*\/)]\*\/||gs;

        $menu =~ s/\s{0,}([{}\[\]:=])\s{0,}/$1/g;
        $menu =~ s/",([}\]])/"$1/;
    }

    return $menu;

}
1;
