# (C) http://spcms.ru
use strict;

sub users_teachers() {
    my $table;
    my @a;

    my ( $login, $binded, $class_master );
    my $counter = 0;
    my $colored1;
    my $colored2;

    my %bindings;
    sqlh \%bindings,
      qq[select vw_teacher, 1 from sys_matrix where view_class = 9001
and exists ( select 1 from get_node_saldo_by_unit
( sys_matrix.node_id, '$gdate', '', 0 ) where saldo_sum <> 0 )];

    my %class_master;
    sqlh \%class_master,
      "select vw_teacher, 1 from sys_matrix where view_class = 9003
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)";

    my $q = sqlp q[select
last_name || ' ' || first_name || ' ' || middle_name, human_id, log, uid
from human
left join sp_users on uid = human_id
where class = 0
order by last_name,first_name,middle_name];

    while ( @a = $q->fetchrow_array ) {
        $a[3] ||= '';
        $counter++;
        $login        = ( defined $a[2] )      ? $a[2]    : '&nbsp;';
        $binded       = $bindings{ $a[3] }     ? '&bull;' : '&nbsp;';
        $class_master = $class_master{ $a[3] } ? '&bull;' : '&nbsp;';
        $colored1 = $colored2 = '';
        $colored1 = q[style="background-color:#F6FFED"]
          if ( $bindings{ $a[3] } );
        $colored2 = q[style="background-color:#F6FFED"]
          if ( $class_master{ $a[3] } );
        $table .= qq[<tr>
<td align=right>$counter.</td>
<td><a class=small href="?act=register_teacher_form&amp;op=edit&amp;uid=$a[1]">$a[0]</a></td>
<td>$login</td>
<td $colored1 align=center>$binded</td>
<td $colored2 align=center>$class_master</td>
</tr>];
    }

    my $count_binded       = scalar keys %bindings;
    my $count_class_master = scalar keys %class_master;

    my $count_sp = sqlff qq[select count(1) from sp_users where gid = 2];

    tpl './tpl/users_teachers.html',
      {
        menu         => generate_menu(),
        count        => $counter,
        count_sp     => ( $count_sp == $counter ? '' : $count_sp ),
        count_binded => ( $count_binded == $counter ? '' : $count_binded ),
        count_class_master =>
          ( $count_class_master == $counter ? '' : $count_class_master ),
        table   => $table,
        footers => generate_footers(),
      };
}

sub teacher_placement() {
    my $table = '';
    my ( $q, $aref );

    $q = sqlp "select vw_teacher from sys_matrix where view_class = 9001
  and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
  where saldo_sum <> 0)";
    my %rowspan;
    while ( $_ = ( $q->fetchrow_array )[0] ) { $rowspan{$_}++ }

    my %class_ref;
    fill_class_ref( \%class_ref );

    my %teacher_login;
    sqlh \%teacher_login, "select uid, log from sp_users where gid = 2";

    $gdb->{"AutoCommit"} = 0;

    $q = sqlp qq[select human_id,
'<b>' || last_name || '</b><br>' || first_name || '&nbsp;' || middle_name,
(select name from lesson where lesson_id = sys_matrix.lesson),
sys_matrix.class,
(select entry_date from sys_entry where debet_node = sys_matrix.node_id and doc_class = 20 and oper_id = 4),
(select entry_id   from sys_entry where debet_node = sys_matrix.node_id and doc_class = 20 and oper_id = 4),
(select name from sp_class_subgrp_ref where sys_matrix.subgrp = id)
from sys_matrix join human on human_id = cast(sys_matrix.vw_teacher as integer)
where view_class = 9001
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)
order by 2, 1, 3, 4], { ib_timestampformat => "%d.%m.%Y" };

    my %cells;

    my $content = 0;
    my $c       = 0;
    my $style;

    my %namesake;

    while ( $aref = $q->fetchrow_arrayref() ) {
        if ( exists $namesake{ $$aref[1] } ) {
            $$aref[1] .=
              $teacher_login{ $$aref[0] }
              ? "<br>(: $teacher_login{$$aref[0]})"
              : "<br>(UID: $$aref[0])";
        }
        else {
            $namesake{ $$aref[1] }++;
        }

        $content = 1 unless $content;

        $style = ( ++$c % 2 ) ? '' : 'style="background-color:#f7f7f7"';

        $table .= qq[<tr>];

        unless ( exists $cells{ $$aref[0] } ) {
            if ($DEBUG) {
                $table .=
qq[<td style="font-size:10pt" rowspan="$rowspan{$$aref[0]}" align=center>$$aref[1]<br>UID = $$aref[0]</td>];
            }
            else {
                $table .=
qq[<td style="font-size:10pt" rowspan="$rowspan{$$aref[0]}" align=center>$$aref[1]</td>];
            }
            $cells{ $$aref[0] }++;
        }

        $$aref[6] ||= '<span style="color:grey">&mdash;</span>';

        my @stopped = sqlf "select entry_id, entry_date from sys_entry
where credit_node = (select debet_node from sys_entry
                     where sys_entry.entry_id = $$aref[5])
and   debet_node  = (select credit_node from sys_entry
                     where sys_entry.entry_id = $$aref[5])",
          { ib_timestampformat => "%d.%m.%Y" };

        if ($DEBUG) {
            $$aref[4] .= "<br>ID = $$aref[5]";
            if (@stopped) {
                $$aref[4] .= "<br> $stopped[1]<br>ID = $stopped[0]";
            }
        }
        else {
            if (@stopped) {
                $$aref[4] .= "<br> $stopped[1]";
            }
        }

        unless ( exists $class_ref{ $$aref[3] } ) {
            $class_ref{ $$aref[3] } = "<b style='color:red'>ID=$$aref[3]</b>";
        }

        my $class_string =
          $DEBUG
          ? "$class_ref{$$aref[3]}<br>ID&nbsp;=&nbsp;$$aref[3]"
          : $class_ref{ $$aref[3] };

        my $disable_on_time_machine = '';
        if ($state_date) {
            $disable_on_time_machine = 'disabled';
        }

        $table .= qq[<td $style>$$aref[2]</td>
<td $style align=right>$class_string</td>
<td $style align=center>$$aref[6]</td>
<td $style align=center nowrap>$$aref[4]</td>
<td $style align=center nowrap>
  <form name="form_$$aref[5]" onsubmit="return check_date('$$aref[4]',document.form_$$aref[5].d.value)">
    <input type=hidden name="act" value="teacher_placement_stop">
    <input type=hidden name="id" value="$$aref[5]">
    <input $disable_on_time_machine type=text class=def size=10 maxlength=10 name="d" value="$gdate">
    <button $disable_on_time_machine type=submit></button>
  </form>
</td>
</tr>];
    }

    $gdb->{"AutoCommit"} = 1;

    $table =
"<tr><td colspan=6><span id=error>  ($gdate)   .</span></td></tr>"
      unless $content;

    tpl './tpl/teacher_placement.html',
      {
        menu         => generate_menu(),
        footers      => generate_footers(),
        table        => $table,
        list_class   => filter_class(0),
        list_subject => filter_subj(0),
        list_teacher => filter_teacher(0),
        gdate        => $gdate,
      };

}

sub teacher_form_master() {
    my $table = '';
    my ( $q, $aref );

    $q = sqlp "select vw_teacher from sys_matrix where view_class = 9003
  and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
  where saldo_sum <> 0)";
    my %rowspan;
    while ( $_ = ( $q->fetchrow_array )[0] ) { $rowspan{$_}++ }

    my %class_ref;
    fill_class_ref( \%class_ref );

    my %teacher_login;
    sqlh \%teacher_login, "select uid, log from sp_users where gid = 2";

    $q = sqlp qq[select human_id,
'<b>' || last_name || '</b><br>' || first_name || '&nbsp;' || middle_name,
sys_matrix.class,
(select entry_date from sys_entry where debet_node = sys_matrix.node_id and doc_class = 21 and oper_id = 4),
(select entry_id   from sys_entry where debet_node = sys_matrix.node_id and doc_class = 21 and oper_id = 4)
from sys_matrix join human on human_id = cast(sys_matrix.vw_teacher as integer)
where view_class = 9003
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)
order by human.last_name], { ib_timestampformat => "%d.%m.%Y" };

    my %cells;

    my $content = 0;
    my $c       = 0;
    my $style;

    my %namesake;

    while ( $aref = $q->fetchrow_arrayref ) {
        if ( exists $namesake{ $$aref[1] } ) {
            $$aref[1] .=
              $teacher_login{ $$aref[0] }
              ? "<br>(: $teacher_login{$$aref[0]})"
              : "<br>(UID: $$aref[0])";
        }
        else {
            $namesake{ $$aref[1] }++;
        }

        $content = 1 unless $content;

        $style = ( ++$c % 2 ) ? '' : 'style="background-color:#f7f7f7"';

        $table .= qq[<tr>];

        $table .=
qq[<td style="font-size:10pt" rowspan="$rowspan{$$aref[0]}">$$aref[1]</td>]
          unless $cells{ $$aref[0] };
        $cells{ $$aref[0] }++ unless $cells{ $$aref[0] };

        if ($DEBUG) {
            $$aref[3] .= "<br>ID = $$aref[4]";
        }

        my $class_string =
          $DEBUG
          ? "$class_ref{$$aref[2]}<br>ID = $$aref[2]"
          : $class_ref{ $$aref[2] };

        my $disable_on_time_machine = '';
        if ($state_date) {
            $disable_on_time_machine = 'disabled';
        }

        $table .= qq[<td $style align=right>$class_string</td>
<td $style align=center>$$aref[3]</td>
<td $style align=center>
  <form name="form_$$aref[4]" onsubmit="return check_date('$$aref[3]',document.form_$$aref[4].d.value)">
    <input type=hidden name="act" value="teacher_form_master_stop">
    <input type=hidden name="id" value="$$aref[4]">
    <input $disable_on_time_machine type=text class=def size=10 maxlength=10 name="d" value="$gdate">
    <button $disable_on_time_machine type=submit></button>
  </form>
</td>
</tr>];
    }

    $table =
"<tr><td colspan=6><span id=error>  ($gdate)   .</span></td></tr>"
      unless $content;

    tpl './tpl/teacher_form_master.html',
      {
        menu         => generate_menu(),
        footers      => generate_footers(),
        list_teacher => filter_teacher(0),
        list_class   => filter_class(0),
        table        => $table,
        gdate        => $gdate,
      };
}

sub teacher_place() {

    my ( $uid, $s, $c, $date ) =
      ( param('uid'), param('s'), param('c'), param('date') );

    my $g              = param('g');
    my $grp_sql_select = '';
    if ($g) {
        sec_gt0($g);
        $grp_sql_select = "and subgrp = $g";
    }

    sec_gt0($uid);
    sec_gt0($s);
    sec_gt0($c);
    sec_date($date);

    if (
        sqlff "select 1 from sys_matrix where view_class = 9001
and vw_teacher = $uid and class = $c and lesson = $s
$grp_sql_select
and exists (select 1 from get_node_saldo_by_unit(sys_matrix.node_id, '$gdate', '', 0)
where saldo_sum <> 0)"
      )
    {
        stop
"        ,  ,    .";
    }

    my $node_id_credit;
    my $node_id_debet;
    my $doc_number;

    $node_id_credit = sqlff
"select node_id from sys_matrix where view_class = 9002 and vw_teacher = $uid";

    unless ($node_id_credit) {
        $node_id_credit = sqlff 'select gen_id(sys_matrix_id, 1) from dual';
        sql qq[insert into sys_matrix (node_id, view_class, vw_teacher)
           values ($node_id_credit, 9002, '$uid')];
    }

    $node_id_debet = sqlff 'select gen_id(sys_matrix_id, 1) from dual';
    if ($g) {
        sql
qq[insert into sys_matrix (node_id, view_class, class, lesson, subgrp, vw_teacher)
           values ($node_id_debet, 9001, '$c', '$s', '$g', '$uid')];
    }
    else {
        sql
qq[insert into sys_matrix (node_id, view_class, class, lesson, vw_teacher)
           values ($node_id_debet, 9001, '$c', '$s', '$uid')];
    }

    $doc_number = sqlff 'select next_value from get_next_doc_no(20)';
    sql
"insert into sys_entry (entry_date, debet_node, credit_node, unit, unit_value, doc_class, doc, oper_id )
       values ('$date', $node_id_debet, $node_id_credit, '', 1, 20, $doc_number, 4 )";

    redir "teacher_placement";
}

sub teacher_form_master_place() {
    my ( $uid, $c, $date ) = ( param('uid'), param('c'), param('date') );

    sec_gt0($uid);
    sec_gt0($c);
    sec_date($date);

    if (
        sqlff "select 1 from sys_matrix where view_class = 9003
and vw_teacher = $uid and class = $c
and exists (select 1 from get_node_saldo_by_unit(sys_matrix.node_id, '$gdate', '', 0)
where saldo_sum <> 0)"
      )
    {
        stop
"   ($gdate)        .";
    }

    my $node_id_credit;
    my $node_id_debet;
    my $doc_number;

    $node_id_credit = sqlff
"select node_id from sys_matrix where view_class = 9002 and vw_teacher = $uid";

    unless ($node_id_credit) {
        $node_id_credit = sqlff 'select gen_id(sys_matrix_id, 1) from dual';
        sql qq[insert into sys_matrix (node_id, view_class, vw_teacher)
           values ($node_id_credit, 9002, '$uid')];
    }

    $node_id_debet = sqlff 'select gen_id(sys_matrix_id, 1) from dual';
    sql qq[insert into sys_matrix (node_id, view_class, class, vw_teacher)
         values ($node_id_debet, 9003, '$c', '$uid')];

    $doc_number = sqlff 'select next_value from get_next_doc_no(21)';
    sql
"insert into sys_entry (entry_date, debet_node, credit_node, unit, unit_value, doc_class, doc, oper_id )
       values ('$date', $node_id_debet, $node_id_credit, '', 1, 21, $doc_number, 4 )";

    redir "teacher_form_master";
}

sub teacher_placement_stop() {
    internal_teacher_binding_stop( 20, '' );
    redir "teacher_placement";
}

sub teacher_form_master_stop() {
    internal_teacher_binding_stop( 21, '' );
    redir "teacher_form_master";
}

sub internal_teacher_binding_stop($$) {
    my $doc_class = shift;
    my $unit      = shift;

    my $id   = param('id');
    my $date = param('d');

    sec_date($date);

    if ( totime($date) > time() ) {
        stop "   '<b>$date</b>'   .";
    }

    my ( $node_id_debet, $node_id_credit ) =
      sqlf "select debet_node, credit_node
               from sys_entry where entry_id = $id",
      { ib_timestampformat => "%d.%m.%Y" };

    my $entry_date;
    if ( $entry_date =
        sqlff
"select entry_date from sys_entry where debet_node = $node_id_credit and credit_node = $node_id_debet",
        { ib_timestampformat => "%d.%m.%Y" } )
    {
        stop
          "       &ndash; $entry_date.";
    }
    else {
        my $doc_number =
          sqlff "select next_value from get_next_doc_no($doc_class)";
        sql
"insert into sys_entry (entry_date, debet_node, credit_node, unit, unit_value, doc_class, doc, oper_id )
        values ('$date', $node_id_credit, $node_id_debet, '$unit', 1, $doc_class, $doc_number, 4 )";
    }
}

sub teacher_switch_binding() {
    unless (
        sqlff qq[select count(1) from sys_matrix
where view_class = 9001
and vw_teacher = $guid
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)]
      )
    {
        stop
'            .          &mdash;       /   ,            .';
    }

    if ( param('id') ) {
        unless ( sqlff
"select 1 from sp_user_settings where uid = $guid and id = 0 and f_int = 1"
          )
        {
            sql
"insert into sp_user_settings (uid,id,f_int) values ($guid, 0, 1)";
        }
    }
    else {
        sql "delete from sp_user_settings where uid = $guid and id = 0";
    }
    if ( $ENV{'HTTP_REFERER'} ) {
        exit print redirect $ENV{'HTTP_REFERER'};
    }
    else {
        redir('score_form_select_class');
    }
}

sub check_teacher_binded_to {
    my $c = $_[0];
    my $s = $_[1];

    my $g = param('g');

    my $grp_sql_select = '';
    if ($g) {
        sec_gt0($g);
        $grp_sql_select = "and subgrp = $g";
    }
    else {
        $grp_sql_select = 'and subgrp is NULL';
    }

    if (
        sqlff qq[select 1 from sys_matrix
where sys_matrix.view_class = 9003
and sys_matrix.vw_teacher = $guid
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)]
      )
    {
        if (
            sqlff qq[select 1 from sys_matrix
where sys_matrix.view_class = 9003
and sys_matrix.vw_teacher = $guid
and class = $c
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)]
          )
        {
            return;
        }
        else {
            if (
                sqlff qq[select 1 from sys_matrix
where view_class = 9001
and vw_teacher = $guid
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)]
              )
            {
                stop
"   .<br>       .<br><a href='?act=teacher_list_bindings'></a>   ."
                  unless (
                    sqlff qq[select 1 from sys_matrix
where view_class = 9001
and vw_teacher = $guid
and class  = $c
and lesson = $s
$grp_sql_select
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)]
                  );
            }
        }
    }

}

sub teacher_list_bindings() {
    my $kr = '';
    my $pr = '';

    my %classes;

    my @a;

    sqlh \%classes, qq[select class_id,
paralel || ' ' || ( select name from class where class_id = cast(sys_matrix.class as integer) )
from sys_matrix, class
where view_class = 7
and class.class_id = sys_matrix.class
and exists ( select 1 from get_node_saldo( sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )];

    for ( keys %classes ) {
        $classes{$_} =~ s/^(\d+ \".+\").+/$1/;
        $classes{$_} =~ s/\"/&quot;/g;
    }

    sqlffa \@a, qq[select cast(class as integer) from sys_matrix
where sys_matrix.view_class = 9003
and sys_matrix.vw_teacher = $guid
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)];

    for (@a) {
        $kr .= qq[<tr><td>$classes{$_}</td></tr>];
    }

    $kr =
qq[<tr><td><span style="color:red">  </span></td></tr>]
      unless ( scalar @a );

    @a = ();

    sqla \@a, qq[select cast(sys_matrix.class as integer), lesson.name,
(select name from sp_class_subgrp_ref where sys_matrix.subgrp = id)
from sys_matrix, lesson
where sys_matrix.view_class = 9001
and lesson.lesson_id = sys_matrix.lesson
and sys_matrix.vw_teacher = $guid
and exists ( select 1 from get_node_saldo_by_unit ( sys_matrix.node_id, '$gdate', '', 0 )
where saldo_sum <> 0)
order by lesson.name];

    for (@a) {
        $_->[2] ||= '<span style="color:grey">&nbsp;</span>';
        $pr .=
qq[<tr><td class=pr4 align=right>$classes{$_->[0]}</td><td align=left>$_->[1]</td><td align=left>$_->[2]</td></tr>];
    }

    $pr =
qq[<tr><td colspan=3><span style="color:red">  </span></td></tr>]
      unless ( scalar @a );

    tpl './tpl/teacher_list_bindings.html',
      {
        menu    => generate_menu(),
        footers => generate_footers(),
        kr      => $kr,
        pr      => $pr,
      };
}

1;
