# (C) http://spcms.ru
use strict;
our (%human_class_hash);

sub logs() {

    my (
        @result,          @logs_in,    @name,     $block,
        $block_top,       $i,          $j,        $class,
        %Grp,             %Logged,     $user_out, @s,
        @t,               $date_begin, $date_end, $date_filter,
        %logs_matrix_ref, $bottom
    );
    my $time = timelocal localtime;
    my $filter = ( defined param("f") and param("f") < 1 ) ? 0 : param("f")
      || 0;
    my $filter1    = param("f1") || '';
    my $filter_grp = param("g");
    my $date_s     = ( defined param("d") && param("d") > 0 ) ? param("d") : 0;
    my $sort       = param("s") || 0;
    my $full       = param("full") || 0;
    $full = $full == 1 ? 1 : 0;
    $date_begin = param("d_begin") || todate( $time - 604800 );
    $date_end   = param("d_end")   || todate($time);
    $block_top  = '';

    sec_gteq0($filter);
    sec_gteq0($date_s);
    sec_gteq0( $filter_grp, 1 );

    if ( $filter == 1 ) {
        sec_gteq0($filter1);
    }
    elsif ( $filter == 2 ) {
        if ( $filter1 !~
m/^(?:(?:25[0-5]|2[0-4][0-9]|\d*?\*\d*?|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|\d*?\*\d*?|2[0-4][0-9]|[01]?[0-9][0-9]?)$/
          )
        {
            stop(
qq[   IP  ( $filter1 ),   IP : <a href='http://apple.com' target='_blanck'>17.149.160.49</a>]
            );
        }
    }

    my $q = sqlp(
        'SELECT gid, name FROM sp_gid_ref WHERE EXISTS
    (SELECT 1 FROM sp_users WHERE sp_users.gid = sp_gid_ref.gid) ORDER BY gid'
    );
    while ( @result = $q->fetchrow_array() ) {
        $Grp{ $result[0] } = $result[1];
    }

    clear_expired_sessions();
    $q = sqlp "SELECT sid FROM sp_users_logged";
    while ( @result = $q->fetchrow_array() ) {
        $Logged{ $result[0] } = 1;
    }

    if ( $date_s == 6 ) {
        sec_date($date_begin);
        sec_date($date_end);
        if ( totime $date_end < totime $date_begin ) {
            stop("     ");
        }
    }

    my @f_dt = ( 0, 1, 2, 3, 7, 14, 30, 61, 92 );
    my @f_dt_word = (
        "",
        " ",
        " ",
        "",
        " ",
        "",
        "2 ",
        "3 ",
        " ",
        ""
    );

    if ( $f_dt[$date_s] ) {
        $time = day_sub( $time, $f_dt[$date_s] );
    }

    $date_filter = todate($time);

    my $SQL;
     my @f_d = (
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "AND date_s > cast('$date_filter' as TIMESTAMP)",
        "",
"AND ( date_s >= cast('$date_begin' as TIMESTAMP ) AND date_s <= cast('$date_end 23:59:59' as TIMESTAMP) )"
    );
    $SQL .= $f_d[$date_s] . ' ';

    $filter1 =~ s/\*/%/g;
    my @f_f = (
        '',
        "AND uid = '$filter1'",
        "AND ip LIKE '$filter1'",
"AND (ip LIKE \'10.%\' OR ip LIKE \'192.168.%\' OR ip LIKE \'172.16.%\' OR ip LIKE \'169.254.%\' OR ip LIKE \'127.%\')",
"AND not (ip LIKE \'10.%\' OR ip LIKE \'192.168.%\' OR ip LIKE \'172.16.%\' OR ip LIKE \'169.254.%\' OR ip LIKE \'127.%\')",
        "AND gid = '$filter1'",
        "AND s < 4",
        "AND s != 11",
    );
    $SQL .= $f_f[$filter] . ' ';

    if ( defined $filter_grp && $filter_grp ne '' ) {
        $SQL .= "AND gid = '$filter_grp'";
    }
    else {
        $filter_grp = '';
    }

    $q = sqlpcms
"SELECT s, sid, date_s, ip, ip_for, uid, gid, ids, agent, date_exit, s_exit, NULL FROM logs_session
     WHERE (s < 30) $SQL", { ib_timestampformat => "%d.%m.%Y, %H:%M:%S|%s" };
    my @tmp;
    while ( @result = $q->fetchrow_array() ) {
        if ( defined $result[1] ) {
            $name[0] = human_hash( $result[5] );
            $name[1] = $Grp{ $result[6] };
            $name[2] = $Logged{ $result[1] } ? 1 : 0;
        }
        else {
            $name[0] = '&mdash;';
            undef $name[1];
            undef $name[2];
        }
        ( $result[2], $name[3] ) = split /\|/, $result[2];
        if ( defined $result[9] ) {
            ( $result[9], $name[4] ) = split /\|/, $result[9];
        }
        else {
            $result[9] = $name[4] = '';
        }
        unless ( $name[2]
            && $result[0] == 1
            && ( $filter == 7 or $filter == 6 ) ) {
            push @logs_in, [ @result, @name ];
        }
    }

    @s = ( -1, 0, 2, 4, 6, 8 );
    $t[1] = $t[2] = $t[3] = $t[4] = '';
    if ( $sort == 7 ) {
        @logs_in =
          reverse sort { $a->[6] cmp $b->[6] || $a->[2] cmp $b->[2] } @logs_in;
        $t[4] = " &uarr;";
    }
    elsif ( $sort == 6 ) {
        @logs_in = sort { $a->[6] cmp $b->[6] || $a->[2] cmp $b->[2] } @logs_in;
        $t[4] = " &darr;";
        $s[4] = 7;

    }
    elsif ( $sort == 5 ) {
        @logs_in =
          reverse sort { $a->[12] cmp $b->[12] || $a->[2] cmp $b->[2] }
          @logs_in;
        $t[3] = " &uarr;";
    }
    elsif ( $sort == 4 ) {
        @logs_in =
          sort { $a->[12] cmp $b->[12] || $a->[2] cmp $b->[2] } @logs_in;
        $t[3] = " &darr;";
        $s[3] = 5;

    }
    elsif ( $sort == 3 ) {
        @logs_in =
          reverse sort { $a->[3] cmp $b->[3] || $a->[2] cmp $b->[2] } @logs_in;
        $t[2] = " &uarr;";
    }
    elsif ( $sort == 2 ) {
        @logs_in = sort { $a->[3] cmp $b->[3] || $a->[2] cmp $b->[2] } @logs_in;
        $t[2] = " &darr;";
        $s[2] = 3;

    }
    elsif ( $sort == 1 ) {
        @logs_in =
          reverse sort { $a->[15] cmp $b->[15] || $a->[3] cmp $b->[3] }
          @logs_in;
        $t[1] = " &uarr;";
    }
    else {
        @logs_in =
          sort { $a->[15] cmp $b->[15] || $a->[3] cmp $b->[3] } @logs_in;
        $t[1] = " &darr;";
        $s[1] = 1;
    }

    $q = sqlpcms "SELECT s,name,description FROM logs_matrix_ref";
    while ( @result = $q->fetchrow_array() ) {
        if ( defined $result[2] && $result[2] ne '' ) {
            $result[1] = qq[<span class=hl>$result[1]</span>];
        }
        $logs_matrix_ref{ $result[0] } = [ $result[1], $result[2] ];
    }

    my %class;
    $class{0} = "FFC4A1";
    $class{1} = "FFEBBD";
    $class{2} = "C7FFC7";
    $class{4} = "ffffff";

    my (
        $fio,   @Fio,       $stat,      $classI, $tmp,
        @count, %count_Grp, %user_hash, $block_th
    );
    $block_th = $classI = '';
    $count[1] = $count[2] = 0;

    my $bg = 0;
    for ( $i = 0 ; $i < @logs_in ; $i++ ) {
        $user_out = '';
        $stat     = '&nbsp;';
        if ( defined $logs_in[$i][6] ) {
            $Fio[0] = qq[$logs_in[$i][12]<span id="t$i" style="display:none;">];
            $Fio[1] = qq[<br>: $logs_in[$i][13]];
            if ( $logs_in[$i][6] == 4 ) {
                $fio =
                    $Fio[0]
                  . qq[<a href='?act=pupil_info&uid=$logs_in[$i][5]' title='  '><img src='/sp/img/user.gif' width=18 height=18 border=0 align='left' vspace=5></a>]
                  . $Fio[1];
                $fio .= ', ' . class_hash( $logs_in[$i][5] );
            }
            else {
                $fio = $Fio[0] . $Fio[1];
            }
            $fio .= '</span>';
            $classI =
              length( $class{ $logs_in[$i][6] } ) > 1
              ? 'background-color: #' . $class{ $logs_in[$i][6] } . ';'
              : '';
        }
        else {
            $logs_in[$i][6] = 'not-dt';
        }

        if (   defined $logs_in[$i][10]
            && $logs_in[$i][10] >= 3
            && $logs_in[$i][10] <= 5 )
        {
            $count[ $logs_in[$i][10] ]++;
            $user_out =
              ( $logs_in[$i][9] ne '' ? $logs_in[$i][9] . "<br>" : '' )
              . "<span title='$logs_matrix_ref{$logs_in[$i][10]}[1]' style='font-size:85%;color:red;'>$logs_matrix_ref{$logs_in[$i][10]}[0]</span><br>";
        }
        elsif ( $logs_in[$i][0] >= 12 ) {
            $count[ $logs_in[$i][0] ]++;
            $user_out =
              ( $logs_in[$i][9] ne '' ? $logs_in[$i][9] . "<br>" : '' )
              . "<span title='$logs_matrix_ref{$logs_in[$i][0]}[1]' style='font-size:85%;color:red;'>$logs_matrix_ref{$logs_in[$i][0]}[0]</span><br>";
        }
        elsif ( $logs_in[$i][14] && $logs_in[$i][0] == 1 ) {
            $user_out = $logs_in[$i][14] ? '  ' : '';
        }
        elsif ( $logs_in[$i][0] >= 6 && $logs_in[$i][0] <= 11 ) {
            defined $logs_matrix_ref{ $logs_in[$i][0] }[0]
              and $user_out =
              q[<font color='red']
              . (
                defined $logs_matrix_ref{ $logs_in[$i][0] }[1]
                ? " title='" . $logs_matrix_ref{ $logs_in[$i][0] }[1] . "'"
                : '' )
              . qq[>$logs_matrix_ref{$logs_in[$i][0]}[0]</font>];
            $count[ $logs_in[$i][0] ]++;
            if ( $logs_in[$i][0] != 11 ) {
                $stat =
                  q[<img src="/sp/img/error2.gif" width="15" height="15">];
            }
            my @q = sqlfcms
"SELECT container,container2 FROM logs_matrix WHERE type_t = 1 AND stat = $logs_in[$i][0] AND mid = $logs_in[$i][7]";
            $q[0] = escape_tag( \$q[0] );
            $q[1] = escape_tag( \$q[1] );
            if ( $logs_in[$i][0] > 5 && $logs_in[$i][0] < 8 ) {
                $fio = qq[: <b>$q[0]</b>];
                if ( $ggid == 0 ) { $fio .= qq[<br>: <b>$q[1]</b>]; }
            }
            elsif ( $logs_in[$i][0] == 8 ) {
                my @aL = split /\n/, $q[0];
                $fio = qq[: <b>$aL[0]</b><br>: <b>$aL[1]</b>];
            }
            elsif ( $logs_in[$i][0] == 9 ) {
                $fio = qq[UID: <b>$q[0]</b>];
            }
            else {
                $fio =
qq[<a href='?act=pupil_info&uid=$q[0]' title='  '><img src='/sp/img/user.gif' width=18 height=18 border=0 align='left' vspace=5></a> UID: <b>$q[0]</b><br>: <b>$q[1]</b>];
            }
        }

        my $time_session_length;
        if (   defined $logs_in[$i][10]
            && $logs_in[$i][9] ne ''
            && ( $logs_in[$i][10] > 1 && $logs_in[$i][10] < 6 ) )
        {
            if ( ( $filter == 6 or $filter == 7 )
                and !( $logs_in[$i][10] == 3 or $logs_in[$i][10] == 4 ) )
            {
                goto exit_st;
            }
            if (   $logs_in[$i][10] != 3
                && $logs_in[$i][10] != 4
                && $logs_in[$i][10] != 5 )
            {
                $user_out = $logs_in[$i][9] . '<br>';
            }
            $time_session_length = $logs_in[$i][16] - $logs_in[$i][15];
        }
        elsif ( $user_out eq '' ) {
            $count[2]++;
            $user_out = '<font color=red>  </font>';
        }
        else {
            $time_session_length = '';
        }

        my $ip_str = '';
        if ( $logs_in[$i][3] =~
m/^127\.\d+\.\d+\.\d+$|10\.\d+\.\d+\.\d+$|192\.168\.\d+\.\d+$|172\.16\.\d+\.\d+$|169\.254\.\d+\.\d+$/
          )
        {
            $ip_str = q[<dl class="local"></dl>];
        }
        else {
            $ip_str = q[<dl class="internet"></dl>];
        }

        if ( $full == 1 ) {
            $ip_str .=
qq[ <a href='?act=logs&d=$date_s&f=2&f1=$logs_in[$i][3]&s=$sort&g=$filter_grp&full=$full&d_begin=$date_begin&d_end=$date_end&show=1' class='small'>]
              . $logs_in[$i][3];
            defined $logs_in[$i][4]
              and $ip_str .= ( $logs_in[$i][4] ? ', ' : ' ' ) . $logs_in[$i][4];
            $ip_str .= '</a>';
            $block_th = q[<th></th>];
        }

        $bg = $bg == 1 ? 0 : 1;
        my $tmp =
          ( defined $logs_in[$i][5] && $logs_in[$i][5] > 0 )
          ? qq[ onClick="show($i,$logs_in[$i][5]);" id="$i"]
          : '';
        my $tmp1 =
          $full == 1
          ? ''
          : qq[ onClick="showIP($i);" str="$logs_in[$i][3]" id="ip_$i"];
        my $s_time = time2str($time_session_length);
        $block .= qq[<tr class='bg$bg'>
      <td style="$classI">$stat</td>
      <td>$logs_in[$i][2]<br>$user_out$s_time</td>
      <td nowrap$tmp>$fio</td>
      <td$tmp1 nowrap class='c'>$ip_str</td>];
        if ( $full == 1 ) {
            $block .= qq[<td nowrap title="$logs_in[$i][8]">];
            if ( $logs_in[$i][8] =~ /msie (\d+\.\d+)/i ) {
                $block .= qq[<dl class=ie></dl> v$1];
            }
            elsif ( $logs_in[$i][8] =~ /opera\/(\d+\.\d+)/i ) {
                $block .= qq[<dl class=opera></dl> v$1];
            }
            elsif ( $logs_in[$i][8] =~ /firefox\/((\.?\d+){1,5})/i ) {
                $block .= qq[<dl class=firefox></dl> v$1];
            }
            elsif ( $logs_in[$i][8] =~ /chrome\/((\.?\d+){1,5})/i ) {
                $block .= qq[<dl class=gchrome></dl> v$1];
            }
            elsif ( $logs_in[$i][8] =~ /version\/([\.\d]+).+safari\//i ) {
                $block .= qq[<dl class=safari></dl> v$1];
            }
            else { $block .= q[] }
            $block .= '</td>';
        }
        $block .= '</tr>';

        if ( defined $count_Grp{ $logs_in[$i][6] } ) {
            $count_Grp{ $logs_in[$i][6] }++;
        }
        else {
            $count_Grp{ $logs_in[$i][6] } = 1;
        }

        if ( defined $logs_in[$i][5] ) {
            ${ $user_hash{ $logs_in[$i][5] } }[0] = $logs_in[$i][12];
            ${ $user_hash{ $logs_in[$i][5] } }[1]++;
            ${ $user_hash{ $logs_in[$i][5] } }[2] = $logs_in[$i][6];
        }
      exit_st:
    }

    if ( $i < 1 ) {
        $block .= q[<tr class='bg1'>
      <td>&nbsp;</td>
      <td colspan=4 align=center>   .     .</td>
    </tr>];
    }
    else {
        my $user_n = scalar keys %user_hash;
        $block_top =
q[<table class="d" id=short_stat align="center" border="0" cellspacing="0" cellpadding="1">
  <tr>
    <th colspan="2" scope="col"> </th>
  </tr>];

        unless ( $filter == 7 or $filter == 6 ) {
            $block_top .= q[
  <tr class='bg1'>
    <td style="height:24px" colspan="2"><b>   :&nbsp;&nbsp;</b></td>
  </tr>];

            for (
                sort {
                         $user_hash{$a}->[2] <=> $user_hash{$b}->[2]
                      || $user_hash{$a}->[0] cmp $user_hash{$b}->[0]
                } keys %user_hash
              )
            {
                my $str_dec =
                  $user_hash{$_}[1] . ' '
                  . declension( $user_hash{$_}[1], [ '', '', '' ] );
                my $add_class = '';
                if ( $user_hash{$_}[2] =~ /^[012]$/ ) {
                    $add_class = " g$user_hash{$_}[2]";
                }
                $block_top .=
                    "<tr><td class='par$add_class' title='UID: $_'>"
                  . $user_hash{$_}[0]
                  . "</td><td class='$add_class' title=' $str_dec'>"
                  . $str_dec
                  . "</td></tr>";
            }

            $block_top .= qq[
  <tr>
    <td class='par'><i><b>&nbsp; :</b></i></td>
    <td>$user_n</td>
  </tr>
  <tr>
    <td class='par'><i><b>&nbsp; -    :</b></i></td>
    <td>$i</td>
  </tr>];
        }

        $block_top .= q[
  <tr class='bg1'>
    <td style="height:24px" colspan="2"><b>  :</b></td>
  </tr>];

        if ( $count[2] ) {
            $block_top .= qq[
  <tr>
    <td class='par'>  :</td>
    <td>$count[2]</td>
  </tr>];
        }

        $q = sqlpcms
"SELECT s,name,description FROM logs_matrix_ref WHERE s != 11 AND s >= 3 ORDER BY s";
        while ( @result = $q->fetchrow_array() ) {
            if ( defined( $count[ $result[0] ] ) && $count[ $result[0] ] > 0 ) {
                $result[1] = ucfirst $result[1];
                $tmp = defined $result[2] ? $result[2] : '';
                if ( $tmp ne '' ) {
                    $result[1] = qq[<span class=hl>$result[1]</span>];
                }
                $block_top .=
qq[<tr><td class='par' title="$tmp">$result[1]:</td><td>$count[$result[0]]</td></tr>];
                $count[1] += $count[ $result[0] ];
            }
        }

        $count[1] =
          ( $count[1] + $count[2] ) == 0 ? '' : ( $count[1] + $count[2] );
        $block_top .= qq[
  <tr>
    <td class='par'><i><b>&nbsp;:</b></i></td>
    <td>$count[1]</td>
  </tr>
  <tr class='bg1'>
    <td style="height:24px" colspan="3"><b>   :</b></td>
  </tr>];

        my $summ = 0;
        for ( sort keys %count_Grp ) {
            $block_top .=
              "<tr><td class='par'>"
              . (
                defined $Grp{$_}
                ? $Grp{$_}
                : '  ' )
              . ':</td><td>'
              . $count_Grp{$_}
              . '</td></tr>';
            $summ += $count_Grp{$_};
        }

        $block_top .= qq[<tr><td class='par'><i><b>&nbsp;:</b></i></td>
    <td>$summ</td></tr></table><br>];
    }

    $tmp = '';
    $i   = 1;
    for ( sort keys %Grp ) {
        $tmp .=
qq[<td><div class=legend style="background-color:#$class{$_}">&nbsp;</div>&nbsp;&nbsp;&nbsp;&nbsp;$Grp{$_}<td>];
        if ( $i == 4 ) { $tmp .= '</tr><tr>'; $i = 0; }
        $i++;
    }
    $bottom = qq[<br>
<style type=text/css>
.tmp tr td, .tmp tr td table tr td {padding: 0 2px;}
</style>
<table class=tmp border="0" align="center" cellpadding="0" cellspacing="3">
<tr><td>
  <table align="center" border="0" cellpadding="0" cellspacing="5"><tr>$tmp</table>
</td></tr>
<tr align="center"><td>
  <span><dl class=local></dl>  </span>&nbsp;&nbsp;&nbsp;
  <span><dl class=internet></dl> </spam>
</td></tr>
</table>];

    my ( $select_f, $select_f1, $select_d, $sel, $grp_f1 );
    $select_f1 = '';
    for ( my $i = 0 ; $i < @f_dt_word ; $i++ ) {
        $sel = $i == $date_s ? ' selected' : '';
        $select_d .= qq[<option value="$i"$sel>$f_dt_word[$i]</option>];
    }

    @tmp = (
        ' -', 'UID', 'IP', ' IP', ' IP', '',
        '  ',
        ' '
    );
    for ( my $i = 0 ; $i < @tmp ; $i++ ) {
        if ( length( $tmp[$i] ) < 2 ) { next; }
        $sel = $i == $filter ? ' selected' : '';
        $select_f .= qq[<option value="$i"$sel>$tmp[$i]</option>];
    }

    $grp_f1 = "<select class=def name='g'>";
    $grp_f1 .= "<option value=''> -</option>";
    for ( sort keys %Grp ) {
        $sel = $_ eq $filter_grp ? ' selected' : '';
        $grp_f1 .= "<option value='$_'$sel>$Grp{$_}</option>";
    }
    $grp_f1 .= "</select>";

    $filter1 =~ s/%/\*/g;
    if ( $filter <= 2 && $filter > 0 ) {
        $select_f1 =
qq[<input class=def name="f1" id=f1 type="text" size="12" value="$filter1" onBlur="f_chk();" onKeyUp="f_chk(1);" onMouseOut="f_chk(1);">];
    }
    elsif ( $filter <= 4 && $filter >= 3 ) {
        $select_f1 .= qq[<input type="hidden" name="f1" id=f1 value="$filter">];
    }

    my %replace = (
        menu       => generate_menu(),
        act        => param("act"),
        block      => $block,
        block_th   => $block_th,
        block_top  => $block_top,
        s1         => $s[1],
        s2         => $s[2],
        s3         => $s[3],
        s4         => $s[4],
        s5         => $s[5],
        t1         => $t[1],
        t2         => $t[2],
        t3         => $t[3],
        t4         => $t[4],
        f1         => $filter1,
        f          => $filter,
        d          => $date_s,
        s          => $sort,
        grp_f1     => $grp_f1,
        select_d   => $select_d,
        d_begin    => $date_begin,
        d_end      => $date_end,
        select_f   => $select_f,
        filter_grp => $filter_grp,
        select_f1  => $select_f1,
        full       => $full,
        full_ch    => ( $full == 1 ? 'checked' : '' ),
        date_sel_display =>
          ( $date_s != ( @f_dt_word - 1 ) ? 'style="display: none;"' : '' ),
        bottom  => $bottom,
        footers => (
            defined param('show')
            ? q[<script type="text/javascript"> stat_show(); </script>]
            : ''
          )
          . generate_footers(),
        show_log => ( defined param('show') ? 'show' : '' ),
    );
    tpl( "./tpl/logs.html", \%replace );
}

sub class_hash {
    my $class = shift;
    unless ( $human_class_hash{$class} ) {
        $human_class_hash{$class} = get_pupil_class( 1, $class );
    }
    return $human_class_hash{$class};
}

1;
