# (C) http://spcms.ru
use strict;

sub print_main() {

    my $SQLp = "";
    if ( $ggid == 4 ) {
        if ($state_date) {
            if ( ( time - $state_date ) > ( 86400 * 30 ) ) {
                delete_graduate();
            }
        }
        my $class_id = get_pupil_class(0);

        unless ($class_id) {
            unless ($state_date) {
                my $release_date =
                  sqlff "select entry_date from sys_entry t1, sys_matrix t2
where t1.credit_node = t2.node_id and
entry_date between (select min(entry_date) from sys_entry) and 'now' and
doc_class = 5 and
vw_pupil = $guid and
exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
deduction_type between 1032 and 1034)", { ib_timestampformat => '%d.%m.%Y' };
                if ($release_date) {
                    if ( totime($release_date) + 86400 * 30 < time ) {
                        delete_graduate();
                    }
                    $release_date = totime $release_date;
                    $release_date = day_sub $release_date;
                    sql
qq[update sp_users set state_date = '$release_date' where uid = $guid];
                    redir 'main';
                }
            }
        }

        my $release_date =
          sqlff "select entry_date from sys_entry t1, sys_matrix t2
where t1.credit_node = t2.node_id and
entry_date between (select min(entry_date) from sys_entry) and 'now' and
doc_class = 5 and
vw_pupil = $guid and
exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
deduction_type between 1032 and 1034)", { ib_timestampformat => '%d.%m.%Y' };
        if ($release_date) {
            if ( totime($release_date) + 86400 * 30 < time ) {
                delete_graduate();
            }
            $release_date = totime $release_date;
            $release_date = day_sub $release_date;
            sql
qq[update sp_users set state_date = '$release_date' where uid = $guid];
            $state_date = $release_date;
        }

        my $paralel = sqlff(
            "select cast(paralel AS integer) from sys_matrix
    where view_class = 7 and class = $class_id and exists
    (select 1 from get_node_saldo (sys_matrix.node_id, 'now', 0)
    WHERE saldo_sum <> 0)"
          )
          || sqlff(
            "select cast(paralel AS integer) from sys_matrix
    where view_class = 7 and class = $class_id and exists
    (select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0)
    WHERE saldo_sum <> 0)"
          );

        $SQLp .= " OR
    (msg_public_send.type_g = 2 AND msg_public_send.gid = $paralel)
              OR
    (msg_public_send.type_g = 3 AND msg_public_send.gid = $class_id)";
    }

    my $id_announcement = sqlffcms(
        "SELECT msg_public_text.id
  FROM msg_public_text,msg_public_send WHERE
  msg_public_text.id = msg_public_send.pub_id AND
   (
   (msg_public_send.type_g = 1 AND msg_public_send.gid = $ggid)
   $SQLp
   ) AND (msg_public_text.date_begin <= 'NOW' AND msg_public_text.date_end >= 'NOW')
     AND NOT EXISTS (
       SELECT 1 FROM msg_public_read WHERE
       msg_public_read.p_id = msg_public_text.id AND msg_public_read.uid = $guid )
     ORDER BY msg_public_text.date_begin DESC
  "
    );

    if ($id_announcement) {
        redir "announcement&id=$id_announcement&sact=ref", $gconf{msg};
    }

    if ( $ggid == 0 or $ggid == 1 ) {
        my $last_auto_check =
          sqlff "select f_int from sp_settings where name = 'last_auto_check'";

        my @tmp = localtime(time);
        $tmp[4]++;

        if (    scalar(time) - $last_auto_check > 7776000
            and $tmp[4] > 8
            and $tmp[4] < 6 )
        {
            sql "update sp_settings set f_int = "
              . scalar(time)
              . " where name = 'last_auto_check'";
            redir 'wizard_new_year';
        }

        redir 'logged';
    }

    if ( $ggid == 2 ) { redir 'score_form_select_class'; }

    if ( $ggid == 4 ) {
        score_all_subjects();
    }

}

sub delete_graduate() {
    if ( sqlfcms "SELECT 1 FROM msg_public_text WHERE author_id = $guid" ) {
        my ( $delete, $key, @result, $q );
        $key = 0;
        $q   = sqlpcms "SELECT id FROM msg_public_text WHERE author_id = $guid";
        while ( @result = $q->fetchrow_array() ) {
            if ( $key > 0 ) { $delete .= ' OR '; }
            $key++;
            $delete .= 'pub_id = ' . $result[0];
        }
        sqlpcms "DELETE FROM msg_public_send WHERE " . $delete;
        sqlpcms "DELETE FROM msg_public_read WHERE uid = " . $guid;
        sqlpcms "DELETE FROM msg_public_text WHERE author_id = $guid";
    }

    if ( sqlfcms "SELECT 1 FROM msg_message_text WHERE author_id = $guid" ) {
        my ( @DelAll, $DelUpd, $key, $key_u, @result, $q );
        $key = $key_u = 0;
        $q = sqlpcms "SELECT msg_message_text.id, msg_send.cmd_s, msg_send.u_id
      FROM msg_message_text, msg_send
      WHERE msg_message_text.id = msg_send.msg_id AND msg_message_text.author_id = $guid";
        while ( @result = $q->fetchrow_array() ) {
            if ( $result[1] == 3 || $result[2] == $guid ) {
                if ( $key > 0 ) { $DelAll[0] .= ' OR '; $DelAll[1] .= ' OR '; }
                $key++;
                $DelAll[0] .= 'msg_id = ' . $result[0];
                $DelAll[1] .= 'id = ' . $result[0];
            }
            else {
                if ( $key_u > 0 ) { $DelUpd .= ' OR '; }
                $key_u++;
                $DelUpd .= 'id = ' . $result[0];
            }
        }
        if ( $DelAll[0] ne '' ) {
            sqlpcms "DELETE FROM msg_send WHERE " . $DelAll[0];
            sqlpcms "DELETE FROM msg_message_text WHERE " . $DelAll[1];
        }
        if ( $DelUpd ne '' ) {
            sqlcms( "UPDATE msg_message_text SET cmd_i = 3 WHERE " . $DelUpd );
        }
    }
    sqlpcms "DELETE FROM msg_send WHERE u_id = " . $guid;
    sqlpcms
"DELETE FROM msg_message_text WHERE msg_message_text.cmd_i = 3 AND not exists
     (SELECT 1 FROM msg_send WHERE msg_message_text.id = msg_send.msg_id)";

    sqlpcms "DELETE FROM msg_address_book WHERE uid = " 
      . $guid
      . " OR fav = "
      . $guid;

    sql "delete from sp_users_acl where uid = $guid";
    sql "delete from sp_user_settings where uid = $guid";
    sql "delete from sp_users_logged where uid = $guid";
    sql "delete from sp_users where uid = $guid";

    my $sid = sid();
    log_user_sesion( 12, $sid );
    printfile './tpl/graduate_goodbye.html';
}

1;
