# (C) http://spcms.ru
use strict;
use vars qw( $gdate );

sub class_links_list() {
    my ( $l1f, $l1t, $l2f, $l2t, $l3f, $l3t ) = split( ',',
        sqlff qq[select f_char from sp_settings where name = 'class_links'] );

    my %replace = (
        menu    => generate_menu(),
        l1f     => $l1f,
        l2f     => $l2f,
        l3f     => $l3f,
        l1t     => $l1t,
        l2t     => $l2t,
        l3t     => $l3t,
        footers => generate_footers()
    );

    tpl( './tpl/setup_class_links_list.html', \%replace );
}

sub class_links_setup() {
    sec_gt0 param 'l1_from';
    sec_gt0 param 'l2_from';
    sec_gt0 param 'l3_from';
    sec_gt0 param 'l1_to';
    sec_gt0 param 'l2_to';
    sec_gt0 param 'l3_to';

    my $p = join( ',',
        param('l1_from'), param('l1_to'),   param('l2_from'),
        param('l2_to'),   param('l3_from'), param('l3_to') );

    sql qq[update sp_settings set f_char = '$p' where name = 'class_links'];

    redir("class_links_list");
}

1;
