# (C) http://spcms.ru
use locale;
use strict;

use vars qw/$act $sact $id $tab $guid $ggid/;
our (%human_class_hash);
my ( $body, $bottom, $q, %SET, $title_d );

$SET{'a_teacher_systest'} = 1;

sub test_desktop() {
    $body = $bottom = $title_d = '';
    if ( $sact eq 'execute_test' ) {
        $body    = executetest();
        $title_d = "";
    }
    else {
        my @access_make =
          qw/expandedinfo start_test totalsscore executetest_del_act/;
        my $denied;
        $denied = 1;
        $denied = 0 if ( grep /^\Q$sact\E$/, @access_make );
        if ($denied) {
            $body = list_tests();
        }
        else {
            no strict 'refs';
            &{$sact}();
        }
    }

    my %replace = (
        menu    => generate_menu(),
        title_d => $title_d,
        act     => $act,
        body    => ( mesg() . $body ),
        bottom  => '',
        footers => generate_footers(),
    );
    tpl( "./tpl/test/desktop.html", \%replace );
}

sub list_tests() {
    $body = '';

    my ( %hScore, @result );
    $q =
      sqlpcms "SELECT score,date_start,penalty,tid FROM test_users_execution t
    WHERE t.uid = $guid AND t.date_stop IS NOT NULL AND
      t.penalty = (SELECT MAX(t1.penalty) FROM test_users_execution t1
      WHERE t1.uid = t.uid AND t1.tid = t.tid)",
      { ib_timestampformat => '%H:%M %d.%m.%Y' };
    while ( @result = $q->fetchrow_array() ) {
        $hScore{ $result[3] } = [@result];
    }

    my $SQL = '';
    $SQL = qq[AND atype != 10
   AND ( (cast('NOW' AS TIMESTAMP) between date_start AND date_stop) or
         (cast('NOW' AS TIMESTAMP) >= date_start AND date_stop IS NULL) )
   AND ( (atype = 4 AND afor = $guid)];

    if ( $ggid == 4 ) {
        $q = sqlp(
"SELECT sp_class_subgrp_ref.id FROM sp_class_subgrp, sp_class_subgrp_ref
    WHERE sp_class_subgrp.id = sp_class_subgrp_ref.id AND sp_class_subgrp.uid = $guid"
        );
        while ( @result = $q->fetchrow_array() ) {
            $SQL .= "or (atype = 3 AND afor = $result[0])";
        }

        my $class_id = get_pupil_class(0);
        $SQL .= "or (atype = 2 AND afor = $class_id)";

        my $paralel = sqlff(
"SELECT paralel FROM sys_matrix WHERE class = $class_id AND sys_matrix.view_class = 7
    AND exists ( select 1 from get_node_saldo (sys_matrix.node_id, 'NOW', 0) where saldo_sum <> 0)"
        );
        $SQL .= "or (atype = 1 AND afor = $paralel) )";
    }
    elsif ( isadmin() ) {
        $SQL = '';
    }
    else {
        $SQL .= "or (atype = 5 AND afor = $ggid) )";
    }

    my %tid_a;
    %tid_a = ();
    $q = sqlpcms "SELECT DISTINCT tid, date_start, date_stop FROM test_access
  WHERE publish = 1 $SQL", { ib_timestampformat => '%d.%m.%Y' };
    while ( @result = $q->fetchrow_array() ) {
        $tid_a{ $result[0] } = [ $result[1], $result[2] ];
    }
    $SQL = '';
    for ( keys %tid_a ) {
        $SQL .= ($SQL) ? ",$_" : $_;
    }

    if ( isadmin() ) {
        $SQL = '';
    }
    else {
        if ( scalar keys %tid_a > 0 ) {
            $SQL =
              ( length($SQL) > 0 )
              ? "WHERE status = 1 and (autor = $guid OR id in ($SQL))"
              : '';
        }
        else {
            $SQL = 'WHERE 1=2';
        }
    }

    $q = sqlpcms "SELECT id, name, penalty_test, maxtime, status, null, null
    FROM test_test $SQL ORDER BY id DESC";

    my ( $date_txt, $count_txt );
    $count_txt = 0;
    while ( @result = $q->fetchrow_array() ) {
        if ( $tid_a{ $result[0] }[0] ) {
            push @result, @{ $tid_a{ $result[0] } };
        }

        if ( defined $result[7] ) {
            my @tmp = split /\./, $result[7];
            $tmp[1]    = $mnths[ $tmp[1] - 1 ];
            $result[7] = ( $tmp[0] + 0 ) . ' ' . $tmp[1] . ' ' . $tmp[2];
            $date_txt  = " $result[7]";

            if ( $result[8] ) {
                my @tmp = split /\./, $result[8];
                $tmp[1]    = $mnths[ $tmp[1] - 1 ];
                $result[8] = ( $tmp[0] + 0 ) . ' ' . $tmp[1] . ' ' . $tmp[2];
                $date_txt .= "<br> $result[8]";
            }

            $result[1] =
              qq[<a href="#" onClick="start_test($result[0])">$result[1]</a>];
        }
        else {
            $date_txt =
qq[<font color='#DD2200'>  &nbsp;&nbsp;</font>];
            $result[1] = qq[<b>$result[1]</b>];
        }

        if ( $result[3] > 0 ) {
            $result[3] = time2str( $result[3] );
        }
        else {
            $result[3] = '';
        }

        $date_txt .=
          $result[4]
          ? ''
          : q[<br><font color="#DD2200">   ()</font>];
        $date_txt .=
          $hScore{ $result[0] }[0]
          ? qq[<br><br><font color="#0646CC">   <b>$hScore{$result[0]}[0]</b> <br>$hScore{$result[0]}[1]]
          . '</font>'
          : '';

        $body .= qq[<tr valign="top">
    <td class=list_test>$result[1]
    <div class=hr_></div>
       <b>$result[2] ]
          . ( declension( $result[2], [ "", "", "" ] ) )
          . qq[</b>  <br>
        <b>$result[3]</b>
    </td>
    <td width="210">$date_txt</td>
    </tr>];
        $count_txt++;
    }

    $bottom = '';
    if ( $count_txt > 0 ) {
        $body =
qq[<tr valign="top" style="border-bottom: 1px solid #D6D6D6; padding:6px 3px; font-size:12px; background-color:#E0E0E0;">
    <td width="80%"><b> </b></td>
    <td nowrap><b> &nbsp;</b></td>
    </tr>$body];

        my $tmp = $gconf{'sp'} . "?act=$act&sact=expandedinfo&id=";
        $bottom = qq[<script type="text/javascript">
function start_test(id){redir("$tmp"+id);}
</script>];
    }
    else {
        $body =
qq[<tr><td colspan=2 align=center><b>   </b></td></tr>];
    }

    tpl(
        "./tpl/test/desktop_row.html",
        {
            width   => "'75%' class='d list_tests'",
            title_d => " ",
            act     => $act,
            body    => (
                    tpl_str('./tpl/test/available_test_filter.html') 
                  . mesg()
                  . $body
            ),
            header  => '',
            bottom  => $bottom,
            menu    => generate_menu(),
            footers => generate_footers(),
        }
    );
}

sub expandedinfo() {
    sec_gteq0 $id;
    $body = $bottom = '';

    my ( $SQL, @text_to_form, $uid, $penalty_limitN, $penalty_limit, $quest_num,
        @a, @result );
    @text_to_form   = ();
    $penalty_limitN = 0;
    $uid            = $guid;
    my $maccess = maketest_access($id);
    if ( $maccess >= 1 ) {
        $SQL = '';
    }
    else {
        $SQL = "AND
     ((cast('NOW' as TIMESTAMP) between date_start AND date_stop) or
      (cast('NOW' AS TIMESTAMP) > date_start AND date_stop IS NULL))
     AND test_access.publish = 1
     AND (test_test.status = 1 OR test_test.autor = $uid OR
     EXISTS (SELECT 1 FROM test_access_teacher WHERE tid = test_test.id AND status >= 1) )";
    }

    @result = sqlfcms
      "SELECT first 1 test_test.id, test_test.name, test_access.date_start,
     test_access.date_stop, test_access.publish, penalty_test, maxtime, annotation, status,
     test_test.answer_num, test_test.loc
  FROM test_test, test_access
  WHERE test_test.id = test_access.tid AND test_test.id = $id $SQL";

    if ( !$result[0] ) { redir $act; }

    if ( param('uid') and $maccess >= 1 ) {
        $uid = param('uid');
        $body = q[<tr><td><b></b>: ] . ( human_hash($uid) ) . q[</td></tr>];
    }

    $body .=
qq[<tr><td><div style="padding: 6px 0pt; font-size: 15pt;" class="c g">&laquo;$result[1]&raquo;</div></td></tr>];

    if ( !$result[8] ) {
        $body .=
q[<tr><td><font color="#dd2200">      ()</font></td></tr>];
    }

    $quest_num = sqlffcms
      "SELECT COUNT(1) FROM test_question_list WHERE publish = 1 and tid = $id";

    if ( $quest_num > 0 and not defined param('uid') ) {

        $penalty_limit = $penalty_limitN =
          $result[5] -
          ( sqlffcms
"SELECT MAX(penalty) FROM test_users_execution WHERE uid = $uid AND tid = $id"
              || 0 );

        if ( $penalty_limit == $result[5] ) {
            $penalty_limit =
                qq[  <span class="s5 g">$penalty_limit</span> ]
              . ( declension( $result[5], [ "", "", "" ] ) )
              . q[  ];
        }
        elsif ( $penalty_limit < 1 ) {
            $penalty_limit = qq[  ]
              . (
                declension(
                    $result[5],
                    [
                        " ",
                        " <span class='s1 g'>$result[5]</span> ",
                        " <span class='s1 g'>$result[5] "
                    ]
                )
              ) . q[  ];
            if ( $result[5] == 2 ) {
                $penalty_limit =
                  qq[     ];
            }
        }
        else {
            $penalty_limit =
              qq[   <span class='s5 g'>$penalty_limit</span> ]
              . (
                declension(
                    $penalty_limit, [ "", "", "" ]
                )
              ) . q[  ];
        }
        $body .= qq[<tr><td nowrap>$penalty_limit</td></tr>];

        if ( $result[6] > 0 ) {
            $result[6] = time2str( $result[6] );
            $result[6] =
qq[  <span class="s2 g">$result[6]</span>   ];
        }
        else {
            $result[6] = qq[    ];
        }
        $body .= qq[<tr><td nowrap>$result[6]</td></tr>];

        my $temp = '';
        if ( $result[9] and $quest_num > $result[9] ) {
            $temp      = "  <span class='s3 g'>$quest_num</span> ";
            $quest_num = $result[9];
        }
        $body .=
            qq[<tr><td><span class="s1 g">$quest_num</span> ]
          . ( declension( $quest_num, [ "", "a", "" ] ) )
          . "  $temp</td></tr>";

        if ( $result[7] ) {
            $body .=
              qq[<tr><td><div class="text_desc">$result[7]</div></td></tr>];
        }

    }
    elsif ( defined param('uid') and $maccess >= 1 ) {
    }
    else {
        $body .=
q[<tr><td><h2><font color="#dd2200">   .</font></h2></td></tr>];
    }

    my $Test_Exec = cookie("SP_TestExecution") || 0;
    if ( $Test_Exec =~ m/^\d+$/ and $Test_Exec > 0 or $Test_Exec < 4294967295 )
    {
        $q = sqlfcms "SELECT 1
	FROM test_users_execution LEFT JOIN test_test ON
	test_users_execution.tid = test_test.id
	WHERE test_users_execution.uid = $guid
	AND test_users_execution.id = $Test_Exec
	AND date_stop IS NULL
	AND IIF(maxtime = 0, 1, IIF(date_start + maxtime/86400.000000000 > CAST('NOW' as timestamp), 1, 0) ) = 1";
        if ($q) {
            $bottom .=
qq[<div align="center" id="ButtonStartStop"><br><form method="post" id="StartTest">
<input name="act" type="hidden" value="$act">
<input name="sact" type="hidden" value="start_test">
<input name="goexe" type="hidden" value="$Test_Exec">
<input name="id" type="hidden" value="$id">
<button type="button" onClick="start_test($result[0])"><dl class=exe></dl>&nbsp;   </button>
<script type="text/javascript">function start_test(id) {e('StartTest').submit();}</script>
</form><br></div>];
        }
        else {
            $Test_Exec = 0;
        }
    }

    unless ($Test_Exec) {
        $bottom .= '<div ';
        unless ($penalty_limitN > 0
            and $quest_num > 0
            and !( param('uid') and $maccess >= 1 )
            and access_test_islocale( $result[10] ) )
        {
            $bottom .= 'style="display:none;"';
        }
        $bottom .=
qq[ align="center" id="ButtonStartStop"><br><form method="post" id="StartTest">
<input name="act" type="hidden" value="$act">
<input name="sact" type="hidden" value="start_test">
<input name="id" type="hidden" value="$id">
<button type="button" onClick="start_test($result[0])"><dl class=traffic-light></dl>  </button>
<script type="text/javascript">function start_test(id) {e('StartTest').submit();}</script>
</form><br></div>];
    }

    $q = sqlpcms "SELECT id, date_start, date_stop, penalty, score, time_e
     FROM test_users_execution WHERE uid = $uid and tid = $id ORDER BY penalty DESC",
      { ib_timestampformat => '%A %d.%m.%Y %H:%M' };
    while ( @result = $q->fetchrow_array() ) {
        if ( $Test_Exec eq $result[0] ) { next; }
        push @a, [@result];
    }

    if (@a) {
        $bottom .=
q[<br><table class="d" width="45%" align="center" border="0" cellspacing="0" cellpadding="3"><tr>
    <th colspan=5 class=def>   </th></tr>];

        $bottom .=
q[<tr align="center"><td><b>&nbsp;&nbsp;</b></td><td width='100%'><b>&nbsp;&nbsp;</b></td><td><b>&nbsp;&nbsp;</b></td>];
        if ( $maccess == 2 ) { $bottom .= '<td></td>';
        }
        $bottom .= '</tr>';

        my $tmp =
          param('ref') ? '&ref=' . param('ref') . '&tab=' . param('tab') : '';
        for (@a) {
            $$_[4] = $$_[4] ? $$_[4] : '<font color="red"></font>';
            if ( $$_[4] < 3 && $$_[4] > 0 ) {
                $$_[4] = "$$_[4], <font color='red'></font>";
            }
            elsif ( $$_[4] >= 3 ) {
                $$_[4] = "<b>$$_[4]</b>";
            }
            else {
                $$_[4] = '<font color="red"></font>';
            }
            $bottom .=
qq[<tr onmouseout="m_out(this);" onmouseover="m_over(this);" class="hand" id=$$_[0]><td align='right' onClick="totals_score('$$_[0]$tmp')">&nbsp; $$_[3]</td><td align="center" onClick="totals_score('$$_[0]$tmp')" nowrap>$$_[1]</td>
      <td onClick="totals_score('$$_[0]$tmp')" nowrap>$$_[4]</td>];
            if ( $maccess == 2 )
            { $bottom .=
qq[<td class="c"><dl class="del" onClick="hd('$$_[0]$tmp')"></dl></td>];
            }
            $bottom .= '</tr>';
        }

        $bottom .= '</table><br>';
    }

    if ( $maccess == 2 ) {
        $bottom .= qq[<script type="text/javascript">
	function hd(tv){if(confirm('    ?')){getContent(0,'sp.cgi?act=$act&sact=executetest_del_act&id='+tv,'fhd');}}
	function fhd(tv){e(tv).style.display='none';}
	</script>];
    }

    tpl(
        "./tpl/test/desktop_row.html",
        {
            width   => "70% class=t",
            title_d => "   ",
            act     => $act,
            body    => $body,
            header  => '',
            bottom  => $bottom,
            menu    => generate_menu(),
            footers => generate_footers(),
        }
    );
}

sub start_test() {
    if ( $ENV{"REQUEST_METHOD"} ne 'POST' ) { redir("$act&sact=&mesg=ban"); }
    sec_gteq0 $id;

    my $SQL = '';
    if ( !isadmin() ) {
        $SQL = "AND (t.status = 1 OR t.autor = $guid
      or EXISTS (SELECT 1 FROM test_access_teacher WHERE tid = t.id and status >= 1) )
      AND a.publish = 1 AND (
      (cast('NOW' as TIMESTAMP) between date_start and date_stop) OR
      (cast('NOW' AS TIMESTAMP) > date_start AND date_stop IS NULL))";
    }
    my ( $maxP, $locP, $MaxTime, $oldExec ) =
      sqlffcms "SELECT penalty_test, loc, maxtime,
  (SELECT MAX(penalty) FROM test_users_execution WHERE uid = $guid AND tid = $id)
  FROM test_test t, test_access a WHERE t.id = a.tid AND t.id = $id $SQL";

    unless ( access_test_islocale($locP) ) {
        redir "$act&mesg=errorend";
    }

    my $Test_Exec = cookie("SP_TestExecution") || 0;
    if ( $Test_Exec and param('goexe') ) {
        sec_gt0 $Test_Exec, 1;

        if (
            param('goexe') == $Test_Exec
            and sqlfcms "SELECT 1
	FROM test_users_execution LEFT JOIN test_test ON
	test_users_execution.tid = test_test.id
	WHERE test_users_execution.uid = $guid
	AND test_users_execution.id = $Test_Exec
	AND date_stop IS NULL
	AND IIF(maxtime = 0, 1, IIF(date_start + maxtime/86400.000000000 > CAST('NOW' as timestamp), 1, 0) ) = 1"
          )
        {
            $oldExec--;
            redir "$act&sact=execute_test&id=" . $Test_Exec;
        }
    }

    if ( $maxP - $oldExec < 1 ) {
        redir "$act&mesg=errorend";
    }

    $oldExec++;
    my $eid = cmsgenid( "GEN_TEST_USERS_EXECUTION_ID", 1 );
    sqlcms
"INSERT INTO test_users_execution (id,tid,uid,date_start,penalty) VALUES ($eid,$id,$guid,'NOW',$oldExec)";

    setcookie( 'SP_TestExecution', $eid, "+\Q$MaxTime\Es" );

    redir "$act&sact=execute_test&id=" . $eid;
}

sub executetest() {
    sec_gteq0 $id;
    my ( $tid, $date_start ) =
      sqlfcms
"SELECT tid, date_start FROM test_users_execution WHERE date_stop IS NULL AND id = $id AND uid = $guid",
      { ib_timestampformat => "%s" };
    if ( $tid < 1 ) { redir "$act&mesg=ban"; }

    my ( @penalty_score, $temp, $KeyExe, @ChecksAccess, @result );

    @ChecksAccess = ();
    @ChecksAccess = checks_access($tid);
    if ( $ChecksAccess[0] < 1 ) { redir "$act&sact=&mesg=ban"; }

    $KeyExe = 0;

    $body =
      q[<table width="100%" cellspacing="0" cellpadding="4" id="t_table">];

    my @tmp = split( /\|/, param('key') || '' );
    if ( defined $tmp[1] && $tmp[0] == $id ) {
        sec_gteq0 $tmp[0];
        sec_gteq0 $tmp[1];
        $KeyExe = test_answer_check( $id, $tid, param('key') );
    }

    $q = sqlpcms
"SELECT qid, qtype, questiontext, score, penaltyout, penalty, maxtime, sorts
    FROM (SELECT qid, qtype, maxtime, questiontext, sorts, publish, tid, penalty, score,
    (SELECT max(penalty) FROM test_users_answers ai WHERE ai.eid = $id and ai.qid = q.qid) as penaltyout
    FROM test_question_list q) answ
    WHERE answ.publish = 1 AND answ.tid = $tid AND
    (answ.penalty > answ.penaltyout OR (answ.penaltyout is null) ) AND
    NOT EXISTS (SELECT 1 FROM test_users_answers a WHERE a.qid = answ.qid AND a.eid = $id AND a.incor = 2)
    ORDER BY answ.sorts";

    my @quest_list;
    @quest_list = ();
    while ( @result = $q->fetchrow_array() ) {
        push @quest_list, [@result];
    }
    @quest_list = sort { rand() <=> rand() } @quest_list;

    my $count_quest_no_ans = scalar @quest_list;

    my ( $count_quest_full, $count_quest_num ) = sqlfcms "SELECT
  (SELECT count(qid) FROM test_question_list WHERE publish = 1 and tid = $tid),
  (SELECT answer_num FROM test_test WHERE id = $tid)
  FROM DUAL";
    if ($count_quest_num) {
        $count_quest_no_ans -= $count_quest_full - $count_quest_num;
        $count_quest_full =
          $count_quest_full - ( $count_quest_full - $count_quest_num );
    }

    if ( $count_quest_no_ans < 1 && $KeyExe ) {

        setcookie('SP_TestExecution');

        test_calc_and_cache( $id, $tid );
    }
    elsif ( scalar @quest_list < 1 ) {
        redir "$act&sact=totalsscore&id=$id";
    }
    my @quest_n = @{ $quest_list[0] };

    @penalty_score = ();
    if ( defined $quest_n[4] ) {
        @penalty_score = sqlfcms "SELECT score, maxtime, penalty
    FROM test_question_penalty WHERE qid = $quest_n[0] and penalty = $quest_n[4]";
    }
    else {
        @penalty_score = sqlfcms "SELECT FIRST 1 score, maxtime, penalty
    FROM test_question_penalty WHERE qid = $quest_n[0] ORDER BY penalty ASC";
    }
    unless (@penalty_score) {
        @penalty_score = ( 100, undef, 1 );
    }

    $penalty_score[0] =
      sprintf( "%.0f", ( $quest_n[3] * $penalty_score[0] ) / 100 );

    if ( not defined $penalty_score[1] || $penalty_score[1] < 0 ) {
        $penalty_score[1] = $quest_n[6];
    }

    my $gen_id = cmsgenid( 'gen_test_users_answers_id', 1 );
    $quest_n[4] = sqlffcms
      "SELECT MAX(a.penalty)+1 FROM test_users_answers a, test_users_execution e
    WHERE e.id = $id AND uid = $guid AND e.id = a.eid AND a.qid = $quest_n[0]";

    $quest_n[4] = $quest_n[4] || 1;
    my $keysid = $id . "|" . ( int( rand(143796482) ) + int( rand(46813254) ) );
    sqlffcms
"INSERT INTO test_users_answers (id, eid, qid, date_start, penalty, answers) VALUES
     ($gen_id, $id, $quest_n[0], 'NOW', $quest_n[4], '$keysid' )";

    $q = sqlpcms
      "SELECT aid, answer FROM test_question_answers WHERE qid = $quest_n[0]";

    my ( $OnSubmit, $JS_exec );
    if ( $quest_n[1] != 5 ) {
        rus2obfuskator( \$quest_n[2] );
        $body .= qq[<tr valign="top"><td colspan=2>$quest_n[2]</td></tr>
    <form method="post" name="amsw" onsubmit="SubmitAns(this)">];
    }

    $OnSubmit = 0;
    my @answer_list_sql;
    @answer_list_sql = ();
    while ( @result = $q->fetchrow_array() ) {
        push @answer_list_sql, [@result];
    }
    @answer_list_sql = sort { rand() <=> rand() } @answer_list_sql;

    for (@answer_list_sql) {
        rus2obfuskator( \$$_[1] );
        if ( $quest_n[1] == 1 ) {
            $body .=
qq[<tr valign="top" class="padd_t" onmouseover="m_over(this);" onmouseout="m_out(this);"><td><input name="answer" type="radio" onSelect="clickAns();" onClick="clickAns();" value="$$_[0]" id="$$_[0]"></td><td onClick="clickAns($$_[0]);" width="100%">$$_[1]</td></tr>];
        }
        elsif ( $quest_n[1] == 2 || $quest_n[1] == 3 ) {
            $body .=
qq[<tr valign="top" class="padd_t" onmouseover="m_over(this);" onmouseout="m_out(this);"><td><input name="answer_$$_[0]" type="checkbox" onSelect="clickAns();" onClick="clickAns();" value="1" id="$$_[0]"></td><td onClick="clickAns($$_[0]);" width="100%">$$_[1]</td></tr>];
        }
        elsif ( $quest_n[1] == 5 || $quest_n[1] == 6 ) {
            $quest_n[2] =
qq[<tr valign="top"><td colspan=2><input name="answer_$quest_n[0]" type="text" value="............" size="20" title=" "></td></tr>];
            $quest_n[2] =~ s/s_ANSWER_$$_[0]_s/\Q$temp\E/g;
            $body .= qq[<tr valign="top"><td colspan=2>$quest_n[2]</td></tr>];
        }
        $OnSubmit =
          ( ( $quest_n[1] == 2 || $quest_n[1] == 3 ) && !$OnSubmit )
          ? 1
          : $OnSubmit;
    }

    $penalty_score[1] *= 1000;
    if ( $penalty_score[1] ) {
        $JS_exec = qq[
var time = $penalty_score[1];
function time_ans() {
  if ( time > 0 ) {
    var delta = new Date(time);
    var exec = delta.getMinutes() > 0 ? delta.getMinutes()+' . ' : '';
    exec += delta.getSeconds()+' .';
    e('time_ans').innerHTML = exec;

    var Fdelta = new Date(time_full);
    var GMT = Fdelta.getTimezoneOffset()/60;
    var Fexec = Fdelta.getHours() > -GMT ? Fdelta.getHours()+GMT+' . ' : '';
    Fexec += Fdelta.getMinutes() > 0 ? Fdelta.getMinutes() +' . ' : '';
    Fexec += Fdelta.getSeconds() + ' .';
    e('time_ans_full').innerHTML = Fexec;

    e('time_ans_line').style.width = (time/$penalty_score[1])*100 +'%';
    time -= 50; time_full +=50;
    setTimeout ("time_ans()", 50);
  } else {
    if (e('SubmitTest').disabled != true) {
      amsw.submit();
      SubmitAns(this);
    } else {
      window.location = "?act=$act&sact=execute_test&id=$id";
    }
  }
}
];
    }

    else {
        $JS_exec = q[
function time_ans() {
    var Fdelta = new Date(time_full);
    var GMT = Fdelta.getTimezoneOffset()/60;
    var Fexec = Fdelta.getHours() > -GMT ? Fdelta.getHours()+GMT+' . ' : '';
    Fexec += Fdelta.getMinutes() > 0 ? Fdelta.getMinutes() +' . ' : '';
    Fexec += Fdelta.getSeconds() + ' .';
    e('time_ans_full').innerHTML = Fexec;

    time_full +=1000;
    setTimeout ("time_ans()", 1000);
}
e('time_line').style.display = 'none';
];
    }

    if ($OnSubmit) {
        $JS_exec .= "clickAns(0);";
    }

    $body .= '</table>';

    tpl(
        "./tpl/test/execute_test.html",
        {
            id    => $id,
            act   => $act,
            body  => $body,
            trial => (
                ( $quest_n[5] == 1 )
                ? ''
                : qq[ $quest_n[4]  $quest_n[5]<br>]
            ),
            keysid      => $keysid,
            JS_exec     => $JS_exec,
            count_quest => ( $count_quest_full - $count_quest_no_ans + 1 )
              . '  '
              . $count_quest_full,
            time_exec     => ( time() - $date_start ) * 1000,
            date_start    => $date_start,
            penalty_score => $penalty_score[0],
            menu          => generate_menu(),
            footers       => generate_footers(),
        }
    );
}

sub totalsscore() {
    sec_gteq0 $id;
    my (
        $temp,       @tmp, @execution, $TileExe, @incor,
        $PenaltyNum, $SQL, $tid,       @access,  @result
    );
    if   ( isadmin() ) { $SQL = ''; }
    else               { $SQL = "AND uid = $guid"; }
    @execution = sqlfcms
      "SELECT tid, score, date_start, date_stop, penalty, time_e, caches, uid,
    (SELECT AVG(date_stop-date_start)*86400 FROM test_users_answers WHERE eid = $id)
    FROM test_users_execution WHERE id = $id $SQL",
      { ib_timestampformat => "%d.%m.%Y %H:%M|%s" };

    $tid = $execution[0];
    if ( $tid < 1 and isadmin() ) {
        redir "test_report&sact=report_list&mesg=noexec";
    }
    elsif ( $tid < 1 ) { redir "$act&mesg=ban"; }

    ( $incor[0], $PenaltyNum ) =
      split( /\//, CacheStr( $execution[6], 'answer' ) );

    if (   not defined $execution[6]
        or $PenaltyNum == 0
        or defined param('score') )
    {
        test_calc_and_cache( $id, $execution[0] );

        @execution = sqlfcms
"SELECT tid, score, date_start, date_stop, penalty, time_e, caches, uid,
    (SELECT AVG(date_stop-date_start)*86400 FROM test_users_answers WHERE eid = $id)
    FROM test_users_execution WHERE id = $id $SQL",
          { ib_timestampformat => "%d.%m.%Y %H:%M|%s" };
        $tid = $execution[0];
        if ( $tid < 1 ) { redir "$act&mesg=ban"; }
    }

    @access = ();
    @access = checks_access( $tid, 1 );
    if ( $access[0] < 1 ) { redir "$act&mesg=ban"; }

    my $maccess = maketest_access( $access[0] );

    @tmp = split /\|/, $execution[3];
    $execution[3] = $tmp[0];
    $TileExe = $tmp[1];
    @tmp = split /\|/, $execution[2];
    $execution[2] = $tmp[0];
    $TileExe -= $tmp[1];
    $TileExe = $TileExe > 0 ? time2str $TileExe : "&mdash;";

    $execution[8] = sprintf( "%.0f", $execution[8] );
    $execution[8] = $execution[8] > 0 ? time2str $execution[8] : "&mdash;";

    $execution[1] = 1 if ( not defined $execution[1] );

    $incor[1] = $PenaltyNum - $incor[0];
    $incor[2] = sprintf( "%.0f", ( $incor[0] / $PenaltyNum ) * 100 );
    if ( $incor[0] == 0 ) {
        $incor[0] = q[<span class="s1 g">] . $incor[0] . q[</span>];
        $incor[1] = q[<span class="s5 g">] . $incor[1] . q[</span>];
    }
    else {
        $incor[0] = q[<span class="s5 g">] . $incor[0] . q[</span>];
        $incor[1] = q[<span class="s1 g">] . $incor[1] . q[</span>];
    }

    my @StrCache = split( /\//, CacheStr( $execution[6], 'ball' ) );
    $incor[3] = qq[<span class="s$execution[1] g">$StrCache[0]</span>];
    $incor[4] = qq[<span class="s5 g">$StrCache[1]</span>];
    $incor[5] = sprintf( "%.0f", ( $StrCache[0] / $StrCache[1] ) * 100 );

    $body = qq[<tr>
 <td colspan=2><div class="c g" style="padding:6px 0;font-size:15pt;">&laquo;$access[1]&raquo;</div></td>
</tr>];

    if ( defined param('ref') ) {
        $body .=
            "<tr><td colspan=2>: "
          . human_hash( $execution[7] )
          . "</td></tr>";
    }

    $body .= qq[<tr>
 <td class="score_txt_big">:</td>
 <td><span class="score_big s$execution[1]">$execution[1]</span></td>
</tr>
<tr>
 <td nowrap>  /  :&nbsp;</td>
 <td nowrap>$incor[3] / $incor[4]&nbsp;&nbsp;<font color="#aaaaaa" class="hint" title="  "><b>&nbsp;($incor[5] %)&nbsp;</b></font></td>
</tr>
<tr>
 <td colspan=2 title="  ">
  <div class="proc_score"><div id="proc_score_line" class="line"></div><div class="txt" id=proc_score_v>$incor[5] %</div></div>
 </td>
</tr>
<tr>
 <td>/  :</td>
 <td>$incor[0] / $incor[1]&nbsp;&nbsp;<font color="#aaaaaa" class="hint" title="  "><b>&nbsp;($incor[2] %)&nbsp;</b></font></td>
</tr>
<tr>
 <td>  :</td>
 <td>$PenaltyNum</td>
</tr>
<tr>
 <td nowrap>  :</td>
 <td>$TileExe</td>
</tr>
<tr>
 <td nowrap>   :</td>
 <td>$execution[8]</td>
</tr>
<tr>
 <td nowrap> :</td>
 <td nowrap>$execution[2]</td>
</tr>
<tr>
 <td nowrap>  :</td>
 <td>$execution[4]</td>
</tr>

<tr>
 <td colspan=2><u class='handa dontprint' onClick="av();">  o </u></td>
</tr>
</table>

<div id='tscore_answ' style='display:none;'><table class=d cellspacing='0' cellpadding='3' align=center>
<tr>
 <th> </th>];

    if ( $maccess >= 1 ) {
        $body .= "<th></th><th></th>";
    } $body .= "<th><dl class='clock'></dl></th></tr>";

    my @incors = (
"<dl title='     ' class='cl'></dl><b>&mdash;</b>",
        "<dl class='worn' title=' '></dl>",
        "<dl class='ok' title=' '></dl>"
    );
    my $score_total = 0;
    my $score_max   = 0;
    $gdbcms->{"AutoCommit"} = 0;
    $q = sqlpcms "SELECT ta.id,
	ta.qid,
    ql.questiontext,
	ta.penalty,
    ((ta.date_stop - ta.date_start)*86400),
    ta.incor,
    ta.answers,
	qa.answer,
	ql.qtype,
 	qa.score,
 	ql.score
	FROM test_users_answers ta
	LEFT JOIN test_question_answers qa ON ta.answers = qa.aid
	LEFT JOIN test_question_list ql ON ta.qid = ql.qid
	WHERE eid = $id ORDER BY qid, penalty";
    while ( @result = $q->fetchrow_array() ) {
        $result[4] =
          $result[4] ? time2str( sprintf( "%.0f", $result[4] ) ) : '&mdash;';
        $body .= "<tr><td>";
        if ( $maccess >= 1 ) {
            $score_max = 0;
            if ( $result[8] == 1 ) {
                $score_max = sqlffcms
"SELECT max(score) FROM test_question_answers WHERE qid = $result[1]";
            }
            elsif ( $result[8] == 2 or $result[8] == 3 ) {
                $score_max = sqlffcms
"SELECT sum(score) FROM test_question_answers WHERE qid = $result[1]";
            }

            $body .=
"<a href='?act=maketest&sact=maketest_quest&id=$execution[0]&qid=$result[1]' class='small'>"
              . ( strip_tag \$result[2], 'nohtml' );
            $body .= '</a></td><td>';
            $result[9] = $result[9] || 0;
            if ( $result[5] > 0 and ( $result[8] == 2 or $result[8] == 3 ) ) {
                my $a = sqlpcms
"SELECT score,answer FROM test_question_answers WHERE qid = $result[1] and aid in ($result[6]) ORDER BY score DESC";

                $body .= $incors[ $result[5] ];
                $body .= '&nbsp;&nbsp;<table style="display:inline;">';

                my (@answer);
                while ( @answer = $a->fetchrow_array() ) {
                    if ( $result[8] == 2 ) {
                        $result[9] =
                            $answer[0] > 0
                          ? $result[9] + $answer[0]
                          : $result[9] - $result[10];
                    }
                    $body .=
                        '<tr><td>'
                      . ( strip_tag \$answer[1], 'nohtml' )
                      . '</td><td><div title="'
                      . ( $answer[0] > 0
                        ? qq[  ">$incors[2]</div>]
                        : qq[  ">$incors[1]</div>] )
                      . '</td></tr>';
                }
                $body .= '</table>';

                if ( $result[8] == 3 ) {
                    $result[9] = $score_max;
                }
                if ( $result[9] < 0 ) { $result[9] = 0; }
            }
            else {
                $body .=
                  $incors[ $result[5] ]
                  . ( $result[7] ? strip_tag \$result[7], 'nohtml' : '' );
            }

            $body .=
              "</td><td>$result[9] <span class='grays'> $score_max</span>";
        }
        else {
            $body .= strip_tag \$result[2], 'nohtml';
        }
        $body .= '</td>';
        $body .= "<td>$result[4]</td></tr>";
    }
    $body .= q[</table></div>];
    $gdbcms->{"AutoCommit"} = 1;

    my $bottom =
q[<br><table cellspacing="0" cellpadding="4" align="center" class="memu_bar dontprint"><tr>];
    if ( $maccess >= 1 ) {
        my $tmp =
          param('ref')
          ? '&ref=' . ( param('ref') || '' ) . '&tab=' . ( param('tab') || '' )
          : '';
        $bottom .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);"><a href="?act=$act&sact=expandedinfo&id=$execution[0]&uid=$execution[7]$tmp"><dl class="notebook48"></dl><div>   </div></a></td>];
        $bottom .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);"><a href="?act=test_report&sact=report_fullscore&id=$execution[0]$tmp"><dl class="stat48"></dl><div>  </div></a></td>];
        if ( $maccess == 2 ) {
            $bottom .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);" onClick="if(confirm('      ?')){redir('sp.cgi?act=$act&sact=totalsscore&score=recal&id=$id','hd')}"><dl class="calkul48"></dl><div>  </div></td>];
            $bottom .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);" onClick="if(confirm('    ?')){getContent(0,'sp.cgi?act=$act&sact=executetest_del_act&id=$id$tmp','hd')}"><dl class="del48"></dl><div>  </div></td>];
        }
    }
    else {
        $bottom .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);"><a href="?act=$act&sact=expandedinfo&id=$execution[0]"><dl class="form48"></dl><div>   </div></a></td>];
        $bottom .=
qq[<td onmouseout="mo(this);" onmouseover="mi(this);"><a href="?act=$act"><dl class="notebook48"></dl><div>   </div></a></td>];
    }

    $bottom .= qq[</tr></table>
<script type="text/javascript">
var tsansw=0;
function av(){e('tscore_answ').style.display=tsansw?'none':'';tsansw=tsansw?0:1;}
var startscore=0;
function score() {
  e('proc_score_line').style.width=startscore +'%';
  e('proc_score_v').innerHTML=startscore +' %';
  if (startscore < $incor[5]) {
    startscore += 1;
    setTimeout("score()",30);
  }
}
setTimeout("score()",50);
function hd(mi){redir('sp.cgi?act=$act&sact=expandedinfo&id=$execution[0]');}
function mi(o){
  o.style.border="1px solid #F5CB82";
  o.style.backgroundColor="#DADBD8";
}
function mo(o){
  o.style.border="1px solid #F1F2EE";
  o.style.backgroundColor="transparent";
}
</script>
];

    my %replace = (
        width   => "40% class=t",
        title_d => "   ",
        act     => $act,
        body    => $body,
        header  => '',
        bottom  => $bottom,
        menu    => generate_menu(),
        footers => generate_footers(),
    );
    tpl( "./tpl/test/desktop_row.html", \%replace );
}

sub test_maketest_desktop () {
    $title_d = " ";
    my @access_make = qw/
      maketest_act maketest_dsmk maketest_quest maketest_deltest maketest_deltest_act
      maketest_tolerance maketest_tolerance_act maketest_tolerance_step2
      make_quest_copy maketest_delquest maketest_timequestupd maketest_timeupd
      aj_make_quest aj_make_quest_act aj_cat_field aj_quest aj_maketest_activate aj_maketest_locint
      massive_operation
      /;

    if ( $sact ne '' ) {
        my $denied;
        $denied = 1;
        $denied = 0 if ( grep /^\Q$sact\E$/, @access_make );
        if ($denied) {
            redir 'maketest';
        }
        else {
            no strict 'refs';
            &{$sact}();
        }
    }
    else {
        maketest_list();
    }

}

sub maketest_list() {
    my (
        $SQL,   $i,      $n,       @a_test, @gid_ref,
        $count, $header, @taccess, $tmp,    @result
    );

    sub is_num { $_[0] =~ /^\d+$/; }
    my ( %h_cat_item_count, %ref_cat_l, %ref_cat_k, %ref_cat_i, $panel_cat,
        %cat_sel, %cat_sd, $sel );
    %cat_sel = %cat_sd = ();
    my $tcat_sel_type  = param('f') || 0;
    my $cat_sel_filter = param('k') || 0;
    $cat_sel_filter = is_num($cat_sel_filter) ? $cat_sel_filter * 1 : 0;
    my $cat_sel_filter_t =
      ( param('t') ? param('t') : cookie("SP_test_thm") || -1 );

    if ( defined param('t') and param('t') == 0 ) {
        setcookie('SP_test_thm');
        $cat_sel_filter_t = -1;
    }
    elsif ( param('t') ) {
        setcookie( 'SP_test_thm', param('t') );
    }

    if ( $tcat_sel_type > 0 and $cat_sel_filter > 0 ) {
        setcookie( 'SP_test_cat', "$tcat_sel_type|$cat_sel_filter" );
    }
    elsif ( defined param('f') ) {
        if ( $tcat_sel_type < 0 ) {
            $tcat_sel_type  = 0;
            $cat_sel_filter = 0;
            setcookie('SP_test_cat');
        }
        else {
            setcookie( 'SP_test_cat', "$tcat_sel_type|$cat_sel_filter" );
        }
    }
    else {
        my @a = split( /[|]/, cookie("SP_test_cat") || '' );
        if ( scalar @a > 1 ) {
            $tcat_sel_type  = $a[0];
            $cat_sel_filter = $a[1];
        }
    }

    sec_gteq0( $cat_sel_filter, 1 );
    sec_gteq0( $tcat_sel_type,  1 );
    if (   $cat_sel_filter_t !~ m/^\d+$/
        or $cat_sel_filter_t < -1
        or $cat_sel_filter_t > 4294967295 )
    {
        $cat_sel_filter_t = -1;
    }

    $q = sqlpcms
"SELECT cat_type,category,COUNT('id') FROM test_test GROUP BY cat_type, category
  UNION SELECT 0,cat_them,COUNT('id') FROM test_test where cat_them is not null GROUP BY cat_them";
    while ( @result = $q->fetchrow_array() ) {
        $h_cat_item_count{ $result[0] }{ $result[1] } = $result[2];
    }

    $cat_sd{1} = $cat_sd{2} = $cat_sd{3} = ' class="dn"';
    $cat_sd{$tcat_sel_type} = '';
    $cat_sel{1} = $cat_sel{2} = $cat_sel{3} = '';
    $cat_sel{$tcat_sel_type} = ' selected';

    my @f_activ;
    $f_activ[3] = param('activ');
    if ( defined $f_activ[3] ) {
        if ( $f_activ[3] == 0 ) {
            setcookie('SP_test_activ');
            $f_activ[0] = undef;
        }
        else {
            $f_activ[0] = $f_activ[3] == 2 ? 1 : 0;
        }
    }
    else {
        $f_activ[3] = cookie("SP_test_activ");
        if ( defined $f_activ[3] ) {
            $f_activ[0] = $f_activ[3] == 2 ? 1 : 0;
        }
    }

    $panel_cat =
      q[<div class="panel"><table width='100%' style="padding:0 4px;"><tr>
  <td width='80'>
   <dl onClick="redir('?act=maketest&activ=2')" title=" ,   " class="checkbox-c"></dl>
   <dl onClick="redir('?act=maketest&activ=1')" title=" ,   " class="checkbox"></dl>
   <dl onClick="redir('?act=maketest&activ=0')" title="  " class="cl"></dl>
  </td>
  <td align="center"><b></b>:

  <select id="cat_type" onchange="sel_categories(e('cat_type').value);">
    <option value="-1"></option>];
    if ( scalar keys %{ $h_cat_item_count{2} } > 0 ) {
        $panel_cat .= qq[<option value="2"$cat_sel{2}></option>];
    }
    if ( scalar keys %{ $h_cat_item_count{3} } > 0 ) {
        $panel_cat .= qq[<option value="3"$cat_sel{3}> </option>];
    }
    if ( scalar keys %{ $h_cat_item_count{1} } > 0 ) {
        $panel_cat .= qq[<option value="1"$cat_sel{1}></option>];
    }
    $panel_cat .= q[</select>&nbsp;&nbsp;];
    my @ref_cat_type = ( '', '', ' -', '  -' );

    if ( scalar keys %{ $h_cat_item_count{2} } > 0 ) {
        $q = sqlp "SELECT lesson_id,name FROM lesson ORDER BY name";
        $panel_cat .=
qq[<select id="cat2" $cat_sd{2} onchange="add_categories('cat2','maketest&f=2')"><option value=0> -  -</option>];
        while ( @result = $q->fetchrow_array() ) {
            unless ( $h_cat_item_count{2}{ $result[0] } ) { next; }
            $sel =
              ( $result[0] == $cat_sel_filter and $tcat_sel_type == 2 )
              ? ' selected'
              : '';
            $panel_cat .=
"<option value='$result[0]'$sel>$result[1] ($h_cat_item_count{2}{$result[0]})</option>";
            $ref_cat_l{ $result[0] } = $result[1];
        }
        $panel_cat .= '</select>';
    }

    if ( scalar keys %{ $h_cat_item_count{3} } > 0 ) {
        $q = sqlp
          "SELECT knowledge_id, name FROM knowledge_area_ref ORDER BY name";
        $panel_cat .=
qq[<select id="cat3" $cat_sd{3} onchange="add_categories('cat3','maketest&f=3')"><option value=0> -  -</option>];
        while ( @result = $q->fetchrow_array() ) {
            unless ( $h_cat_item_count{3}{ $result[0] } ) { next; }
            $sel =
              ( $result[0] == $cat_sel_filter and $tcat_sel_type == 3 )
              ? ' selected'
              : '';
            $panel_cat .=
"<option value='$result[0]'$sel>$result[1] ($h_cat_item_count{3}{$result[0]})</option>";
            $ref_cat_k{ $result[0] } = $result[1];
        }
        $panel_cat .= '</select>';
    }

    my @test_categories;
    $q = sqlpcms "SELECT cid, name, ctype FROM test_categories ORDER BY name";
    while ( @result = $q->fetchrow_array() ) {
        push @test_categories, [@result];
    }
    if ( scalar keys %{ $h_cat_item_count{1} } > 0 ) {
        $panel_cat .=
qq[<select id="cat1" $cat_sd{1} onchange="add_categories('cat1','maketest&f=1')"><option> -  -</option>];

        for (@test_categories) {
            if ( $$_[2] == 0 ) {
                unless ( $h_cat_item_count{1}{ $$_[0] } ) { next; }
                $sel =
                  ( $$_[0] == $cat_sel_filter and $tcat_sel_type == 1 )
                  ? ' selected'
                  : '';
                $panel_cat .=
"<option value='$$_[0]'$sel>$$_[1] ($h_cat_item_count{1}{$$_[0]})</option>";
                $ref_cat_i{ $$_[0] } = $$_[1];
            }
        }
        $panel_cat .= '</select>';
    }

    if ( scalar keys %{ $h_cat_item_count{0} } > 0 ) {
        $panel_cat .=
q[&nbsp;&nbsp;<b></b>: <select id="catTh0" onchange="add_categories('catTh0','maketest')"><option value="0"></option>];
        for (@test_categories) {
            if ( $$_[2] == 1 ) {
                unless ( $h_cat_item_count{0}{ $$_[0] } ) { next; }
                $sel = $$_[0] == $cat_sel_filter_t ? ' selected' : '';
                $panel_cat .=
"<option value='$$_[0]'$sel>$$_[1] ($h_cat_item_count{0}{$$_[0]})</option>";
                $ref_cat_i{ $$_[0] } = $$_[1];
            }
        }
        $panel_cat .= '</select>';
    }
    $panel_cat .=
q[</td><td align="right" width='175'><b></b> <input onKeyUp="test_list_search()" onBlur="test_list_search()" id="search_test" type="text" size="15" title="   .     ."></td></tr></table></div>];

    $body = qq[<h1> </h1>
  $panel_cat
  <table class="d admin_list_test" align="center" cellspacing="0" cellpadding="3" width="100%"><tr>
  <th class="def">&nbsp;</th>
  <th class="def">&nbsp;&nbsp;&nbsp;</th>
  <th class="def" width="100%"></th>
  <th class="def" nowrap> ,  &mdash; </th>
  </tr>];

    $q = sqlp(
        'SELECT gid, name FROM sp_gid_ref WHERE EXISTS
      (SELECT 1 FROM sp_users WHERE sp_users.gid = sp_gid_ref.gid) ORDER BY gid'
    );
    while ( @result = $q->fetchrow_array() ) {
        $gid_ref[ $result[0] ] = $result[1];
    }
    $gid_ref[2] = " ";
    $gid_ref[3] = " ";
    $gid_ref[5] = "  ";

    $SQL = "WHERE (autor = 0 OR autor = $guid
    OR EXISTS (SELECT first 1 1 FROM test_access_teacher WHERE tid = test_test.id AND uid = $guid))";
    if ( isadmin() ) { $SQL = ''; }

    if ( $tcat_sel_type > 0 and $cat_sel_filter > 0 ) {
        $SQL .= $SQL ? ' AND ' : 'WHERE ';
        if ( $tcat_sel_type == 3 ) {
            my @a;
            sqlffa \@a, "SELECT lesson_id FROM lesson WHERE knowledge_area = "
              . $cat_sel_filter;
            $SQL .= "(cat_type=2 AND (";
            for ( $i = scalar(@a) - 1 ; $i >= 0 ; $i-- ) {
                $SQL .= "category = $a[$i]" . ( $i > 0 ? ' OR ' : '' );
            }
            $SQL .= ")) OR ";
        }
        $SQL .= " (cat_type = $tcat_sel_type AND category = $cat_sel_filter)";
    }
    if ( $cat_sel_filter_t > 0 ) {
        $SQL .= $SQL ? ' AND ' : 'WHERE';
        $SQL .= " (cat_them = $cat_sel_filter_t)";
    }

    if ( defined $f_activ[0] ) {
        $SQL .= $SQL ? ' AND ' : 'WHERE';
        $SQL .= " status = $f_activ[0]";
    }

    $q = sqlpcms "SELECT id, name, autor, status,
  (SELECT status FROM test_access_teacher WHERE uid = $guid AND tid = test_test.id),
  (SELECT COUNT('id') FROM test_question_list WHERE publish = 1 and tid = test_test.id),
  cat_type, category, cat_them, loc
  FROM test_test $SQL ORDER BY id DESC";

    while ( @result = $q->fetchrow_array() ) {
        push @a_test, [@result];
    }

    my $js_data = q[<script type="text/javascript">NameData = new Array(];
    $count = scalar @a_test;
    for ( $n = 0 ; $n < $count ; $n++ ) {
        $js_data .= ( $n == 0 ? '' : ',' )
          . qq[new Array("$a_test[$n][0]","$a_test[$n][1]")];

        $q =
          sqlpcms "SELECT id, atype, afor, date_start, date_stop, publish FROM
    test_access WHERE tid = " . $a_test[$n][0] . " ORDER BY atype, afor",
          { ib_timestampformat => "%d.%m.%Y %H:%M" };
        my ( $j, $temp, @a_access );
        while ( @result = $q->fetchrow_array() ) {
            push @a_access, [@result];
        }

        $a_test[$n][4] = maketest_access( $a_test[$n][4], $a_test[$n][2] );
        $tmp = $a_test[$n][3] ? "C7FFC7" : "FFC4A1";
        my $tmp1 = $a_test[$n][3] == 1 ? 'checked' : '';
        $tmp1 .= $a_test[$n][4] == 2 ? '' : " disabled='true'";
        $tmp1 .= $a_test[$n][5] > 0  ? '' : " disabled='true'";
        $body .=
qq[<tr id="ti_$a_test[$n][0]"><td id="container_status_color_$a_test[$n][0]" style="background-color: #$tmp" title="     ">
    <input onClick="ak($a_test[$n][0])" id="container_status_$a_test[$n][0]" type='checkbox' $tmp1></td>
    <td onMouseOver='g_menu(event,$a_test[$n][0])' onmouseover="clearTimeout(timerID)" class="menuImg">&nbsp;</td>
    <td class=tit><a href='?act=maketest&sact=maketest_quest&id=$a_test[$n][0]'>]
          . ( $a_test[$n][4] == 2
            ? $a_test[$n][1]
            : "<span class=list_noaccess title='      '>$a_test[$n][1]</span>"
          )
          . ( $DEBUG ? " (id:" . $a_test[$n][0] . ")" : "" )
          . "</a></td>
    <td nowrap>$a_access[0][3] &mdash; "
          . ( defined $a_access[0][4] ? $a_access[0][4] : "&infin;" )
          . "</td></tr>\n";

        $tmp     = '';
        @taccess = ();
        my $tmp2;
        $tmp2 = -1;
        $i    = 1;
        $j    = 0;
        my $count2 = scalar @a_access;
        for (@a_access) {

            if ( $$_[1] == 1 ) {
                push @taccess,
                  ( ( $tmp2 != $$_[1] ) ? '</b><br>:<b> ' : '' )
                  . $$_[2];
                if ( $tmp2 != $$_[1] ) { $tmp2 = $$_[1]; }
            }
            elsif ( $$_[1] == 2 ) {
                $q = sqlff
"SELECT paralel ||'&nbsp;'||(select name from class where class_id = cast(sys_matrix.class as integer))
        FROM sys_matrix, class WHERE class = class_id AND
        class = $$_[2] AND sys_matrix.view_class = 7 AND
        exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)";

                $q =~ s/(.+\").+/$1/;
                push @taccess,
                  ( $tmp2 != $$_[1] ? '</b><br>:<b> ' : '' ) . $q;
                if ( $tmp2 != $$_[1] ) { $tmp2 = $$_[1]; }
            }
            elsif ( $$_[1] == 3 ) {
                my @lesson =
                  sqlf "SELECT lesson.name, sp_class_subgrp_ref.name, c
        FROM sp_class_subgrp_ref, lesson
        WHERE sp_class_subgrp_ref.s = lesson.lesson_id AND id = " . $$_[2];

                if (@lesson) {
                    $q = sqlff
"SELECT paralel ||'&nbsp;'||(select name from class where class_id = cast(sys_matrix.class as integer))
           FROM sys_matrix, class WHERE class = class_id AND
           class = $$_[2] AND sys_matrix.view_class = 7 AND
           exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)";

                    push @taccess,
                        ( $tmp2 != $$_[1] ? "</b><br> $q:<b> " : '' )
                      . $lesson[0] . " "
                      . $lesson[1];
                    if ( $tmp2 != $$_[1] ) { $tmp2 = $$_[1]; }
                }
                else {
                    push @taccess,
"<br><font color='red'><b>!</b>  ( id $$_[2]),    , </font><br>";
                }
            }
            elsif ( $$_[1] == 4 ) {
                push @taccess,
                    ( $tmp2 != $$_[1] ? '</b><br>:<b>' : '' )
                  . '&nbsp; '
                  . human_hash( $$_[2] );
                if ( $tmp2 != $$_[1] ) { $tmp2 = $$_[1]; }
            }
            elsif ( $$_[1] == 5 ) {
                push @taccess,
                  ( $tmp2 != $$_[1] ? '</b><br><b> ' : '' )
                  . $gid_ref[ $$_[2] ];
                if ( $tmp2 != $$_[1] ) { $tmp2 = $$_[1]; }
            }
            else {
                $i--;
            }
            $j++;
            $i++;
        }

        if ( $i <= 1 ) {
            $tmp =
qq[<font color=#FF3300> .</font> <a href="?act=maketest&sact=maketest_tolerance&id=$a_test[$n][0]"></a>];
        }
        else {
            $tmp =
qq[<a href="?act=maketest&sact=maketest_tolerance&id=$a_test[$n][0]">  :</a>]
              . ( join ', ', @taccess );
            if ( length($tmp) > 400 ) { $tmp = qq[<div>$tmp</div>]; }
        }

        $body .=
qq[<tr id="te_$a_test[$n][0]"><td colspan=2 class="br"><dl id="il_$a_test[$n][0]" onClick="il($a_test[$n][0])" class="]
          . ( $a_test[$n][9] ? 'local' : 'internet' )
          . q[" title="  ]
          . (
            $a_test[$n][9] ? '   ' : '   ' )
          . qq["></dl></td>
	<td class="acc">$tmp</td>
	<td class='t r br'>$a_test[$n][5] ]
          . declension( $a_test[$n][5], [ '', '', '' ] ) . qq[<br>
	$ref_cat_type[$a_test[$n][6]] ];
        if    ( $a_test[$n][6] == 1 ) { $body .= $ref_cat_i{ $a_test[$n][7] }; }
        elsif ( $a_test[$n][6] == 2 ) { $body .= $ref_cat_l{ $a_test[$n][7] }; }
        elsif ( $a_test[$n][6] == 3 ) { $body .= $ref_cat_k{ $a_test[$n][7] }; }
        defined $a_test[$n][8]
          and $body .= '<br>' . $ref_cat_i{ $a_test[$n][8] };
        $body .= '<br>'
          . (
            defined $a_test[$n][2] ? human_hash( $a_test[$n][2] ) : '&mdash;' )
          . '</td></tr>';
    }

    $js_data .= qq[);\n</script>\n];

    if ( $n < 1 ) {
        $body .=
q[<tr><td colspan="4" nowrap align="center"> , <a href="?act=maketest&sact=maketest_dsmk">  </a></td>];
    }

    $body .=
q[</table><div id="g_menu_container" onmouseover="clearTimeout(timerID)" onmouseout="timerID=setTimeout('g_hidemenu()',800)"></div>
  <script type="text/javascript">
  function ak(id){getContent(0,'sp.cgi?act=maketest&sact=aj_maketest_activate&id='+id,'g_container_status');}
  function il(id){getContent(0,'sp.cgi?act=maketest&sact=aj_maketest_locint&id='+id,'g_container_locint');}
  </script>];

    my %replace = (
        act     => $act,
        body    => ( mesg() . $body ),
        bottom  => $js_data,
        menu    => generate_menu(),
        footers => generate_footers()
    );
    tpl( "./tpl/test/desktop_tab.html", \%replace );
}

sub maketest_dsmk() {
    sec_gteq0 $id, 1;
    my ( @bodytab, @PassMark, @users_all, @result, $maccess, $tmp, @qa );

    if ( $id > 0 ) {
        my $SQL = '';
        unless ( isadmin() ) {
            $SQL =
"AND (test_test.autor = 0 OR test_test.autor = $guid OR uid = $guid)";
        }
        @qa =
          sqlfcms "SELECT test_test.status, test_test.name, test_test.maxtime,
      test_test.penalty_test, test_test.penalty_qest, test_test.autor,
      test_test.annotation, test_test.passmark, test_access_teacher.status,
      test_test.cat_type, test_test.category, test_test.answer_num, test_test.loc,
      test_test.cat_them, test_test.administrative
      FROM
      test_test LEFT JOIN test_access_teacher ON test_test.id = test_access_teacher.tid
      WHERE test_test.id = $id $SQL";

        $maccess = maketest_access( $qa[8], $qa[5] );
    }
    else {
        @qa = (
            0, '', 0, 1, 1, $guid, '', '1=0|2=45|3=67|4=79|5=91', '', '1', '1',
            0
        );
        $maccess = 2;
    }
    if ( $maccess < 1 ) {
        redir "maketest";
    }

    $qa[2] = $qa[2] / 60;

    $qa[49] = human_hash( $qa[5] );

    my @PM = split /\|/, $qa[7];
    for (@PM) {
        push @PassMark, [ split /=/, $_ ];
    }
    my $max = @PassMark;
    $qa[50] = '';
    for ( my $i = 0 ; $i < $max ; $i++ ) {
        if ( $i == $max - 1 ) {
            $PassMark[$i][2] = 100;
        }
        else {
            $PassMark[$i][2] = $PassMark[ $i + 1 ][1] - 1;
            if ( $PassMark[$i][2] < 1 ) { $PassMark[$i][2] = 0; }
        }

        $qa[50] .=
qq[<tr><td><input name="test_passmark_$i" emsg='     ' value="$PassMark[$i][1]" type="text" size="2" maxlength="2" id="min_$i" class='def']
          . ( $i == 0
            ? " readonly='true' disabled='true'"
            : qq[ alt='number' onBlur="passmark_s($i)" onKeyUp="passmark_s($i)"]
          )
          . qq[></td><td><input value="$PassMark[$i][2]" type="text" size="2" class="def read" disabled="true" readonly="true" id="max_$i"></td>
            <td class="c g">$PassMark[$i][0]</td></tr>];
        if ( $i > 100 ) { last; }
    }

    my ( @gid_ref, %atu_list );
    $q = sqlp(
        'SELECT gid, name FROM sp_gid_ref WHERE EXISTS
        (SELECT 1 FROM sp_users WHERE sp_users.gid = sp_gid_ref.gid) ORDER BY gid'
    );
    while ( @result = $q->fetchrow_array() ) {
        $gid_ref[ $result[0] ] = $result[1];
    }

    $qa[51] = q[<div id="UsersBl" class="yui-skin-sam"></div>];

    $q = sqlpcms "SELECT uid, status FROM test_access_teacher WHERE tid = "
      . ( $id ? $id : 0 );
    while ( @result = $q->fetchrow_array() ) {
        $atu_list{ $result[0] } = $result[1];
    }

    $q = sqlp "SELECT sp_users.uid,
       human.last_name ||' '|| human.first_name ||' '|| human.middle_name, sp_users.gid
       FROM sp_users, human WHERE sp_users.uid = human.human_id AND
       (sp_users.gid > 1 and sp_users.gid <= 3) AND sp_users.uid != $guid
       ORDER BY sp_users.gid, human.last_name, human.first_name, human.middle_name";
    my $sel;
    my $key       = 0;
    my @color_sel = (
        "<font srt='0' color='#777777'><b></b></font>",
        "<font srt='1' color='#11AD11'><b> </b></font>",
        "<font srt='2' color='#D46300'><b></b></font>"
    );
    while ( @result = $q->fetchrow_array() ) {
        if ( !defined $atu_list{ $result[0] } || $atu_list{ $result[0] } < 1 ) {
            $atu_list{ $result[0] } = 0;
        }
        $qa[51] .=
qq[<input name='$result[0]' value='$atu_list{$result[0]}' id='$key' type='hidden'>];
        $sel = $color_sel[ $atu_list{ $result[0] } ];
        $qa[52] .= ( $key != 0 ) ? ",\n" : "";
        $qa[52] .=
          qq[{st:"$sel", fio:"<b>$result[1]</b>",gid:"$gid_ref[$result[2]]"}];
        $key++;
    }

    my ( @cat_sel, @cat_sd );
    @cat_sel = @cat_sd = ();
    $cat_sel[1] = $cat_sel[2] = $cat_sel[3] = '';
    $cat_sel[ $qa[9] ] = ' selected';
    $qa[53] =
qq[<select name="cat_type" onchange="add_categories('cat_type');sel_categories(e('cat_type').value)" id="cat_type">
    <option value="2"$cat_sel[2]></option>
    <option value="3"$cat_sel[3]> </option>
    <option value="1"$cat_sel[1]></option>
    <option value="0">&nbsp;&nbsp; + </option>
  </select>&nbsp;&nbsp;
  ];

    $cat_sd[1] = $cat_sd[2] = $cat_sd[3] = ' alt="" class="dn"';
    $cat_sd[ $qa[9] ] = ' alt="select"';

    $q = sqlp "SELECT lesson_id, name FROM lesson ORDER BY name";
    $qa[53] .=
qq[<select name="cat2" id="cat2" $cat_sd[2] onchange="add_categories('cat2')" emsg='    '><option value='-1'> -  -</option>];
    while ( @result = $q->fetchrow_array() ) {
        $sel = ( $result[0] == $qa[10] and $qa[9] == 2 ) ? ' selected' : '';
        $qa[53] .= "<option value='$result[0]'$sel>$result[1]</option>";
    }
    $qa[53] .= '</select>';

    $q = sqlp "SELECT knowledge_id, name FROM knowledge_area_ref ORDER BY name";
    $qa[53] .=
qq[<select name="cat3" id="cat3" $cat_sd[3] onchange="add_categories('cat3')" emsg='    '>];
    $qa[53] .= qq[<option value='-1'> -  -</option>];

    while ( @result = $q->fetchrow_array() ) {
        $sel = ( $result[0] == $qa[10] and $qa[9] == 3 ) ? ' selected' : '';
        $qa[53] .= "<option value='$result[0]'$sel>$result[1]</option>";
    }
    $qa[53] .= '</select>';

    my @test_categories;
    $q = sqlpcms "SELECT cid, name, ctype FROM test_categories ORDER BY name";
    while ( @result = $q->fetchrow_array() ) {
        push @test_categories, [@result];
    }

    if ( $id < 1 ) { $cat_sd[1] = ' alt="selectv"'; }
    $qa[53] .=
qq[<select name="cat1" id="cat1" $cat_sd[1] onchange="add_categories('cat1')" emsg='    '>];
    if ( $id > 0 ) { $qa[53] .= qq[<option value='-1'> -  -</option>]; }
    for (@test_categories) {
        if ( $$_[2] == 0 ) {
            $sel = ( $$_[0] == $qa[10] and $qa[9] == 1 ) ? ' selected' : '';
            $qa[53] .= "<option value='$$_[0]'$sel>$$_[1]</option>";
        }
    }
    $qa[53] .= '</select>';

    $qa[55] =
qq[<select name="catTh0" onchange="add_categories('catTh0');e('catTh_new').className=((e('catTh0').value==0)?'':'dn');" id="catTh0"><option value='-1'> &mdash;</option>];
    for (@test_categories) {
        if ( $$_[2] == 1 ) {
            $sel = ( $$_[0] == $qa[13] ) ? ' selected' : '';
            $qa[55] .= "<option value='$$_[0]'$sel>$$_[1]</option>";
        }
    }
    $qa[55] .= '<option value="0">&nbsp;&nbsp; + </option></select>';

    $tmp =
      $maccess < 2
      ? " <b><font color='ee2222'>( )</font></b>"
      : "";
    $bodytab[0] = qq[<div style="margin: 7px 10px 10px 10px">
    <b>*  </b>: <span class="info" title="     "></span>$tmp<br>
    <input name="test_name" id="test_name" type="text" style="width:100%;margin-top:4px" maxlength="512" class="title" value="$qa[1]" alt='blank' emsg='    '>
    <script type="text/javascript">e('test_name').focus();</script>

    <div class="hr"></div>
    <div style="margin-bottom:4px"><b>     </b>:
      <span class="info" title="<b> </b>  <b> </b>.<br> ."></span></div>
    <textarea name="test_annotation" style="width:100%;" rows="24" id="test_annotation" emsg_="..." alt_="blank">$qa[6]</textarea>
  ];

    if ( $id > 0 ) {
        if ( 0 < sqlffcms
"SELECT count(qid) FROM test_question_list AS q WHERE tid = $id and qtype != 2 and penalty = 1 and NOT EXISTS (SELECT 1 FROM test_question_answers AS a WHERE a.qid = q.qid and a.score > 0)"
          )
        {
            $bodytab[0] .= qq[
      <div style="margin: 10px 0 5px 0;">
        <span class="hint" style="color: red;" title="<h2>!</h2>       .<br>          .">!      .
        <a href="?act=maketest&sact=maketest_quest&id=$id"></a></span>
      </div>];
        }
        else {
            if ( sqlffcms
"SELECT COUNT('id') FROM test_question_list WHERE PUBLISH = 1 and tid = $id"
              )
            {
                $bodytab[0] .= q[
       <div style="margin: 10px 0 5px 0;"><label for="test_status">
         <input type="checkbox"]
                  . ( $qa[0] == 1 ? " checked" : "" )
                  . qq[ id="test_status" value="1" name="test_status">&nbsp;<b>     </b>
         <span class="info" title="      " "      ."></span>
       </label></div>];
            }
            else {
                $bodytab[0] .= qq[
       <div style="margin: 10px 0 5px 0;">
            . <a href="?act=maketest&sact=maketest_quest&id=$id&make_quest=1"></a>
       </div>];
            }
        }
    }

    $bodytab[0] .= q[</div>];

    if ( $qa[11] ) {
        $qa[54][2] = " alt='number'";
        $qa[54][1] = '';
        $qa[54][0] = ' checked';
    }
    else {
        $qa[54][2] = ' disabled="disabled"';
        $qa[54][1] = ' checked';
        $qa[54][0] = '';
    }

    if ( $qa[12] ) {
        $qa[12] = " checked";
    }

    $qa[14] = $qa[14] ? " checked" : '';
    if ( !isadmin() ) {
        $qa[14] .= " disabled='disabled'";
    }

    $bodytab[2] = tpl_str(
        "./tpl/test/make_dsmk_seting.html",
        {
            qa2    => $qa[2],
            qa3    => $qa[3],
            qa4    => $qa[4],
            qa11   => $qa[11],
            qa12   => $qa[12],
            qa14   => $qa[14],
            qa49   => $qa[49],
            qa50   => $qa[50],
            qa51   => $qa[51],
            qa52   => $qa[52],
            qa53   => $qa[53],
            qa55   => $qa[55],
            qa54_0 => $qa[54][0],
            qa54_1 => $qa[54][1],
            qa54_2 => $qa[54][2]
        }
    );

    $body =
qq[<form name="maketest" id="maketest_form_id" method="post" onSubmit='return val();' onFocusOut='clearStyle(event.srcElement)'><input name="act" value="$act" type="hidden"><input name="sact" value="maketest_act" type="hidden"><input name="id" value="$id" type="hidden">];

    my @temp =
      $id > 0
      ? [ " ", "&sact=maketest_quest&id=$id", 1 ]
      : '';

    my $next;
    $next = '';
    if ( $maccess > 1 ) {
        $next =
qq[<div class=r><input name="ext_edit_quest" type="hidden" value="1" id="extedit">
    <button type="submit" onClick="e('extedit').value='';"><dl class="ok"></dl></button>
    <button type="submit" title=" <br>"><dl class="exe"></dl></button></div>];
    }
    if ( $id > 0 ) {
        $body .= tab_div(
            [ "1: ",  $bodytab[0], '', $next ],
            [ "2: ", $bodytab[2] ],
            [ "3: ", "&sact=maketest_quest&id=$id", 1 ],
            [
                "4:   ", "&sact=maketest_tolerance&id=$id", 1
            ]
        );
    }
    else {
        $body .= tab_div(
            [ "1: ",  $bodytab[0], '', $next ],
            [ "2: ", $bodytab[2] ],
        );
    }

    $body .= qq[</form>];

    $body .= tpl_str(
        "./tpl/test/make_access_teacher.html",
        {
            js_data     => $qa[52],
            color_sel_0 => $color_sel[0],
            color_sel_1 => $color_sel[1],
            color_sel_2 => $color_sel[2]
        }
    );

    tpl(
        "./tpl/test/desktop_tab.html",
        {
            act     => $act,
            body    => ( mesg() . $body ),
            bottom  => '',
            menu    => generate_menu(),
            footers => generate_footers(),
        }
    );
}

sub maketest_act() {
    sec_gteq0 $id, 1;
    my $maccess;
    if ( defined $id and $id ne '' ) {
        $maccess = maketest_access($id);
    }
    else {
        $maccess = 2;
    }
    if ( $maccess < 2 ) { redir "maketest"; }

    my (
        @bodytab,           $PassMark,          $tmp,
        $idm,               $test_name,         $test_annotation,
        $test_penalty_test, $test_penalty_qest, $test_maxtime,
        $test_status,       $cat_type,          $categories,
        $test_answer_all,   $test_answer_num,   $test_islocale
    );
    $PassMark = $tmp = "";

    $test_name         = escape_tag \param('test_name');
    $test_annotation   = param('test_annotation');
    $test_penalty_test = param('test_penalty_test');
    $test_penalty_qest = param('test_penalty_qest');
    $test_maxtime      = param('test_maxtime');
    $test_status       = param('test_status') == 1 ? 1 : 0;
    $test_answer_num   = param('test_answer_num');
    $test_answer_all   = param('test_answer_all') == 1 ? 1 : 0;
    $test_islocale     = param('test_islocale') == 1 ? 1 : 'NULL';

    $cat_type = sec_gteq0( param('cat_type') );
    if ( $cat_type == 0 ) {
        $categories = param('cat0');
        $categories =~ s!['"/\\]+!!ig;
        $categories = trim($categories);
        if ( length($categories) < 4 ) {
            stop
              "        ";
        }
        my $cid = sqlffcms(
"SELECT cid FROM test_categories WHERE lower(name) LIKE '\U$categories'"
        );
        if ($cid) { $categories = $cid; $cat_type = 1; }

    }
    elsif ( $cat_type >= 1 && $cat_type <= 3 ) {
        $categories = sec_gteq0( param( 'cat' . $cat_type ) );
    }

    sex_gteq0( $test_penalty_test, $test_penalty_qest );

    if ( $test_answer_all or $test_answer_num == 0 ) {
        $test_answer_num = 'NULL';
    }
    else {
        sec_gteq0($test_answer_num);
    }

    if (
           length($test_name) < 3
        or ( $test_penalty_test < 1 and $test_penalty_test > 99 )
        or ( $test_penalty_qest < 1 and $test_penalty_qest > 99 )
        or (    $test_maxtime < 0
            and $test_maxtime =~ /^[0-9]*([,.][0-9]+)?|[0-9]+$/ )
      )
    {
        stop
"          ";
    }

    $test_maxtime = sprintf( "%.0f", $test_maxtime * 60 );

    strip_tag( \$test_annotation, 'html' );

    my $cat_them = param('catTh0');
    if ( $cat_them == -1 ) {
        $cat_them = 'NULL';
    }
    elsif ( $cat_them == 0 ) {
        my $cat_them_new = param('catTh_new');
        $cat_them_new =~ s!['"/\\]+!!ig;
        $cat_them_new = trim($cat_them_new);

        $cat_them = cmsgenid( "GEN_TEST_CATEGORIES_CID", 1 );
        sqlcms(
"INSERT INTO test_categories (cid, name, ctype) values ($cat_them, '$cat_them_new', 1)"
        );
    }
    else {
        sec_gteq0($cat_them);
    }

    if ( $cat_type == 0 ) {
        $idm = cmsgenid( "GEN_TEST_CATEGORIES_CID", 1 );
        sqlcms(
"INSERT INTO test_categories (cid, name) values ($idm, '$categories')"
        );
        $cat_type   = 1;
        $categories = $idm;
    }

    if ( $id > 0 ) {
        $idm = $id;
    }
    else {
        $idm = cmsgenid( "GEN_TEST_TEST_ID", 1 );
    }

    my $max = $gconf{score_max} - $gconf{score_min};
    for ( my $i = 0 ; $i <= $max ; $i++ ) {
        $tmp = $i == 0 ? '0' : param("test_passmark_$i");
        sec_gteq0 $tmp, 1;
        $PassMark .= ( $gconf{score_min} + $i ) . "=" . $tmp;
        if ( $i != $gconf{score_max} - 1 ) { $PassMark .= "|"; }
        if ( $i > 100 ) { last; }
    }

    if ( $id > 0 ) {
        if ( $maccess > 0 ) {
            sqlbcms
              "UPDATE test_test SET status=$test_status, maxtime=$test_maxtime,
       penalty_test=$test_penalty_test, penalty_qest=$test_penalty_qest, passmark = '$PassMark',
       cat_type = $cat_type, category = $categories, cat_them = $cat_them, loc = $test_islocale,
       answer_num = $test_answer_num, name=?, annotation=?"
              . (
                isadmin()
                ?       ( ', administrative='
                      . ( param('test_administrative') == 1 ? 1 : 'NULL' ) )
                : ''
              ) . " WHERE id = $idm", $test_name, $test_annotation;
        }
    }
    else {
        use Digest::MD5 qw(md5_hex);
        my $info_hash .=
          time() . md5_hex( $test_name . $guid . $test_annotation . rand() );

        sqlbcms "INSERT INTO test_test
       (id, status, name, maxtime, penalty_test, penalty_qest, autor, annotation, passmark, cat_type,
       category, cat_them, info_hash, answer_num, loc"
          . ( isadmin() ? ', administrative' : '' ) . ")
       values ($idm, $test_status, ?, $test_maxtime, $test_penalty_test, $test_penalty_qest,
       $guid, ?, '$PassMark', $cat_type, $categories, $cat_them, '$info_hash', $test_answer_num,
       $test_islocale"
          . ( isadmin()
            ? ', ' . ( param('test_administrative') == 1 ? 1 : 'NULL' )
            : '' )
          . ")",
          $test_name, $test_annotation;

        my $start = $gdate;
        my $stop  = todate( time() + 1209600 );
        sqlcms
          "INSERT INTO test_access (tid, atype, date_start, date_stop, publish)
       values ($idm, 10, '$start', '$stop 23:59:59', 1)";
    }

    my ( %auid, $SQL_U, @result );
    $q = sqlpcms "SELECT uid, status FROM test_access_teacher WHERE tid = $idm";
    while ( @result = $q->fetchrow_array() ) {
        $auid{ $result[0] } = $result[1];
    }
    $q = sqlp
"SELECT uid, gid FROM sp_users WHERE ((sp_users.gid >= 2 and sp_users.gid <= 3) or sp_users.gid = 5) AND sp_users.uid != $guid";
    while ( @result = $q->fetchrow_array() ) {
        $tmp = param( $result[0] );
        sec_gteq0 $tmp, 1;
        if (   ( $tmp == 1 || $tmp == 2 )
            && ( $auid{ $result[0] } != $tmp || $auid{ $result[0] } == defined )
          )
        {
            if ( $auid{ $result[0] } == defined ) {
                sqlcms
"INSERT INTO test_access_teacher (tid, uid, status) VALUES ($idm, $result[0], $tmp);";
            }
            else {
                sqlcms
"UPDATE test_access_teacher SET status = $tmp WHERE uid = $result[0] AND tid = $idm";
            }
        }
        elsif ( $tmp == 0 ) {
            sqlcms
"DELETE FROM test_access_teacher WHERE uid = $result[0] AND tid = $idm";
        }
    }

    redir $act
      . "&sact="
      . ( param('ext_edit_quest') == 1
        ? "maketest_quest&id=$idm"
        : "maketest_dsmk&id=$idm&tab=" . param('tab') );
}

sub maketest_tolerance() {
    sec_gteq0 $id;
    my (
        $tmp,        @paralel,    @users_all, $i,
        $gids,       $new_key2,   @onse,      @gid_ref,
        @gid_access, %all_pupils, $hidden,    @result
    );
    $body = '';

    my $access = maketest_access($id);
    if ( $access < 1 ) { redir "$act"; }

    $q = sqlp(
        "SELECT gid, name FROM sp_gid_ref WHERE EXISTS
     (SELECT 1 from sp_users WHERE sp_users.gid = sp_gid_ref.gid) ORDER BY gid"
    );
    while ( @result = $q->fetchrow_array() ) {
        $gid_ref[ $result[0] ] = $result[1];
    }
    $q = sqlpcms
      "SELECT afor, publish FROM test_access WHERE tid = $id and atype = 5";
    while ( @result = $q->fetchrow_array() ) {
        $gid_access[ $result[0] ] = $result[1];
    }

    $q = sqlp
"SELECT class, paralel, (SELECT name from class where class_id = sys_matrix.class)
    FROM sys_matrix
    WHERE view_class = 7 AND
    EXISTS (SELECT 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0) WHERE saldo_sum <> 0)
    ORDER BY CAST(paralel as integer), 3";
    while ( @result = $q->fetchrow_array() ) {
        push @paralel, [@result];
    }
    $q = sqlpcms
      "SELECT afor, publish FROM test_access WHERE tid = $id and atype = 1";
    my %paralel_access;
    while ( @result = $q->fetchrow_array() ) {
        $paralel_access{ $result[0] } = $result[1];
    }
    $q = sqlpcms
      "SELECT afor, publish FROM test_access WHERE tid = $id and atype = 2";
    my %class_access;
    while ( @result = $q->fetchrow_array() ) {
        $class_access{ $result[0] } = $result[1];
    }

    $q = sqlp "SELECT sys_matrix.class, vw_pupil,
   (SELECT trim(last_name)||' '||first_name||' '||middle_name FROM human WHERE human_id = cast(sys_matrix.vw_pupil as integer))
   FROM sys_matrix inner join human on cast(vw_pupil as integer) = human_id
   WHERE sys_matrix.view_class = 1 AND EXISTS (
    SELECT 1 FROM get_node_saldo(sys_matrix.node_id, '$gdate', 0)
    WHERE saldo_sum <> 0
   )";
    while ( @result = $q->fetchrow_array() ) {
        push @{ $all_pupils{ $result[0] } }, [ $result[1], $result[2] ];
    }

    $q = sqlp(
"SELECT sp_users.uid, human.last_name ||' '|| human.first_name ||' '|| human.middle_name as name, gid
    FROM sp_users, human WHERE sp_users.uid = human.human_id AND sp_users.gid > 1 AND sp_users.gid != 4
    ORDER BY gid, name"
    );
    while ( @result = $q->fetchrow_array() ) {
        push @users_all, [@result];
    }
    $q = sqlpcms
      "SELECT afor, publish FROM test_access WHERE tid = $id and atype = 4";
    my %users_access;
    while ( @result = $q->fetchrow_array() ) {
        $users_access{ $result[0] } = $result[1];
    }

    $tmp = $gids = $hidden = '';
    my $new_key = $new_key2 = -1;
    for (@users_all) {
        if ( $new_key != $$_[2] ) {
            $gids .=
qq[var key$$_[2] = new YAHOO.widget.TaskNode("$gid_ref[$$_[2]]", tree.getRoot(), false, false, "grp_$$_[2]");\n];
            $new_key = $$_[2];
        }

        $tmp = 'false';
        if ( defined $gid_access[ $$_[2] ] && $gid_access[ $$_[2] ] == 1 ) {
            $tmp = 'true';
        }
        elsif ( defined $users_access{ $$_[0] }
            && $users_access{ $$_[0] } == 1 )
        {
            $tmp = 'true';
        }
        $gids .=
qq[new YAHOO.widget.TaskNode("$$_[1]", key$$_[2], false, $tmp, "id_$$_[0]");\n];
        $i++;
    }

    $q = sqlp(
"SELECT sp_users.uid, human.last_name ||' '|| human.first_name ||' '|| human.middle_name as name
    FROM sp_users, human WHERE sp_users.uid = human.human_id AND sp_users.gid = 4
    ORDER BY gid, name"
    );
    my %sp_users_paralel;
    while ( @result = $q->fetchrow_array() ) {
        $sp_users_paralel{ $result[0] } = $result[1];
    }

    if ( scalar %sp_users_paralel ) {
        $gids .=
qq[key4 = new YAHOO.widget.TaskNode("", tree.getRoot(), true, true, "grp_4", true);\n];

        my ( @arr, $yui_str );
        for my $par (@paralel) {
            unless ( $all_pupils{ $$par[0] } ) {
                next;
            }

            if ( $new_key2 != $$par[1] ) {
                $gids .=
qq[var key4_$$par[1] = new YAHOO.widget.TaskNode("$$par[1] ", key4, false, false, "par_$$par[1]");\n];
                $new_key2 = $$par[1];
            }

            my $tpr = $$par[1] . " " . $$par[2];
            $tpr =~ s/^(\d+\s{0,}".+").+/$1/o;
            $tpr =~ s/'/&ldquo;/go;
            $tpr =~ s/"/&quot;/go;

            $gids .=
qq[var pupil = new YAHOO.widget.TaskNode("$tpr $$par[0]", key4_$$par[1], false, false, "class_$$par[0]");\n];

            @arr = sort { $$a[1] cmp $$b[1] } @{ $all_pupils{ $$par[0] } };

            for my $class_arr (@arr) {
                $yui_str =
                  $$class_arr[1] . ( $DEBUG ? ' id:' . $$class_arr[0] : '' );
                if ( !defined $sp_users_paralel{ $$class_arr[0] } ) {
                    $yui_str = qq[<span class=gray>$yui_str<\\/span>];
                }

                $tmp = 'false';
                if ( defined $paralel_access{ $$par[1] }
                    && $paralel_access{ $$par[1] } == 1 )
                {
                    $tmp = 'true';
                }
                elsif ( defined $class_access{ $$par[0] }
                    && $class_access{ $$par[0] } == 1 )
                {
                    $tmp = 'true';
                }
                elsif ( defined $users_access{ $$class_arr[0] }
                    && $users_access{ $$class_arr[0] } == 1 )
                {
                    $tmp = 'true';
                }

                $gids .=
qq[new YAHOO.widget.TaskNode("$yui_str", pupil, false, $tmp, "id_$$class_arr[0]");\n];
            }
        }
    }

    my ( $date_begin, $date_end, $time_begin, $time_end, @tb, @te );
    my @date_access =
      sqlfcms
      "SELECT min(date_start), max(date_stop) FROM test_access WHERE tid = $id",
      { ib_timestampformat => '%d.%m.%Y=%H:%M' };
    if ( defined $date_access[0] ) {
        @tb = split /=/, $date_access[0];
        @te = split /=/, $date_access[1];
        $date_begin = $tb[0];
        $date_end   = $te[0];
        $time_begin = $tb[1];
        $time_end   = $te[1];
    }
    else {
        $date_begin = $gdate;
        $date_end   = todate( time() + 1209600 );
        $time_begin = join ':', (localtime)[ 2, 1 ];
        $time_end   = '23:59';
    }

    my %replace = (
        date_begin => $date_begin,
        date_end   => $date_end,
        time_begin => $time_begin,
        time_end   => $time_end,
        hidden     => $hidden,
        gids       => $gids,
        tid        => $id,
        gact       => "?act=" . $act . "&sact",
        sact       => $sact,
    );
    if ( $access < 2 ) {
        $body = tpl_str( "./tpl/test/make_tree_read.html", \%replace );
    }
    else {
        $body = tpl_str( "./tpl/test/make_tree.html", \%replace );
    }

    $body = tab_div(
        [ "1: ",              "&sact=maketest_dsmk&id=$id",     1 ],
        [ "2: ",             "&sact=maketest_dsmk&id=1&tab=1", 1 ],
        [ "3: ",               "&sact=maketest_quest&id=$id",    1 ],
        [ "4:   ", $body ]
    );

    %replace = (
        act     => $act,
        body    => ( mesg() . $body ),
        bottom  => '',
        menu    => generate_menu(),
        footers => generate_footers(),
    );
    tpl( "./tpl/test/desktop_tab.html", \%replace );
}

sub maketest_tolerance_act() {
    sec_gteq0 $id;
    my @key = split /_/, param('key');
    my $checked = param('c') == 1 ? 1 : 0;
    my $start   = param('s1');
    my $stop    = param('s2');
    my $startT  = param('s11') . ':59';
    my $stopT   = param('s21') . ':59';
    my ( $logs, $tmp, %users_all_hash, @result );

    if ( $stop ne '' ) {
        sec_date($stop);
        sec_time($stopT);
        $stop = "'$stop $stopT'";
    }
    else {
        $stop = 'NULL';
    }
    sec_date($start);
    sec_time($startT);
    $start = "'$start $startT'";
    $logs  = '';

    my $access = maketest_access($id);
    if ( $access < 2 ) { aj_print(''); }

    $q = sqlp(
        "SELECT sp_users.uid, gid
    FROM sp_users, human WHERE sp_users.uid = human.human_id AND sp_users.gid > 1 ORDER BY gid"
    );
    while ( @result = $q->fetchrow_array() ) {
        $users_all_hash{ $result[0] } = $result[1];
    }

    if ( $key[0] eq 'grp' ) {
        my ($users_access);
        for ( keys %users_all_hash ) {
            if ( $users_all_hash{$_} == 2 ) {
                $users_access .= ( $users_access ? ',' : '' ) . $_;
            }
        }

        if ( $checked and ( $key[1] != 4 ) ) {
            sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 4 AND afor in ($users_access)";
            sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
        values ($id, 5, $key[1], $start, $stop, 1)";
            $logs .= "set $key[1]- <br>";
        }
        else {
            sqlcms "DELETE FROM test_access WHERE tid = $id AND atype = 5";
            sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 4 AND afor in ($users_access)";
            $logs .= "del $key[1]- <br>";
        }
    }

    elsif ( $key[0] eq 'par' ) {
        my ( $paralel1, $paralel2 ) = paralel_h();
        my ( $pupil1,   $pupil2 )   = pupil_h();

        if ($checked) {
            sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
         values ($id, 1, $key[1], $start, $stop, 1)";
            $logs .= "set $key[1]- <br>";
        }
        else {
            sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 1 and afor = $key[1]";
            $logs .= "del $key[1]- <br>";
        }

        for ( @{ $$paralel1{ $key[1] } } ) {
            unless ( $$pupil1{$_} ) {
                next;
            } sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 2 and afor = $_";

            my $SQL = '';
            for my $i ( @{ $$pupil1{$_} } ) {
                $SQL .= ($SQL) ? ",$i" : $i;
            }
            sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 4 and afor in ($SQL)";
        }
    }

    elsif ( $key[0] eq 'class' ) {
        my ( $paralel1, $paralel2 ) = paralel_h();
        my ( $pupil1,   $pupil2 )   = pupil_h();

        if ($checked) {
            my ( %paralel_access, $coount_access );
            $coount_access = 0;
            my $SQL = join ',', @{ $$paralel1{ $$paralel2{ $key[1] } } };
            $q = sqlpcms
"SELECT afor FROM test_access WHERE tid = $id and atype = 2 and publish = 1 and afor in ($SQL)";
            while ( @result = $q->fetchrow_array() ) {
                $paralel_access{ $result[0] } = 1;
                $coount_access++;
            }

            if (
                scalar( @{ $$paralel1{ $$paralel2{ $key[1] } } } ) ==
                $coount_access + 1 )
            {
                sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
          values ($id, 1, $$paralel2{$key[1]}, $start, $stop, 1)";
                sqlcms "DELETE FROM test_access WHERE tid = $id AND atype = 2";
                $logs .=
"   $$paralel2{$key[1]} ,    , sel ";
            }
            else {
                sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
          values ($id, 2, $key[1], $start, $stop, 1)";
                $logs .= "set ";
            }
        }
        else {
            sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 2 and afor = $key[1]";

            if ( sqlffcms
"SELECT 1 FROM test_access WHERE tid = $id and atype = 1 and publish = 1 and afor = $$paralel2{$key[1]}"
              )
            {
                sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 1 and afor = $$paralel2{$key[1]}";

                for ( @{ $$paralel1{ $$paralel2{ $key[1] } } } ) {
                    if ( $key[1] != $_ ) {
                        sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
               values ($id, 2, $_, $start, $stop, 1)";
                    }
                }
            }
            $logs .= "del ";
        }

        my $SQL = '';
        for my $i ( @{ $$pupil1{ $key[1] } } ) {
            $SQL .= ($SQL) ? ",$i" : $i;
        }
        sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 4 and afor in ($SQL)";

        $logs .= "ID $key[1] <br>";
    }

    elsif ( $key[0] eq 'id' ) {
        my $user_gid =
          sqlff "SELECT gid FROM sp_users WHERE gid > 1 AND uid = $key[1]";
        if ( !defined $user_gid ) {
            $user_gid = sqlff
              "SELECT 4 FROM human WHERE human_id = $key[1] AND class = 1";
            if ( !defined $user_gid ) { aj_print(''); }
        }
        my ( $users_access, %TestAccess, %temp );
        $users_access = '';

        $q = sqlpcms
"SELECT afor FROM test_access WHERE tid = $id and atype = 4 and publish = 1";
        undef %TestAccess;
        while ( @result = $q->fetchrow_array() ) {
            $TestAccess{ $result[0] } = 1;
        }

        if ($checked) {
            undef %temp;
            for ( keys %users_all_hash ) {
                if ( $user_gid == $users_all_hash{$_}
                    && ( !defined $TestAccess{$_} || $TestAccess{$_} != 1 ) )
                {
                    $temp{$_} = $users_all_hash{$_};
                }
            }

            if ( $user_gid != 4 ) {
                if ( ( ( scalar keys %temp ) - 1 ) > 1 ) {
                    sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
           values ($id, 4, $key[1], $start, $stop, 1)";
                    $logs .=
                        "   ..     "
                      . ( ( scalar keys %temp ) - 1 )
                      . "    <br>";
                }
                else {
                    sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
           values ($id, 5, $user_gid, $start, $stop, 1)";
                    sqlcms
                      "DELETE FROM test_access WHERE tid = $id AND atype = 4";
                    $logs .=
"..       $user_gid <br>";
                }
            }
            else {
                my ( $paralel1, $paralel2 ) = paralel_h();
                my ( $pupil1,   $pupil2 )   = pupil_h();

                $tmp = 0;
                my $users_access;
                $users_access = '';
                for ( @{ $$pupil1{ $$pupil2{ $key[1] } } } ) {
                    if ( defined $TestAccess{$_} && $TestAccess{$_} == 1 ) {
                        $users_access .= ( $users_access ? ',' : '' ) . $_;
                        $tmp++;
                    }
                }

                if ( $tmp + 1 == scalar @{ $$pupil1{ $$pupil2{ $key[1] } } } ) {
                    my ( $paralel_full_sel, $paralel_full_SQL );
                    $paralel_full_sel = 1;
                    $paralel_full_SQL = '';
                    for ( @{ $$paralel1{ $$paralel2{ $$pupil2{ $key[1] } } } } )
                    {
                        my $tmp2;
                        if ( $_ != $$pupil2{ $key[1] } ) {
                            $tmp2 = sqlffcms
"SELECT 1 FROM test_access WHERE tid = $id and atype = 2 and afor = $_ and publish = 1";
                            $paralel_full_sel =
                              ( $tmp2 == 1 ) ? $paralel_full_sel : 0;
                            $paralel_full_SQL .=
                              ( $paralel_full_SQL ? ',' : '' ) . $_;
                        }
                    }

                    if ($paralel_full_sel) {
                        sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
             values ($id, 1, $$paralel2{$$pupil2{$key[1]}}, $start, $stop, 1)";

                        sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 2 and afor in ($paralel_full_SQL)";

                        sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 4 AND afor in ($users_access)";
                        $logs .=
"    $$paralel2{$$pupil2{$key[1]}} ..     <br>";
                    }
                    else {
                        sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
             values ($id, 2, $$pupil2{$key[1]}, $start, $stop, 1)";

                        sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 4 AND afor in ($users_access)";
                        $logs .=
"   ID $$pupil2{$key[1]} ..     <br>";
                    }
                }
                else {
                    sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
           values ($id, 4, $key[1], $start, $stop, 1)";
                    $logs .=
"    ID $key[1] ..   ID $$pupil2{$key[1]}    <br>";
                }

            }
        }
        else {
            sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 4 AND afor = $key[1]";

            if ( $user_gid != 4 ) {
                if ( sqlffcms
"SELECT 1 FROM test_access WHERE tid = $id and atype = 5 and afor = $user_gid and publish = 1"
                  )
                {
                    sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 5 and afor = $user_gid";
                    for ( keys %users_all_hash ) {
                        if (    $user_gid == $users_all_hash{$_}
                            and $key[1] != $_ )
                        {
                            sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
                values ($id, 4, $_, $start, $stop, 1)";
                        }
                    }
                    $logs .=
"  ID $user_gid    ,       ,    $user_gid  <br>";
                }
            }
            else {
                my ( $paralel1, $paralel2 ) = paralel_h();
                my ( $pupil1,   $pupil2 )   = pupil_h();

                if ( sqlffcms
"SELECT 1 FROM test_access WHERE tid = $id and atype = 1 and afor = $$paralel2{$$pupil2{$key[1]}} and publish = 1"
                  )
                {
                    for ( @{ $$paralel1{ $$paralel2{ $$pupil2{ $key[1] } } } } )
                    {
                        if ( $_ != $$pupil2{ $key[1] } )
                        { sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
                  values ($id, 2, $_, $start, $stop, 1)";
                        }
                    }
                    sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 1 and afor = $$paralel2{$$pupil2{$key[1]}}";
                    for ( @{ $$pupil1{ $$pupil2{ $key[1] } } } ) {
                        if ( $key[1] != $_ ) {
                            sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
                  values ($id, 4, $_, $start, $stop, 1)";
                        }
                    }
                }
                else {
                    if ( sqlffcms
"SELECT 1 FROM test_access WHERE tid = $id and atype = 2 and afor = $$pupil2{$key[1]} and publish = 1"
                      )
                    {
                        sqlcms
"DELETE FROM test_access WHERE tid = $id AND atype = 2 and afor = $$pupil2{$key[1]}";
                        for ( @{ $$pupil1{ $$pupil2{ $key[1] } } } ) {
                            if ( $key[1] != $_ ) {
                                sqlcms
"INSERT INTO test_access (tid, atype, afor, date_start, date_stop, publish)
                  values ($id, 4, $_, $start, $stop, 1)";
                            }
                        }
                        $logs .=
"  ID $$pupil2{$key[1]}    $key[1],         <br>";
                    }
                }

            }

        }

        $logs .= "     ID $key[1]<br>";
    }

    unless ($DEBUG) { $logs = ''; } aj_print($logs);
}

sub maketest_tolerance_step2() {
    sec_gteq0 $id;
    my $start  = param("date_begin");
    my $stop   = param("date_end");
    my $startT = param('time_begin') . ':00';
    my $stopT  = param('time_end') . ':59';

    my $access = maketest_access($id);
    if ( $access > 1 ) {
        if ( param("infin_ch") ne 1 ) {
            sec_date($stop);
            sec_time($stopT);
        }
        sec_date($start);
        sec_time($startT);

        my ( $d,  $m,  $y )  = split( /\./, $start );
        my ( $d2, $m2, $y2 ) = split( /\./, $stop );

        if ( date('Ymd') < $y . $m . $d ) {
            stop("    ($start $startT)  ");
        }
        elsif ( $y2 . $m2 . $d2 < $y . $m . $d and param("infin_ch") ne 1 ) {
            stop(
"    ($stop $stopT)   ($start $startT)"
            );
        }

        $start .= " $startT";
        if   ( param("infin_ch") eq 1 ) { $stop = 'NULL'; }
        else                            { $stop = "'$stop $stopT'"; }
        sqlcms
"UPDATE test_access SET date_start='$start', date_stop=$stop WHERE tid = $id";
    }

    if ( param('ext_edit_quest') == 1 ) {
        redir "test&sact=expandedinfo&id=$id";
    }
    else {
        redir $act;
    }
}

sub maketest_quest() {
    sec_gteq0 $id;
    my ( @bodytab, $tmp, @questlist, $toolbar, @result );
    @bodytab = ();

    my @qa = sqlfcms "SELECT name, autor,
    (SELECT status FROM test_access_teacher WHERE uid = $guid AND tid = test_test.id),
    passmark, maxtime, penalty_qest, answer_num
    FROM test_test WHERE id = $id";

    my $access = maketest_access($id);
    if ( $access < 1 ) { redir "$act"; }

    $q = sqlpcms "SELECT qid, category, questiontext, qtype, penalty, author,
	publish, maxtime, sorts,
	iif(qtype=2,(SELECT sum(qa.score) FROM test_question_answers qa WHERE qa.qid = test_question_list.qid), score),
	(SELECT count(aid) FROM test_question_answers WHERE qid = test_question_list.qid)
	FROM test_question_list WHERE tid = $id",
      { ib_timestampformat => '%d.%m.%Y %H:%M' };
    while ( @result = $q->fetchrow_array() ) {
        push @questlist, [@result];
    }

    $tmp =
      maketest_access( $qa[2], $qa[1] ) < 2
      ? "<font color='#ee2222'>( )</font>"
      : "";
    $toolbar = '';
    if ( $access == 2 ) {
        $toolbar =
qq[<button type="button" onclick="CreateQuest($id);" id=button_make_quest style="width:158px;"><dl class="plus"></dl> </button>];
    }
    $bodytab[0] =
qq[<div align="center" style="padding: 6px 0"><b><font size="+1">$qa[0]</font> $tmp</b></div>];
    my @tabblok;
    $tabblok[1] = $tabblok[2] = '';

    my @qTypeImg = (
        '-',
        "<i title='   '><dl class='radio nh'></dl></i>",
"<i title='   '><dl class='checkbox nh'></dl></i>",
"<i title='    '><dl class='checkbox-c nh'></dl><dl class='checkbox-c nh'></dl></i>"
    );

    my @qidlistid;
    for (@questlist) {
        push @qidlistid, $$_[0];
        $$_[7] = $$_[7] ? time2str( $$_[7] ) : '&infin;';
        if ( $$_[10] == 0 ) {
            $$_[10] = qq[<font color=red><b>$$_[10]</b></font>];
        }
        $tabblok[1] .=
            "<tr><td><div class='hand "
          . ( $$_[6] ? "'" : "list_noaccess' title='  '" )
          . qq[ onClick="CreateQuest($id,$$_[0]);">]
          . ( strip_tag( \$$_[2], 'nohtml' )
              . ( $DEBUG ? ' (id' . $$_[0] . ')' : '' ) )
          . qq[</div></td>
     <td>$$_[9]</td>
     <td>$$_[10]</td>
     <td>$qTypeImg[$$_[3]]</td>
     <td>$$_[7]</td>
     <td><dl class=del onClick="adel($$_[0])"></td></tr>];
    }

    my @static = sqlfcms "SELECT
  (SELECT count(qid) FROM test_question_list WHERE tid = $id),
  (SELECT count(publish) FROM test_question_list WHERE tid = $id AND publish != 1),
  (SELECT sum(maxtime) FROM test_question_list WHERE publish = 1 and tid = $id),
  (SELECT count(qid) FROM test_question_list AS q WHERE qtype != 2 and tid = $id and penalty = 1 and NOT EXISTS (SELECT 1 FROM test_question_answers AS a WHERE a.qid = q.qid and a.score > 0))
  FROM DUAL";
    $static[2] *= 1;
    $static[11] = $static[2] == 0 ? ' &infin;' : time2str( $static[2] );
    $static[10] = $static[12] = '';
    if ( $qa[4] < $static[2] and $qa[4] != 0 ) {
        $static[10] =
qq[<div style="color:red" class="hint" title="<h2>!</h2>      .<br><br>        ]
          . time2str( $qa[4] )
          . qq[,        $static[11].">!  </div>];
    }

    if ( $static[3] > 0 ) {
        $static[12] =
q[<div style="color:red" class="hint" title="<h2>!</h2>       .             .">!      .</div>];
    }

    if ( $access < 2 ) {
        $static[12] .=
q[<script type="text/javascript">e('timeBatton').style.display='none';</script>];
    }

    my $block_static =
      '  : '
      . ( $qa[6]
        ? qq[<span class="hint" title='        <b>$qa[6]</b>   <b>$static[0]</b> ,   .'>$qa[6]  $static[0]</span>]
        : $static[0] )
      . "<br>"
      . ' : '
      . ( $static[1] == 0 ? ""
        : "<span class='hint' title='  <b>$static[1]</b>  <b>$static[0]</b> '>$static[1]  $static[0]</span>"
      )
      . '<br>'
      . qq[<span title="    -    ." class="hint">  :</span> $static[11]$static[10]$static[12]];

    $bodytab[0] .= tpl_str(
        './tpl/test/make_list.html',
        {
            tabblok1             => $tabblok[1],
            tabblok2             => $tabblok[2],
            rowsJS               => '80',
            tid                  => $id,
            gact                 => "?act=$act&sact",
            sact                 => $sact,
            toolbar              => $toolbar,
            maxtime              => ( sprintf( "%.1f", $qa[4] / 60 ) * 1 ),
            hack_to_width_for_ie => (
                (
                    substr( $ENV{'HTTP_USER_AGENT'}, 0, 127 ) =~
                      /msie (\d+\.\d+)/i
                ) ? 35 : 16
            ),
            static => $block_static
        }
    );

    $body = '';
    my $next =
q[<div class=r><button style="width:220px;" onclick="go(0)" type="button"><dl class=list></dl>   </button>];
    if ( $access > 1 ) {
        $next .=
q[<button onclick="go(1)" type="button" title=" <br>"><dl class=exe></button>];
    }
    $next .= '</div>';

    $tmp = $gconf{'sp'} . "?act=$act&id=$id&sact";
    $next .= qq[<div class=r>
<script type="text/javascript">
  function go(i){
	if(i){redir("$tmp=maketest_tolerance");}else{redir("$tmp");}
  }
  function val() {
	var oEditor = FCKeditorAPI.GetInstance('questiontext');
	var text_inFUCKeditor = oEditor.GetXHTML(true);
	if ( text_inFUCKeditor.length < 12 ) {
		alert('    ');
		return false;
	} else {
		return validateForm(e('makequst_form_id'));
	}
  }\n];
    if ( defined param("make_quest") && param("make_quest") eq '1' ) {
        $next .= "CreateQuest($id)\n";
    }
    $tmp = param("qid");
    if ( defined $tmp and grep( /^\Q$tmp\E$/, @qidlistid ) ) {
        $next .= "CreateQuest($id,$tmp)\n";
    }
    $next .= "</script>";

    $body .= tab_div(
        [ "1: ",  "&sact=maketest_dsmk&id=$id",       1, $next ],
        [ "2: ", "&sact=maketest_dsmk&id=$id&tab=1", 1 ],
        [ "3: ",   $bodytab[0] ],
        [ "4:   ", "&sact=maketest_tolerance&id=$id", 1 ],
    );

    tpl(
        "./tpl/test/desktop_tab.html",
        {
            menu    => generate_menu(),
            act     => $act,
            body    => ( mesg() . $body ),
            bottom  => '',
            footers => generate_footers(),
        }
    );
}

sub maketest_deltest() {
    sec_gteq0 $id;
    if ( maketest_access($id) < 2 ) { redir "$act"; }
    my $name = sqlffcms "SELECT name FROM test_test WHERE id = $id";

    $body =
qq[<br><br><table class="d" align="center" border="0" cellspacing="0" cellpadding="3" width="400">
<tr>
 <th class=def> </th>
</tr>
<tr>
 <td><div style="padding:10px;text-align:justify;">    "<b>$name</b>".<br><br>
      ,    ,               .
 <br><br>
      ?<br>
 <center><a href="]
      . $gconf{sp}
      . qq[?act=$act&sact=maketest_deltest_act&id=$id"><img src="/sp/img/test_del.gif" width="64" height="64"></a></center></div>
</td>
</tr>
</table>];

    my %replace = (
        menu    => generate_menu(),
        act     => $act,
        body    => ( mesg() . $body ),
        bottom  => '',
        footers => generate_footers(),
    );
    tpl( "./tpl/test/desktop_tab.html", \%replace );
}

sub maketest_deltest_act() {
    sec_gteq0 $id;
    if ( maketest_access($id) < 2 ) { redir "$act"; }

    sqlcms "DELETE FROM test_test WHERE id = $id";

    redir "maketest";
}

sub executetest_del_act() {
    sec_gteq0 $id;
    my $access_teacher = sqlfcms "SELECT 1 FROM test_test WHERE id = $id AND
   administrative is null and (test_test.status = 1 or test_test.autor = $guid
   or EXISTS (SELECT 1 FROM test_access_teacher WHERE tid = test_test.id and status >= 1))";

    if ( isadmin() ) {
        sqlcms "DELETE FROM test_users_execution WHERE id = $id";
    }
    elsif ($access_teacher) {
        sqlcms
          "DELETE FROM test_users_execution WHERE id = $id AND uid = $guid";
    }
    else {
        $id = -1;
    }
    aj_print($id);
}

sub maketest_delquest() {
    sec_gteq0 $id;
    my $tid;

    $tid = sqlffcms "SELECT tid FROM test_question_list WHERE qid = $id";
    if ( maketest_access($tid) < 2 ) {
        redir "$act";
    }

    sqlcms "DELETE FROM test_users_answers WHERE qid = $id";
    sqlcms "DELETE FROM test_question_list WHERE qid = $id";

    redir "maketest&sact=maketest_quest&id=$tid";
}

sub maketest_timequestupd() {
    my $id   = sec_gt0( param("id") );
    my $time = trim( param("time") );
    if (   ( $time !~ /^\d+([,.]\d*)?$/ )
        or ( ( $time < 0.5 or $time > 60 ) and $time != 0 ) )
    {
        stop
"  ($time)    ,    0.5  60  0 ()";
    }
    $time = ( sprintf( "%.1f", $time * 60 ) * 1 );
    sqlcms "UPDATE test_question_list SET maxtime = '$time' WHERE tid = $id";

    redir "maketest&sact=maketest_quest&id=$id";
}

sub maketest_timeupd() {
    my $id   = sec_gt0( param("id") );
    my $time = trim( param("time") );
    if (   ( $time !~ /^\d+([,.]\d*)?$/ )
        or ( ( $time < 5 or $time > 480 ) and $time != 0 ) )
    {
        stop
"  ($time)    ,    5  480  0 ()";
    }
    $time = ( sprintf( "%.1f", $time * 60 ) * 1 );
    sqlcms "UPDATE test_test SET maxtime = '$time' WHERE id = $id";

    redir "maketest&sact=maketest_quest&id=$id";
}

sub massive_operation() {
    sec_gteq0 $id;

    if ( maketest_access($id) < 2 ) {
        redir "test_report&sact=report_fullscore&id=$id";
    }
    my $operation = param('operation');

    if ( $operation eq 'score_recal' ) {

        my ( @ExecutionList, @result );
        $q = sqlpcms "SELECT id FROM test_users_execution WHERE tid = $id";
        while ( @result = $q->fetchrow_array() ) {
            push @ExecutionList, $result[0];
        }
        for (@ExecutionList) {
            test_calc_and_cache( $_, $id, 'go' );
        }

    }
    elsif ( $operation eq 'del_all_executetest' ) {
        sqlcms "DELETE FROM test_users_execution WHERE tid = $id";
    }

    redir "test_report&sact=report_fullscore&id=$id";
}

sub aj_cat_field() {
    my $cat = param("c");
    sec_gteq0( $cat, 1 );
    my ( @result, $aj_print, $sel, $row );
    if ( $cat < 1 ) { $cat = 1; }

    my @qtype = (
        "",
        "   <i>n</i> ",
        "      <i>n</i> ",
        "    ",
        "    ,   ",
        " ,    ",
        " ,    "
    );

    $q = sqlpcms "SELECT qid, questiontext, qtype, author, stamp
    FROM test_question_list WHERE category = $cat ORDER BY stamp desc",
      { ib_timestampformat => '%d.%m.%Y %H:%M' };
    my $num_res = 0;
    while ( @result = $q->fetchrow_array() ) {
        $row = $row == 1 ? '' : 1;
        $aj_print .=
          qq[<div class="qestlist$row" onClick="copyQuest($result[0]);"
     onMouseOut="clearTimeout(timerID)"
     onMouseOver="timerID=setTimeout('aj_quest($result[0])',1150)">
     <b>$result[1]</b><br>($qtype[$result[2]])<br>
     : ]
          . human_hash( $result[3] )
          . qq[<div class="qestcopy" title="    ">&nbsp;</div></div>];
        $num_res++;
    }
    $q->finish();

    if ( !$num_res ) { $aj_print = ""; }
    $aj_print = $num_res ? $aj_print : "<b>    </b>";

    aj_print($aj_print);
}

sub aj_quest() {
    sec_gteq0($id);
    my ( @result, $aj_print, $sel, @qa );

    my @qtype = (
        "",
        "   <i>n</i> ",
        "      <i>n</i> ",
        "    ",
        "    ,   ",
        " ,    ",
        " ,    "
    );

    @qa = sqlfcms "SELECT stamp, questiontext, qtype, category, author,
    publish, penalty, maxtime, matteranswer, ver
    FROM test_question_list WHERE qid = $id",
      { ib_timestampformat => '%d.%m.%Y %H:%M' };
    $qa[7] /= 60;
    $qa[5] = $qa[5] ? "" : "";

    $aj_print .= qq[<div id="$id" class="qestinfo">
  <div style="padding:0 0 6px 0;">
  <hr><b>:</b> $qa[1]<hr>
  ($qtype[$qa[2]])<br>
  <b> :</b> $qa[0]<br>
  <b>:</b> ] . human_hash( $qa[4] ) . qq[<br>
  <b> :</b> $qa[7] .<br>
  <b> :</b> $qa[6]<br>
  <b>  :</b> $qa[5]<br>
  <b> :</b> $qa[9]<br>
  </div>];

    $aj_print = $qa[0] ? $aj_print : "<b>   ID  </b>";

    aj_print($aj_print);
}

sub aj_make_quest() {
    sec_gteq0($id);
    my $test_edit = param('edit');
    sec_gteq0( $test_edit, 1 );
    my (
        $aj_print,        @result, @quest_cat,
        $conainer_answer, @style,  $score,
        $score2,          @answer, $tmp
    );

    my $access = maketest_access($id);
    if ( $access < 1 ) { redir "$act"; }
    my $readonly = ( $access < 2 ) ? 1 : 0;

    $q = sqlpcms "SELECT cid, subid, name, info FROM test_question_categories
  WHERE publish = 1 or publish = $guid ORDER BY cid";
    while ( @result = $q->fetchrow_array() ) {
        push @quest_cat, [@result];
    }

    my @qa;
    @qa = ();
    if ($test_edit) {
        my $SQL;
        if ( isadmin() ) {
            $SQL = qq[WHERE test_question_list.qid = $test_edit];
        }
        else {
            $SQL =
qq[LEFT JOIN test_access_teacher ON (test_question_list.tid = test_access_teacher.tid)
       WHERE test_question_list.qid = $test_edit AND
       (test_question_list.author = 0 OR test_question_list.author = $guid OR
       (test_access_teacher.uid = $guid AND test_access_teacher.status >= 1))];
        }

        @qa =
          sqlfcms "SELECT category, questiontext, score, qtype, penalty, author,
    sorts, fck, maxtime, publish FROM test_question_list $SQL";

        $qa[8] /= 60;
        $qa[9] = $qa[9] ? 'checked' : '';

        $q = sqlpcms
"SELECT answer, score, aid FROM test_question_answers WHERE qid = $test_edit ORDER BY aid";
        $tmp = 0;
        while ( @result = $q->fetchrow_array() ) {
            push @answer, [@result];
            ( defined $result[1] && $result[1] > $tmp ) and $tmp = $result[1];
        }

        if ( $qa[3] == 1 or $qa[3] == 3 ) {
            $qa[2] = $tmp;
        }

        $qa[20] = qq[<input name=edit value="$test_edit" type=hidden>];
    }
    else {
        $qa[0] = '';
        $qa[2] = 10;
        $qa[3] = '1';
        $qa[4] = sqlffcms "SELECT penalty_qest FROM test_test WHERE id = $id";
        $qa[8] = 5;
        $qa[9] = 'checked';
    }

    $tmp = '';
    my $max_answer = scalar @answer;
    for ( my $i = 1 ; $i < 21 ; $i++ ) {
        $style[0] = $style[1] = $style[3] = '';
        not defined $answer[ $i - 1 ][1] and $answer[ $i - 1 ][1] = 0;
        if ( !defined $answer[ $i - 1 ][0] ) {
            $answer[ $i - 1 ][0] = $answer[ $i - 1 ][2] = '';
        }
        if ($test_edit) {
            $tmp = $answer[ $i - 1 ][0];
            if ( $i == 1 or ( length( $answer[ $i - 1 ][0] ) >= 1 ) ) {
                if ( $qa[2] > 0 ) {
                    $score2 =
                      sprintf( "%.0f",
                        ( $answer[ $i - 1 ][1] * 100 / $qa[2] ) );
                }
                else { $score2 = "0"; }
                $style[1] = "style='margin-left:" . ( $score2 * 2 ) . "px;'";
                $score = "$answer[$i-1][1]";
            }
            else {
                $score2   = 0;
                $style[0] = "style='display:none;'";
                $score    = "0";
            }
            if ( $i == ( $max_answer + 1 ) ) {
                $style[0] = '';
            }
            $style[3] =
qq[<input type=hidden name="answer_id_$i" value="$answer[$i-1][2]">];
        }
        else {
            if ( $i != 1 and !( length( $answer[ $i - 1 ][0] ) >= 1 ) ) {
                $style[0] = "style='display:none;'";
                $score2   = 0;
                $score    = "0";
            }
            else {
                $score    = "$qa[2]";
                $style[1] = "style='margin-left:200px;'";
                $score2   = 100;
            }
        }

        $score ||= "0";
        $conainer_answer .= $aj_print = tpl_str(
            "./tpl/test/make_quest_answer.html",
            {
                answer          => $tmp,
                n               => $i,
                score           => $score,
                score2          => $score2,
                style           => $style[0],
                style_l         => $style[1],
                answer_value_id => $style[3],
            }
        );
    }

    for ( my $i = 1 ; $i < 4 ; $i++ ) {
        if   ( $i == $qa[3] ) { $qa[21][$i] = 'checked'; }
        else                  { $qa[21][$i] = ''; }
    }

    $aj_print = tpl_str(
        "./tpl/test/make_quest.html",
        {
            questiontext => $qa[1],
            score        => $qa[2],
            penalty_qest => $qa[4],
            maxtime      => $qa[8],
            publish      => $qa[9],
            qtype1       => $qa[21][1],
            qtype2       => $qa[21][2],
            qtype3       => $qa[21][3],

            q_categories => 1, conainer_answer => $conainer_answer,
            fckeditor => ( $qa[7] ? ' checked' : '' ),
            test_quest_html => $qa[20],
            id              => $id,
            act             => $act,
            gact            => "?act=" . $act . "&sact",
            sact            => $sact,
            save            => "<div class=nav>"
              . (
                $readonly ? ''
                : qq[<div class=left><button type="submit"><dl class="ok"></dl></button></div>]
              )
              . qq[<div class=right><button type="button" onclick="location='sp.cgi?act=maketest&amp;sact=maketest_quest&amp;id=$id'" id="button_maketest_list"><dl class="cl"></dl></button></div></div>],
            save2 => ( $test_edit and !$readonly )
            ? qq[<button style="margin:6px 0 4px 0;" onClick="adel($test_edit)"><dl class="del"></dl></button>]
            : '',
        }
    );

    aj_print($aj_print);
}

sub aj_make_quest_act() {
    my $q_cat        = 1;
    my $penalty      = param('penalty');
    my $maxtime      = param('maxtime');
    my $publish      = param('publish') == 1 ? 1 : 0;
    my $score        = param('score');
    my $test_edit    = param('edit') > 0 ? param('edit') : 0;
    my $questiontext = param('questiontext');
    my $qtype        = param('qtype');
    my $fckeditor    = defined param('fckeditor') ? '1' : 'NULL';
    my ( @result, @answer_text, @answer_score, @answer_id, $tmp );

    for ( my $i = 1 ; $i <= 20 ; $i++ ) {
        $answer_text[$i] = param( 'answer_text_' . $i );
        strip_tag( \$answer_text[$i], 'html' );
        $answer_score[$i] = param( 'answer_score_' . $i );
        $answer_id[$i]    = param( 'answer_id_' . $i );
        sec_range $answer_score[$i], 0, 100;
        if ($test_edit) {
            sec_gteq0 $answer_id[$i], 1;
        }
    }
    $answer_id[0] = -1;

    sex_gteq0 $id, $score, $q_cat, $penalty;
    sec_gteq0 $test_edit, 1;
    sec_gteq0 $qtype,     1;

    if ( $score < 1 and $score > 99 ) {
        stop "          ";
    }
    if (   ( length($questiontext) < 3 )
        or ( $maxtime < 0 and $maxtime =~ /^[0-9]*([,.][0-9]+)?|[0-9]+$/ )
        or ( $penalty < 0 and $penalty > 99 )
        or ( $qtype < 0   and $qtype < 4 ) )
    {
        stop
          "          ";
    }

    $maxtime = sprintf( "%.0f", $maxtime * 60 );
    if ( $maxtime < 20 and $maxtime != 0 ) {
        stop '  " "  20 .';
    }

    strip_tag( \$questiontext, 'html' );

    if ( maketest_access($id) < 2 ) { redir "$act&sact=maketest_quest&id=$id"; }

    my $new_id =
      ($test_edit) ? $test_edit : cmsgenid( "GEN_TEST_QUESTION_LIST_ID", 1 );

    my @answers_list;
    if ($test_edit) {

        sqlffacms \@answers_list,
          "SELECT aid FROM test_question_answers WHERE qid = $new_id";
    }
    else {
        sqlcms "INSERT INTO test_question_penalty (qid, penalty, score, maxtime)
    values ($new_id, 1, 100, NULL)";
    }

    for ( my $i = 1 ; $i < 100 ; $i++ ) {
        !defined $answer_text[$i] and next;
        if ( length( $answer_text[$i] ) >= 1 ) {
            $tmp = sprintf( "%.0f", ( ( $score / 100 ) * $answer_score[$i] ) );
            $tmp = $tmp < 1 ? 'NULL' : $tmp;
            if ($test_edit) {
                if ( grep ( /^$answer_id[$i]$/, @answers_list ) ) {
                    sqlbcms
                      "UPDATE test_question_answers SET score = $tmp, answer=?
          WHERE aid = " . $answer_id[$i], $answer_text[$i];
                }
                else {
                    sqlbcms
                      "INSERT INTO test_question_answers (score, answer, qid)
          values ($tmp, ?, $new_id)", $answer_text[$i];
                }
            }
            else {
                sqlbcms "INSERT INTO test_question_answers (qid, score, answer)
        values ($new_id, $tmp, ?)", $answer_text[$i];
            }
        }
        elsif ($test_edit) {
            if ( grep ( /^$answer_id[$i]$/, @answers_list ) ) {
                sqlcms( "DELETE FROM test_question_answers WHERE aid = "
                      . $answer_id[$i] );
            }
        }
    }

    my $SQLscore = 0;
    if ($test_edit) {
        $new_id = $test_edit;

        my $tmp =
          qq[$gdate |   ] . human_hash($guid) . "\n";
        @result = sqlfcms(
            "SELECT ver, iif($qtype=3,
         (SELECT sum(score) FROM test_question_answers WHERE qid = test_question_list.qid),
         (SELECT max(score) FROM test_question_answers WHERE qid = test_question_list.qid) )
    FROM test_question_list WHERE qid = $new_id"
        );
        $tmp .= $result[0];

        $SQLscore = $qtype == 2 ? $score : $result[1];
        if ( $SQLscore < 1 ) {
            stop
"           ";
        }
        sec_gt0 $SQLscore;

        sqlbcms
"UPDATE test_question_list SET tid=$id, category=$q_cat, questiontext=?,
    qtype=$qtype, penalty=$penalty, score=$SQLscore, publish=$publish,
    maxtime=$maxtime, fck=$fckeditor, ver=? WHERE qid=$new_id", $questiontext,
          $tmp;
    }
    else {
        if ( $qtype == 1 )
        { $SQLscore =
              sqlffcms(
"SELECT max(score) FROM test_question_answers WHERE qid = $new_id"
              );
        }
        elsif ( $qtype == 2 ) {
            $SQLscore = $score;
        }
        elsif ( $qtype == 3 ) {
            $SQLscore = sqlffcms(
"SELECT sum(score) FROM test_question_answers WHERE qid = $new_id"
            );
        }
        if ( $SQLscore < 1 ) {
            stop
"           ";
        }
        sec_gt0 $SQLscore;

        sqlbcms "INSERT INTO test_question_list
    (qid, tid, category, questiontext, qtype, penalty, author, score, publish, stamp, maxtime, fck)
    values ($new_id, $id, $q_cat, ?, $qtype, $penalty, $guid, $SQLscore, $publish, 'NOW', $maxtime, $fckeditor)",
          $questiontext;
    }

    redir $act. "&sact=maketest_quest&id=$id&answer=$new_id";
}

sub aj_maketest_activate() {
    my $id = param('id');
    sec_gteq0 $id;

    $q = sqlffcms "SELECT status FROM test_test WHERE id = $id";

    if ( maketest_access($id) > 1 ) {
        if ( 0 < sqlffcms
"SELECT count(qid) FROM test_question_list AS q WHERE tid = $id AND qtype != 2 AND penalty = 1 AND NOT EXISTS (SELECT 1 FROM test_question_answers AS a WHERE a.qid = q.qid and a.score > 0)"
          )
        {
            aj_print("$q,$id");
        }
        $q = $q == 1 ? 0 : 1;
        sqlcms "UPDATE test_test SET status = $q WHERE id=$id";
    }
    aj_print("$q,$id");
}

sub aj_maketest_locint() {
    my $id = param('id');
    sec_gteq0 $id;

    $q = sqlffcms "SELECT loc FROM test_test WHERE id = $id";
    $q += 0;

    if ( maketest_access($id) > 1 ) {
        $q = $q == 1 ? 0 : 1;
        sqlcms "UPDATE test_test SET loc = $q WHERE id=$id";
    }
    aj_print("$q,$id");
}

sub make_quest_copy() {
    my $qid = param('qid');
    my $tid = param('tid');
    sec_gteq0($tid);
    sec_gteq0($qid);

    my ( @result, $ver, @a, @qa );

    @qa = sqlfcms
"SELECT tid, category, questiontext, qtype, penalty, maxtime, matteranswer, author FROM test_question_list WHERE qid = $qid";

    if ( $qa[0] < 0 ) {
        redir $act. "&sact=maketest_quest&id=$tid&mesg=no_quest";
    }

    my @test = sqlfcms "SELECT name FROM test_test WHERE id = $qa[0]";
    $ver =
      qq[$gdate |     "$test[0]" (ID $qa[0]),  ]
      . human_hash( $qa[7] );

    my $new_id = cmsgenid( "GEN_TEST_QUESTION_LIST_ID", 1 );

    sqlbcms "INSERT INTO test_question_list
  (qid, tid, category, questiontext, qtype, penalty, author, sorts, publish, stamp, maxtime, matteranswer, ver)
  values ($new_id, $tid, $qa[1], ?, $qa[3], $qa[4], $guid, NULL, 1, 'NOW', $qa[5], ?, ?)",
      $qa[2], $qa[6], $ver;

    $q = sqlpcms
      "SELECT score, answer FROM test_question_answers WHERE qid = $qid";
    while ( @result = $q->fetchrow_array() ) {
        push @a, [@result];
    }
    for (@a) {
        $$_[0] = ( $$_[0] > 0 && defined $$_[0] ) ? $$_[0] : 'NULL';
        sqlcms "INSERT INTO test_question_answers (qid, score, answer)
    values ($new_id, $$_[0], '$$_[1]')";
    }

    @a = ();
    $q = sqlpcms
"SELECT penalty, score, maxtime FROM test_question_penalty WHERE qid = $qid";
    while ( @result = $q->fetchrow_array() ) {
        push @a, [@result];
    }
    for (@a) {
        $$_[1] = ( $$_[1] > 0 && defined $$_[1] ) ? $$_[1] : 'NULL';
        $$_[2] = ( $$_[2] > 0 && defined $$_[2] ) ? $$_[2] : 'NULL';
        sqlcms "INSERT INTO test_question_penalty (qid, penalty, score, maxtime)
    values ($new_id, $$_[0], $$_[1], $$_[2])";
    }

    redir $act. "&sact=maketest_quest&id=$tid&answer=$new_id";
}

sub test_answer_check {
    my ( $id, $tid, @penalty_score, $KeyExe, @qa, @result );
    $id     = shift;
    $tid    = shift;
    $KeyExe = shift;

    @qa = sqlfcms
      "SELECT 1, qtype, uid, maxtime, qid, penaltyout, startu, penalty FROM
  (SELECT qid, publish, tid, qtype, penalty, maxtime,
    (SELECT max(penalty) FROM test_users_answers ai WHERE ai.eid = $id) AS penaltyout,
    (SELECT id FROM test_users_answers ic WHERE ic.eid = $id AND ic.date_stop is null AND ic.answers = '$KeyExe' AND ic.qid = q.qid) AS uid,
    (SELECT date_start FROM test_users_answers si WHERE si.eid = $id AND si.date_stop is null AND si.qid = q.qid AND si.answers = '$KeyExe') AS startu
    FROM test_question_list q) answ
    WHERE answ.publish = 1 AND
  answ.tid = $tid AND answ.uid IS NOT NULL AND
  (answ.penalty >= answ.penaltyout OR (answ.penaltyout IS NULL)) AND
  NOT EXISTS (SELECT 1 FROM test_users_answers a WHERE a.qid = answ.qid AND a.eid = $id AND a.incor = 3)",
      { ib_timestampformat => "%s" };

    if (@qa) {
        if ( !defined $qa[5] )
        { @penalty_score =
              sqlfcms "SELECT FIRST 1 score, maxtime
        FROM test_question_penalty WHERE qid = $qa[4] ORDER BY penalty ASC";
        }
        else { @penalty_score = sqlfcms "SELECT score, maxtime
        FROM test_question_penalty WHERE qid = $qa[4] and penalty = $qa[7]";
        }
        if ( !$penalty_score[0] ) {
            @penalty_score = sqlfcms "SELECT min(score),null
        FROM test_question_penalty WHERE qid = $qa[4]";
        }
        if ( !$penalty_score[0] ) {
            @penalty_score = ( 100, undef );
        }

        if ( $qa[3] > 0 ) {
            if ( not defined $penalty_score[1] || $penalty_score[1] < 0 ) {
                $penalty_score[1] = $qa[3];
            }
            $penalty_score[1] *= 60;

            if ( $qa[6] + $penalty_score[1] - 10 <= time ) { $qa[0] = 0;
            }
        }
    }

    if ( $qa[0] == 1 && ( defined $qa[2] ) ) {

        if ( $qa[1] == 1 ) {
            my $answer = sec_gteq0( substr( param('answer'), 0, 64 ) );
            $qa[7] = sqlffcms
              "SELECT score FROM test_question_answers WHERE aid = '$answer'";

            $qa[7] ||= 0;

            if ( $penalty_score[0] > 0 || !defined $penalty_score[0] ) {
                $qa[7] = $qa[7] * $penalty_score[0] / 100;
            }
            $qa[7] *= 1;

            my $incor = $qa[7] > 0 ? 2 : 1;
            sqlbcms
"UPDATE test_users_answers SET date_stop='now', incor=$incor, answers=? WHERE id = $qa[2]",
              $answer;
        }

        elsif ( $qa[1] == 2 || $qa[1] == 3 ) {
            my (
                %answer,      @answer_user, $incor_user,
                $incor_score, $incor_pset,  $tmp
            );
            $incor_pset = $incor_user = $incor_score = 0;
            $q = sqlpcms
              "SELECT aid, score FROM test_question_answers WHERE qid = $qa[4]";
            while ( @result = $q->fetchrow_array() ) {
                if ( $penalty_score[0] > 0 || !defined $penalty_score[0] ) {
                    $result[1] = $result[1] * $penalty_score[0] / 100;
                }
                $result[1] *= 1;

                $tmp = ( param( 'answer_' . $result[0] ) ) ? 1 : 0;

                if ($tmp) { push @answer_user, $result[0]; }

                if ( $result[1] >= 1 ) {
                    $incor_pset++;
                } if ( $result[1] >= 1 and $tmp ) {
                    $incor_user++;
                } elsif ($tmp) {
                    $incor_user--;
                }
            }

            my $incor;
            if ( $qa[1] == 2 ) {
                $incor = (
                         ( $incor_pset == 0 and $incor_user == 0 )
                      or ( $incor_pset > 0  and $incor_user > 0 )
                ) ? 2 : 1;
            }
            else {
                $incor = ( $incor_pset == $incor_user ) ? 2 : 1;
            }

            my $aid = join ',', @answer_user;
            sqlbcms
"UPDATE test_users_answers SET date_stop='now', incor=$incor, answers=? WHERE id = $qa[2]",
              $aid;
        }

    }

    return 1;
}

sub test_calc_and_cache {
    my (
        $id,        $tid,       $tMaketest,  $TotalScore,
        $scoreUser, $scoreMax,  $i,          $FullScoreUser,
        @PM,        $qestNotEs, $Caches_Exe, $date_stop,
        $SQL,       @a,         @result
    );
    $id        = shift;
    $tid       = shift;
    $tMaketest = shift || '';

    if ( not defined $tid ) {
        $tid = sqlfcms "SELECT tid FROM test_users_execution WHERE id = $id";
    }

    $scoreUser = $scoreMax = $qestNotEs = 0;
    $Caches_Exe = '';
    $date_stop  = "'now'";
    $SQL        = '';

    my $count_quest_num =
      sqlffcms "SELECT answer_num FROM test_test WHERE id = $tid";
    if ($count_quest_num) {
        my @question;
        sqlffacms( \@question,
            "SELECT qid FROM test_users_answers WHERE eid = $id" );
        $SQL = "and l.qid IN(" . join( ',', @question ) . ")";
    }

    $q = sqlpcms "SELECT qid, qtype, penalty, score,
	(SELECT first 1 answers FROM test_users_answers WHERE eid = $id AND qid = l.qid ORDER BY penalty DESC),
	(SELECT first 1 incor FROM test_users_answers WHERE eid = $id AND qid = l.qid ORDER BY penalty DESC)
	FROM test_question_list l WHERE l.publish = 1 and l.tid = $tid $SQL";
    while ( @result = $q->fetchrow_array() ) {
        push @a, [@result];
    }

    for (@a) {
        $$_[4] = trim( $$_[4] );
        unless ( defined $$_[4] ) { $$_[4] = -1 }
        elsif ( $$_[4] =~ m/^\d+\|\d+$/ ) { $$_[4] = -1 }

        my $penalty_user = sqlffcms
"SELECT max(penalty) FROM test_users_answers WHERE eid = $id AND qid = $$_[0]";

        my @penalty_score;
        if ($penalty_user) {
            @penalty_score = sqlfcms
"SELECT score, maxtime FROM test_question_penalty WHERE qid = $$_[0] and penalty = $penalty_user";
            unless (@penalty_score) {
                @penalty_score = sqlfcms
"SELECT min(score), null FROM test_question_penalty WHERE qid = $$_[0]";
            }
        }
        else {
            @penalty_score = ( undef, undef );
            $qestNotEs++;
        }

        if ( $$_[2] >= $penalty_user and ( $$_[1] == 1 ) ) {
            $scoreMax += $$_[3];

            my $answersUser = sqlffcms
              "SELECT score FROM test_question_answers WHERE aid='$$_[4]'";

            !defined $answersUser and $answersUser = 0;
            if ( defined $penalty_score[0] && $penalty_score[0] > 0 ) {
                $answersUser = ( $answersUser * $penalty_score[0] / 100 );
            }
            $scoreUser += $answersUser;
        }

        elsif ( $$_[2] >= $penalty_user and ( $$_[1] == 2 or $$_[1] == 3 ) ) {
            my ( $incor, $incor_pset, $incor_user, @answer_score );
            $incor = $incor_pset = $incor_user = 0;
            my @aUserAnswers = split( /,/, $$_[4] );

            $q = sqlpcms
"SELECT aid, score FROM test_question_answers WHERE qid = $$_[0] ORDER BY score DESC";
            while ( @result = $q->fetchrow_array() ) {
                $result[1] += 0;

                $scoreMax += $result[1];

                my $tmp = grep ( /^\Q$result[0]\E$/, @aUserAnswers );

                if ( $result[1] >= 1 ) { $incor_pset++; }
                if ( $result[1] >= 1 and $tmp ) { $incor_user++; }
                elsif ($tmp) { $incor_user--; }

                push @answer_score, $result[1];
            }

            my ( $answer_score_sum, $answersUser );
            if ( $$_[1] == 2 and $$_[5] != 0 ) {
                if ( $incor_pset == $incor_user ) {
                    $answersUser = $$_[3];
                }
                else {
                    for ( $i = 0 ; $i < $incor_user ; $i++ ) {
                        $answersUser += $answer_score[$i];
                    }
                }
            }
            elsif ( $$_[1] == 3 ) {
                if ( $incor_user >= $incor_pset ) {
                    $answersUser = $$_[3];
                }
            }

            !defined $answersUser and $answersUser = 0;
            if ( defined $penalty_score[0] && $penalty_score[0] > 0 ) {
                $answersUser = ( $answersUser * $penalty_score[0] / 100 );
            }
            $scoreUser += $answersUser;
        }
    }

    $Caches_Exe .=
      'answer|'
      . ( sqlffcms
"SELECT count(id) FROM test_users_answers WHERE eid = $id AND incor = 2"
      )
      . '/'
      . ( scalar @a ) . "\n";

    if ($qestNotEs) {
        $date_stop =
"(SELECT iif ((ues + (qmt/86400.000000000)) > uam, (ues + (qmt/86400.000000000)), uam)
      from ( SELECT
        ( SELECT max(ua.date_start) FROM test_users_answers as ua WHERE ua.eid = $id ) as uam,
        ( SELECT DATE_START FROM test_users_execution WHERE id = $id ) as ues,
        ( SELECT maxtime FROM test_question_list as ql LEFT JOIN test_users_answers as ua ON ql.qid = ua.qid and ua.eid = $id
        WHERE publish = 1 and tid = 5 and date_start is not null and date_stop is null) as qmt
      from dual ))";

        my $tmp = sqlffcms
"SELECT id FROM test_users_answers WHERE eid = $id and date_start is not null and date_stop is null";
        $Caches_Exe .=
          'testEsc|' . ( ( scalar @a ) - $qestNotEs ) . '/' . $tmp . "\n";
    }

    if ( $scoreMax < 1 ) { $scoreMax = 1; }

    my $tmp = sqlffcms "SELECT passmark FROM test_test WHERE id = $tid";
    my @PassMark;
    @PM = split /\|/, $tmp;
    for (@PM) {
        push @PassMark, [ split /=/, $_ ];
    }

    $TotalScore = 1;
    $FullScoreUser = sprintf( "%.0f", ( $scoreUser * 100 / $scoreMax ) );
    for ( $i = $gconf{score_min} ; $i <= $gconf{score_max} ; $i++ ) {
        if ( $i == $gconf{score_max} ) { $PassMark[ $i - 1 ][2] = 100; }
        else { $PassMark[ $i - 1 ][2] = $PassMark[$i][1]; }
        if (    $PassMark[ $i - 1 ][1] < $FullScoreUser
            and $FullScoreUser <= $PassMark[ $i - 1 ][2] )
        {
            $TotalScore = $PassMark[ $i - 1 ][0];
        };
    }

    $Caches_Exe .= qq[ball|$scoreUser/$scoreMax\n];

    $date_stop = defined param('score') ? '' : "date_stop=$date_stop,";
    sqlcms
"UPDATE test_users_execution SET $date_stop score='$TotalScore',caches='$Caches_Exe' WHERE id = $id";
    sqlcms
"UPDATE test_users_answers SET answers=null, answers_txt=null WHERE eid = $id AND incor = 0";

    if ( $tMaketest ne 'go' ) {
        redir "$act&sact=totalsscore&id=$id";
    }
}

sub maketest_access {
    my $id  = shift;
    my $uid = shift;
    my ( $access, @qa );
    sec_gteq0( $id, 1 );

    if ( isadmin() ) {
        return 2;
    }

    if ( not defined $uid ) {
        if ( not defined $id ) {
            redir "maketest";
        } @qa = sqlfcms
"SELECT (SELECT status FROM test_access_teacher WHERE uid = $guid AND tid = test_test.id),
    autor FROM test_test WHERE id = $id";
    }
    else {
        @qa = ( $id, $uid );
    }

    if ( $qa[1] == 0 and $ggid == 2 ) {
        $access = $SET{'a_teacher_systest'};
    }
    else {
        $access = 0;
        if ( ( ( $qa[1] == $guid ) or ( $qa[1] != $guid && $qa[0] == 2 ) )
            && defined $qa[1] )
        {
            $access = '2';
        }
        elsif ( $qa[1] != $guid && $qa[0] == 1 && defined $qa[1] ) {
            $access = '1';
        }
    }
    return $access;
}

sub access_test_islocale($) {
    if ( shift() ) {
        my $ip = $ENV{'REMOTE_ADDR'};
        $ip =~ s/'//g;
        if ( $ip =~
m/^127\.\d+\.\d+\.\d+$|10\.\d+\.\d+\.\d+$|192\.168\.\d+\.\d+$|172\.16\.\d+\.\d+$|169\.254\.\d+\.\d+$/
          )
        {
            return 1;
        }
        else {
            return 0;
        }
    }
    return 1;
}

sub rus2obfuskator($) {
    my $a = shift;

    my %replace = (
        '', 'a', '', 'A', '', 'e', '', 'E', '', 'o', '', 'O',
        '', 'c', '', 'C', '', 'x', '', 'X', '', 'H', '', 'K',
        '', 'B', '', 'P', '', 'T', '', 'M',
    );

    my $r;
    for ( my $i = 0 ; $i < length($a) ; $i++ ) {
        $r = int rand 3;
        unless ($r) {
            if ( substr( $$a, $i, 1 ) =~ /[]/o ) {
                substr( $$a, $i, 1 ) = $replace{ substr( $$a, $i, 1 ) };
            }
        }
    }

    return $$a;
}

sub checks_access {
    my $tid     = shift;
    my $no_date = shift;

    unless ( $no_date and isadmin() ) {
        $no_date =
          q[ AND (cast('NOW' as TIMESTAMP) between date_start and date_stop ) or
      (cast('NOW' AS TIMESTAMP) > date_start AND date_stop IS NULL) ];
    }
    else { $no_date = ''; }

    my ( $SQL, @result );
    $SQL = "AND atype != 10$no_date AND ( (atype = 4 AND afor = $guid)";

    if ( $ggid == 4 ) {
        $q = sqlp(
"SELECT sp_class_subgrp_ref.id FROM sp_class_subgrp, sp_class_subgrp_ref
    WHERE sp_class_subgrp.id = sp_class_subgrp_ref.id AND sp_class_subgrp.uid = $guid"
        );
        while ( @result = $q->fetchrow_array() ) {
            $SQL .= "or (atype = 3 and afor = $result[0])";
        }

        my $class_id = get_pupil_class(0);
        $SQL .= "or (atype = 2 and afor = $class_id)";

        my $paralel = sqlff(
"SELECT paralel FROM sys_matrix WHERE class = $class_id AND sys_matrix.view_class = 7
    AND exists ( select 1 from get_node_saldo (sys_matrix.node_id, 'NOW', 0) where saldo_sum <> 0)"
        );
        $SQL .= "or (atype = 1 and afor = $paralel) )";
    }
    elsif ( isadmin() ) {
        $SQL = '';
    }
    else {
        $SQL .= "or (atype = 5 AND afor = $ggid) )";
    }

    my $q = sqlpcms "SELECT DISTINCT tid, date_start, date_stop FROM test_access
  WHERE tid = $tid AND publish = 1 $SQL", { ib_timestampformat => '%d.%m.%Y' };
    my %tid_a;
    while ( @result = $q->fetchrow_array() ) {
        $tid_a{ $result[0] } = [ $result[1], $result[2] ];
    }

    undef $SQL;
    for ( keys %tid_a ) {
        $SQL .= ($SQL) ? ",$_" : $_;
    }
    $SQL = ($SQL) ? "id in ($SQL)" : '';
    if ( !isadmin() ) {
        $SQL .= ' AND status = 1';
    } my @ChecksAccess =
      sqlfcms "SELECT id, name, penalty_test, maxtime, annotation, null, null
    FROM test_test WHERE $SQL";

    return @ChecksAccess;
}

our $quest_cat;
sub quest_sub_cat($$);

sub quest_sub_cat($$) {
    my $c_id = shift || 0;
    my $str  = shift || '';
    my $sub_cat;
    $sub_cat = '';
    $str .= '&nbsp;&nbsp;&nbsp;&nbsp;';
    for ( @{$quest_cat} ) {
        if ( $$_[1] == $c_id ) {
            $sub_cat .=
              qq[<option value="$$_[0]">$str|&mdash; $$_[2]</option>\n];
            $sub_cat .= quest_sub_cat( $$_[0], $str );
        }
    }
    return $sub_cat;
}

sub quest_cat($$) {
    $quest_cat = shift;
    my $sel_cat = shift;
    my $tmp     = '';

    for ( @{$quest_cat} ) {
        if ( not defined $$_[1] or $$_[1] == 0 ) {
            $tmp .= qq[<option value="$$_[0]">$$_[2]</option>\n];
            $tmp .= quest_sub_cat( $$_[0], '' );
        }
    }

    return $tmp;
}

sub paralel_h() {
    my ( %paralel, %paralel2, @result );
    $q = sqlp "SELECT class, paralel FROM sys_matrix
    WHERE view_class = 7 AND exists ( SELECT 1 from get_node_saldo
    (sys_matrix.node_id, '$gdate', 0) WHERE saldo_sum <> 0 )
    ORDER BY CAST(class as integer)";
    while ( @result = $q->fetchrow_array() ) {
        $paralel2{ $result[0] } = $result[1];

        if ( defined $paralel{ $result[1] } ) {
            push @{ $paralel{ $result[1] } }, $result[0];
        }
        else {
            $paralel{ $result[1] } = [ $result[0] ];
        }
    }
    return \%paralel, \%paralel2;
}

sub pupil_h() {
    my ( %pupils, %pupils2, @result );
    $q = sqlp "SELECT vw_pupil, sys_matrix.class
   FROM sys_matrix inner join human on cast(vw_pupil as integer) = human_id
   WHERE sys_matrix.view_class = 1 AND EXISTS (
    SELECT 1 FROM get_node_saldo(sys_matrix.node_id, '$gdate', 0)
    WHERE saldo_sum <> 0 )";
    while ( @result = $q->fetchrow_array() ) {
        $pupils2{ $result[0] } = $result[1];

        if ( defined $pupils{ $result[1] } ) {
            push @{ $pupils{ $result[1] } }, $result[0];
        }
        else {
            $pupils{ $result[1] } = [ $result[0] ];
        }

    }
    return \%pupils, \%pupils2;
}

sub mesg {
    my $body_errer = '';
    my $mesg       = param('mesg') || '';
    my $e          = q[<dl class="worn"></dl>];
    my $s =
q[<img src="/sp/img/forbidden.gif" width="25" height="25" border="0" align="absmiddle">&nbsp;];
    my $f =
q[<img src="/sp/img/stop.gif" width="56" height="50" border="0" align="absmiddle">&nbsp;];
    my $fe =
q[<img src="/sp/img/danger.gif" width="40" height="39" border="0" align="absmiddle">&nbsp;];
    if ( $mesg ne "" ) {
        $body_errer =
q[<div align='center' style='border-bottom: 1px dotted #2F4F4F;margin: 0 80px;padding: 5px 70px 10px 30px;'><font color='red'><b>];
        if ( $mesg eq 'ban' ) {
            $body_errer .= "$e  ";
        }
        elsif ( $mesg eq 'errorqt' ) {
            $body_errer .= "$fe     ";
        }
        elsif ( $mesg eq 'errorend' ) {
            $body_errer .= "$e     ";
        }
        elsif ( $mesg eq 'noexec' ) {
            $body_errer .= "$e     ";
        }
        $body_errer .= q[</b></font></div><br>];
    }

    return $body_errer;
}

sub CacheStr ($$) {
    my @a;
    @a = split( /\n/, shift() || '' );
    my $sr = shift;
    my @b;
    for (@a) {
        @b = split( /\|/, $_ );
        if ( $b[0] eq $sr ) {
            $b[1] =~ s/(\s)//g;
            return $b[1];
        }
    }
}

sub test_maxtime($) {
    return sqlffcms
"SELECT sum(maxtime) FROM test_question_list WHERE publish = 1 and tid = $_[0]";
}

sub test_export {
    my (
        %hash,         $href,   %out,       $idt,      @annotation,
        %annotation_r, $caches, $file_name, $file_ext, @result
    );
    $idt = param('id');
    my $hostmy = $ENV{'SERVER_NAME'};
    if ( $idt !~ m/^\d+$/ or $idt < 0 or $idt > 4294967295 ) { exit; }
    use Digest::MD5 qw(md5_hex);

    $q    = sqlpcms "SELECT * FROM test_test WHERE id = $idt";
    $href = $q->fetchrow_hashref;
    $q->finish();
    delete $$href{id};

    my $spath = $gconf{'sppath'};
    @annotation = $$href{annotation} =~ m/<img .*?src=["'](.+?)["'].*?>/sig;
    push @annotation,
      $$href{annotation} =~ m!<a .*?href=["'](.+?)["'].*?>.*?</a>!sig;
    for (@annotation) {
        $caches = $_;
        if (    $_ !~ m!(https?|ftp)(://\Q$hostmy\E)!i
            and $_ =~ m!(https?|ftp)(://)!i )
        {
            next;
        }
        elsif ( $_ =~ m!(https?|ftp)(://\Q$hostmy\E)!i ) {
            $_ =~ s!(https?|ftp)(://\Q$hostmy\E(/sp)?)!!ig;
        }
        else {
            $_ =~ s!^/sp!!ig;
        }

        print Fo "\n$spath$_\n";

        unless ( $$href{media}{ $spath . $_ } ) {
            unless ( -e $spath . $_ ) { next; }

            print Fo "   - \n";

            open F, $spath . $_;
            binmode F;
            my ( $data, $n );

            my @a = split( /\//, $_ );
            my $tmp = @a;
            $_ = $a[ $tmp - 1 ];

            $_ =~ m/([-A-Z0-9+@#%=~_|.\[\]()]*)(\.\w+)$/im;
            $file_name = $1;
            $file_ext  = $2;

            $$href{annotation} =~ s/(=["']?)\Q$caches\E/$1$$href{autor}\/$_/ig;

            while ( ( $n = read F, $data, 4096 ) != 0 ) {
                $$href{media}{ $$href{autor} . '/' . $_ } .= ' ';
            }
            close(F);
        }
    }
    $out{test} = $href;

    $q = sqlpcms "SELECT * FROM test_question_list WHERE tid = $idt";
    $out{question_tmp} = $q->fetchall_hashref('qid');
    $q->finish();
    my $qid = join( ',', keys %{ $out{question_tmp} } );
    $qid = ( $qid != '' ) ? "qid IN ($qid)" : '1=2';

    $q =
      sqlpcms "SELECT qid,score,answer FROM test_question_answers WHERE $qid";
    while ( @result = $q->fetchrow_array() ) {
        push @{ $out{answers}{ $result[0] } }, [ (@result)[ 1 .. 2 ] ];
    }
    $q->finish();

    for ( keys %{ $out{question_tmp} } ) {
        my %tmp = %{ $out{question_tmp}{$_} };
        delete $tmp{tid};
        delete $tmp{qid};

        push @{ $tmp{answers} },
          @{ $out{answers}{ $out{question_tmp}{$_}{qid} } };
        push @{ $out{questions} }, \%tmp;
    }

    delete $out{question_tmp};
    delete $out{answers};

    dmp \%out;
}

1;
